#*************************************************************************
#              ROCKWELL CONFIDENTIAL AND PROPRIETARY
#        This source is the sole property of ROCKWELL Inc.
#    Reproduction or utilization of this source in whole or in 
#  part is forbidden without the written consent of ROCKWELL Inc.
#*************************************************************************
#                 (c) Copyright ROCKWELL, INC. 1991
#                       All Rights Reserved
#*************************************************************************
#

# 
#       Last update:   11-14-91
#	Last PVCS update: $Date:   07 Sep 1992 15:43:18  $ 
#

#
#	TITLE:	
#
#	FACILITY: 
#
#	MODULE DESCRIPTION:
#
#	
#

#
#	API DOS Makefile for PolyMake or Nmake.
#

LINKFILE=bld.lnk

C51=-DFASTCALL=_pascal -DFAR= -DPASCAL=_pascal
C60=-DFASTCALL=_fastcall -DFAR=_far -DPASCAL=_pascal

CV=
OB=.\\dosobjs\\

# C5.1, small model
#CRFLAGS	=-W3 -c $(C51) -Osal -Gs -AS -Fo$*
#CLFLAGS	=/c /W3 /DFF_TSR /DFF_API /Gs /Osa /Zipe /AS /Fo$*
#MFLAGS	=/W2 /Zi
#APILIB = SRAPI
#FAPILIB = SRFAPI
#LNKLBRS= $(APILIB).LIB $(FAPILIB).LIB FFTSR.LIB SLIBCE.LIB

# C5.1, medium model
#CRFLAGS	=-W3 -c $(C51) -Osal -Gs -AM -NTFAPI -Fo$*
#CLFLAGS	=/c /W3 /DFF_TSR /DFF_API /Gs /Osa /Zipe /AM /NTFAPI /Fo$*
#MFLAGS	=/W2 /Zi /Dmem_m /DNT=FAPI
#APILIB = MRFAPI
#FAPILIB = MRFAPI
#VAPILIB = MRVAPI
#LNKLBRS= $(APILIB).LIB $(FAPILIB).LIB FFTSR.LIB SLIBCE.LIB

# C6.0, small model
#CRFLAGS	=-W3 -c /Zi $(C60) -Osleazr -Gs -AS -Fo$*
#CLFLAGS	=/c /Zi /W3 /DFF_TSR /DFF_API /Gs /Osleazr /Zpe /AS /Fo$*
#MFLAGS	=/W2 /Zi /DFASTCALL
#APILIB = SRAPI
#FAPILIB = SRFAPI
#VAPILIB = SRVAPI
#VRIFLIB = SRVRIF
#LNKLBRS= $(APILIB).LIB $(FAPILIB).LIB FFTSR.LIB SLIBCE.LIB SRIFFILE.LIB

# C6.0, medium model
CRFLAGS	=-W3 -c $(C60) -Osleazr  -Gs -AM -NTFAPI -Fo$*
CVFLAGS	=-W3 -c $(C60) -Od -Gs -AM -NTVAPI -Fo$*
#CLFLAGS	=/c /W3 -DFAR=  -DPASCAL= /Gs /Od /Zpe /AM /NTFAPI /Fo$*
CLFLAGS	=/c /W3 /DFF_TSR /DFF_API /Gs /Osleazr /Zpe /AM /NTFAPI /Fo$*
MFLAGS	=/W2 /DFASTCALL /Dmem_m /DNT=FAPI
ZAPILIB = MRZAPI
FAPILIB = MRFAPI
VAPILIB = MRVAPI
VRIFLIB = MRVRIF
LNKLBRSVAPI = $(ZAPILIB).LIB $(VAPILIB).LIB $(VRIFLIB).LIB MLIBCE.LIB 

#
#	Define the list of object files.
#

###########################
# VAPI
###########################

all : example1.exe example2.exe example4.exe 

example1 : example1.exe

example1.exe :	$(OB)example1.obj $(OB)vcallbke.obj \
                $(OB)vapisess.obj $(OB)vapidspl.obj 
	@echo $(OB)example1.obj +> $(LINKFILE)
	@echo $(OB)vcallbke.obj +>> $(LINKFILE)
	@echo $(OB)vapisess.obj +>> $(LINKFILE)
	@echo $(OB)vapidspl.obj  >> $(LINKFILE)
        @type $(LINKFILE) > example1.lnk
	@echo Current LINK environment is $(LINK)
	link /NOE /MAP @$(LINKFILE),example1,example1,$(LNKLBRSVAPI);

example2 : example2.exe

example2.exe :	$(OB)example2.obj $(OB)vcallbke.obj  \
                $(OB)vapisess.obj $(OB)vapidspl.obj 
	@echo $(OB)example2.obj +> $(LINKFILE)
	@echo $(OB)vcallbke.obj +>> $(LINKFILE)
	@echo $(OB)vapisess.obj +>> $(LINKFILE)
	@echo $(OB)vapidspl.obj  >> $(LINKFILE)
	@echo Current LINK environment is $(LINK)
        @type $(LINKFILE) > example2.lnk
	link /NOE /MAP @$(LINKFILE),example2,example2,$(LNKLBRSVAPI);

example4 : example4.exe

example4.exe :	$(OB)example4.obj $(OB)vcallbke.obj  \
                $(OB)vapisess.obj $(OB)vapidspl.obj 
	@echo $(OB)example4.obj +> $(LINKFILE)
	@echo $(OB)vcallbke.obj +>> $(LINKFILE)
	@echo $(OB)vapisess.obj +>> $(LINKFILE)
	@echo $(OB)vapidspl.obj  >> $(LINKFILE)
	@echo Current LINK environment is $(LINK)
        @type $(LINKFILE) > example4.lnk
	link /NOE /MAP @$(LINKFILE),example4,example4,$(LNKLBRSVAPI);

###########################
# Test Harness Routines
###########################

$(OB)example1.obj:	example1.c example.h  zapi.h  zapidos.h 
	cl $(CVFLAGS) $(CV) -DVF_DOS example1.c

$(OB)example2.obj:	example2.c example.h  zapi.h  zapidos.h 
	cl $(CVFLAGS) $(CV) -DVF_DOS example2.c

$(OB)example4.obj:	example4.c example.h  zapi.h  zapidos.h 
	cl $(CVFLAGS) $(CV) -DVF_DOS example4.c

$(OB)vapisess.obj:	vapisess.c  zapi.h  zapidos.h fapi.h
	cl $(CRFLAGS) $(CV) vapisess.c

$(OB)vapidspl.obj:	vapidspl.c   zapidos.h fapi.h
	cl $(CRFLAGS) $(CV) vapidspl.c

$(OB)vcallbke.obj:	vcallbke.c  vapi.h example.h
	cl $(CVFLAGS) $(CV) -DVF_DOS vcallbke.c


