/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/*
**      Last PVCS update: $Date:   07 Sep 1992 15:43:24  $
*/

/*
**      TITLE:          EXAMPLE.H
**
**      FACILITY:       
**
**      MODULE DESCRIPTION:
**
**      Include File for VAPI Example Code 
**
*/

/*
**
**      Revision History:
**
**              $Log:   D:/api_lib/example.h_v  $
   
      Rev 1.1   07 Sep 1992 15:43:24   Robert Chen
    
   
      Rev 1.0   12 Aug 1992 20:05:16   Robert Chen
   Initial revision.
   
      Rev 1.3   02 Jul 1992  9:43:00   Robert Chen
    
   
      Rev 1.2   24 Jun 1992 16:02:30   Robert Chen
    
**      Rev 1.1   04 Jun 1992 13:57:04   Robert Chen
**   Call Discrimination 00
**   
**      Rev 1.0   26 May 1992 11:19:30   Robert Chen
**   Initial revision.
** 
**
***************************************************************************/


#define TRUE 1
#define FALSE 0
#define USR_TELCO       0
#define USR_HANDSET     1
#define USR_SPEAKER     2
#define USR_MICROPHONE  3
#define USR_HANDSPEAKER 4

//********************************
// Defined DLE codes:
//********************************

#define DLE        0x10
#define DLE_PAUSE  0x70
#define DLE_RESUME 0x72
#define DLE_CANCEL 0x18
#define DLE_XON    0x11
#define DLE_XOFF   0x13

//********************************
// Defined keyboard codes:
//********************************
#define CHAR_LC_U  'u'
#define CHAR_UC_U  'U'
#define CHAR_LC_S  'S'
#define CHAR_UC_S  's'
#define CHAR_LC_Q  'Q'
#define CHAR_UC_Q  'q'
#define CHAR_LC_P  0x70
#define CHAR_UC_P  0x50
#define CHAR_LC_R  0x72
#define CHAR_UC_R  0x52
#define CHAR_LC_C  0x63
#define CHAR_UC_C  0x43

//*************************************************************************
//  a short hand for all digit case statement
//************************************************************************
#define ALL_DIGITS        '0': \
                     case '1': \
                     case '2': \
                     case '3': \
                     case '4': \
                     case '5': \
                     case '6': \
                     case '7': \
                     case '8': \
                     case '9' 
                     

//********************************
// States in user's voice state machine
//********************************
enum USR_VOICE_STATE
{
       USR_STA_01,
       USR_STA_02,
       USR_STA_AUTOANSWER_01,             
       USR_STA_AUTOANSWER_02,
       USR_STA_GET_SETTING_01,    
       USR_STA_GET_SETTING_02,
       USR_STA_SET_SETTING_01,    
       USR_STA_SET_SETTING_02,
       USR_STA_SET_VM_BAUD_01,
       USR_STA_SET_VM_BAUD_02,            
       USR_STA_VOICE_COMMAND,
       USR_STA_VOICE_SUPER_COMMAND,
       USR_STA_VOICE_ONLINE_01,              
       USR_STA_VOICE_ONLINE_02,              
       USR_STA_PLAY_GREETMSG_01,
       USR_STA_PLAY_GREETMSG_02,
       USR_STA_PLAY_GREETMSG_03,
       USR_STA_REC_MSG_01,
       USR_STA_REC_MSG_02,
       USR_STA_REC_MSG_03,
       USR_STA_PLAY_RECMSG_01,
       USR_STA_PLAY_RECMSG_02,
       USR_STA_PLAY_ALL_RECMSG_01,
       USR_STA_PLAY_ALL_RECMSG_02,
       USR_STA_PLAY_ALL_RECMSG_03,
       USR_STA_PLAY_ALL_RECMSG_04,
       USR_STA_PASSWORD_01,
       USR_STA_PASSWORD_02,
       USR_STA_DATA_FAX_01,
       USR_STA_DATA_FAX_02,
       USR_STA_VOICE_TO_FAX_01,
       USR_STA_VOICE_TO_FAX_02,
       USR_STA_FAX,
       USR_STA_DATA,
       USR_STA_VOICE_CONFIG_01,
       USR_STA_VOICE_CONFIG_02,
       USR_STA_VOICE_CONFIG_03,
       USR_STA_VOICE_CONFIG_04,
       USR_STA_HANGUP,
       USR_STA_LAST                      
};

//********************************
// States in user's fax state machine
//********************************
enum USR_FAX_STATE
{
      USR_STA_FAX_INIT,
      USR_STA_FAX_01,
      USR_STA_FAX_02,
      USR_STA_FAX_IN_PROGRESS,
      USR_STA_FAX_LAST
};

// --------------------------------------------------------------------------
// Temporary modifications until RVStatus enhancement:
// --------------------------------------------------------------------------

typedef enum VAPI_STATE_TAG
{
  VAPI_IDLE,
  VAPI_PLAY,
  VAPI_RECORD
} VAPI_STATE;


//*************************************************************************
// Different types of modem operations
//*************************************************************************
enum ModemOp
{
   OP_NOP,
   OP_DATA,
   OP_VOICE,
   OP_FAX
};

//*************************************************************************
// User's voice config operations
//***********************************************************************
enum CONFIG_OPERATION
{
   CONFIG_BPS,
   CONFIG_VSR,
   CONFIG_VSD,
   CONFIG_VSS,
   CONFIG_VSP,
   CONFIG_VLS
};

//**************************************************************************
// Data Structure used in the example code
//**************************************************************************
struct USR_DATA
{
   enum USR_STATE          CurrentState;                    
   enum USR_STATE          NextState;                    
   enum USR_FAX_STATE      CurrentFaxState;
   enum USR_FAX_STATE      NextFaxState;
   int                     ModemInUse;                      
   int                     Abort;                      
   int                     ValidDTMF;
   int                     Port;
   char                    Operation;
   char                    Tone;                            
   char                    fRECMSG;                            
   char                    fSUPER_STATE;                            
   char                    fVoiceFirstTime;                            
   char                    PASSWORD[10];
   char                    CMIdString[20];
   char                    InitString[50];
   char                    cbPwdIndex;
   int                     ToneDetected;                            
   struct VPS              vps, VoiceParmInfo;
   struct VTD              vtd, ToneDetectionInfo;            
   int                     RecMsgIndex;
   int                     PlayBackIndex;
   long                    DTMF_Value;
   enum CONFIG_OPERATION   ConfigOp;
};

//***************************************************************************
// External Data Structure
//**************************************************************************
extern RVCALLBACK         lpfnRVCallBack;
extern struct USR_DATA    USR;


//***************************************************************************
// Function Prototype
//***************************************************************************
extern int  FAR PASCAL RVCallBack( int ID, long Parm);
extern char USR1_GetTone(void);
extern char USR2_GetTone(void);
extern void USR1_ErrHandler(void);
extern void USR2_ErrHandler(void);
extern int VoiceHandSet(char, unsigned int);
extern int USR_HandSetOperations(void);
extern int VoiceAnswerMachine( char *, unsigned int);
extern int VoiceAnswerMachineCD( char *, unsigned int);
extern int USR_AnswerMachine(void);
extern int EX1InProgress( void );
extern int EX2InProgress( void );
extern int EX4InProgress( void );
extern int USR_DataOnline(void);
extern void USR_OpenVoiceCommPort(int);
extern void USR_CloseVoiceCommPort(void);
extern int USR_FaxOperation(int op, char *file);
extern void USR_ConvertDTMF(int tone, long far *lpValue);
void USR_SetVoiceParameter(int bps, long vsr, int vsd, 
                           int vss, int vsp, int vls);
