/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/*
**      Last PVCS update: $Date:   09 Sep 1992 17:31:42  $
*/

/*
**      TITLE:          EXAMPLE2.c
**
**      FACILITY:       
**
**      MODULE DESCRIPTION:
**
**      Source File for VAPI Example 2
**
*/

/*
**
**      Revision History:
**
**              $Log:   D:/api_lib/example2.c_v  $
 * 
 *    Rev 1.3   09 Sep 1992 17:31:42   Robert Chen
 * 
 *    Rev 1.2   07 Sep 1992 15:43:34   Robert Chen
 *  
 * 
 *    Rev 1.1   15 Aug 1992 21:56:12   Robert Chen
 * 
 *    Rev 1.0   12 Aug 1992 19:56:12   Robert Chen
 * Initial revision.
 * 
 *    Rev 1.4   02 Jul 1992  9:41:30   Robert Chen
 *  
 * 
 *    Rev 1.3   24 Jun 1992 16:00:52   Robert Chen
 *  
 * 
 *    Rev 1.2   15 Jun 1992 10:55:00   Robert Chen
 *  
 * 
 *    Rev 1.1   04 Jun 1992 13:55:40   Robert Chen
 * Call Discrimination 00
 * 
 *    Rev 1.0   26 May 1992 14:23:00   Robert Chen
 * Initial revision.
** 
**
***************************************************************************/
/*
** 
** The following is an example program that uses the VAPI 
** to construct an answer machine. The answer machine allows
** a person to call in and leave a message. At the end of the 
** message, the person can play back  the message and has the 
** option to re-record it again. 
** 
** The answer machine also allows the owner to retrieve the 
** recorded message from an remote telephone and erase the 
** message after he is done with the them. The owner also has the 
** option to leave a new greeting message.
** 
** The following are the instructions for using the answer machine
** 
** To leave a message by a user:
**         1) Call in
**         
**         2) Wait for the greeting message to end then speak into 
**            the phone to leave a message.
**          or
**            press '*' during the greeting message then speak into 
**            the phone to leave a message.
** 
**         3) Press '4'  or hangup to  terminate the recording
** 
**         Following options are also available if the recording 
**         is terminated by pressing '4.'
** 
**         4) press '0' to listen to the recorded message
** 
**         5) press '*' to re-record the message 
**        
**         6) repeat step 3 to terminate the message
** 
** To retreive the recorded messages by owner
** 
**         1) Call in
**         
**         2) Press '#' then wait for the beep
** 
**         3) enter the password '123' and wait for the beep
** 
**         4) press '3' to listen to the messages
** 
**         5) press '9' to erase the messages
** 
**         6) Press '4' or hangup to terminate the call
** 
**         
** To leave a new greeting message by owner
** 
**         1) Call in
**         
**         2) Press '#' then wait for the beep
** 
**         3) Enter the password '123' then wait for the beep
** 
**         4) Press '1' then start recording
** 
**         5) Press '4' or hangup to terminate the recording
** 
**         Following options are also available if the recording
**         is terminated by pressing '4.'
** 
**         6) press '2' to listen to the greeting message
** 
**         7) press '1' to re-record the greeting message 
**        
**         8) repeat step 5 to terminate the message
**
** While playing back a recorded message:
**        
**         1) press 'p' to pause
**
**         2) press 'r' to resume
**  
*/ 

#if defined( VF_SWIN ) || defined( VF_MWIN )
  #include <windows.h>
#endif

#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>


#include "vapi.h"
#include "example.h"
#include "zapi.h"

#if defined(VF_SWIN) 
  #include "rawglobl.h"
  #include "raw.h"
  #include "rawvoice.h"
  #include "rawsdio.h"
  #include "rawerr.h"
  #include "rawclas1.h"
  #include "zapicls1.h"
  
#endif

#define USR_TELCO   0
#define USR_HANDSET 1

#ifndef BOOL
#define BOOL int
#endif

static void PrintTitle(char *szCommandStr);
static VAPI_STATE VAPIState = VAPI_IDLE;

// --------------------------------------------------------------------------
// End of temporary modications.
// --------------------------------------------------------------------------

struct USR_DATA   USR;
static   char     szGreetMsg[] = "GREETMSG.RIF";
static   char    *szRecMsg[] =
                 {
                      "RECMSG00.RIF",
                      "RECMSG01.RIF",
                      "RECMSG02.RIF",
                      "RECMSG03.RIF",
                      "RECMSG04.RIF",
                      NULL
                 };

RVCALLBACK lpfnGenCallBack;
static BOOL bModemInUse;

#ifdef VF_DOS
// ---------------------------------------------------------------------------
// The DOS  "main" function.
// ---------------------------------------------------------------------------

void main(int argc, char *argv[])
{

   int argi=1;

   strcpy(USR.PASSWORD, "123");
   USR.Port = 1;
   strcpy(USR.InitString, "#CLS=8#VSS=2#CLS=0");   // Set VSS to 0

   while ((argc >= 2))
   {
          switch(argv[argi][1])
          {
            case 'P' :
               if (argv[argi+1] != NULL)
                  strcpy(USR.PASSWORD, argv[argi+1]);
               break;
            case 'i' :
               if (argv[argi+1] != NULL)
                  strcat(USR.InitString, argv[argi+1]);
               break;
            case 'p' :
               if (argv[argi+1] != NULL)
                  sscanf(argv[argi+1], "%d", &USR.Port);
               break;
            default :
               PrintTitle(argv[0]);
               exit(1);
            }
            argi += 2;
            argc -= 2;
   }


     USR.ModemInUse = TRUE;
     USR.CurrentState = USR_STA_01;

     USR.Operation = USR_TELCO;
     if (RVOpenSess(RZRetIrqId()+USR.Port-1,0))
          exit(1);

     /*
      ** Open the Comp Port
      */
     if (RZOpenCom())
     {
          printf("Open Com%x Error\n",RZRetIrqId()+1);
          exit(1);
     }
     printf("\nDefault COM port - COM%x - 16550 %s\n",
          RZRetIrqId()+1,RZFifoPresent() ? "Present" : "Not Present");

     // User's initialization to use the handset or telco line
     RVPollSysTimerInit();
     USR.ModemInUse = TRUE;
     USR.Abort = FALSE;
     USR.CurrentState = USR_STA_01;
     lpfnGenCallBack = RVCallBack;

     while (1)
     {
          // The following section of code can be inserted anywhere in the user's program.
          // However, it should be called frequently to guarrentee the proper
          // operation of the VAPIs
          if (USR.ModemInUse)
          {
               USR.ModemInUse = USR_AnswerMachine();
               RVPoll();
          }
          // Check if user wants to abort the program
          else if (USR.Abort)
            break;
          else 
          {
            // If user does not key abort the program
            // Start the state machine again and wait for the 
            // next  call.
            USR.ModemInUse = TRUE;
            USR.CurrentState = USR_STA_01;
          }

     }
     // Restore the interrupt vector
     if (RZCloseCom())
     {
          printf("Close Com%x Error\n",RZRetIrqId()+1);
          exit(1);
     }
     exit(0);
}

static void PrintTitle(char *szCommandStr)
{
  printf("\n\n                                VAPI Example Program ");
  printf(  "\n                               Rockwell International\n");
  printf(    "                                 All Rights Reserved\n");
  printf(    "                        Copyright 1992 Rockwell International\n\n");
  printf("Valid Switches:\n" );
  printf("  /{P, p, i} - take parameters as follows:\n\n");
  printf("  P - Password \n");
  printf("  i - Initialization string\n");
  printf("  p - Port \n");
  printf(" example -> %s /p 1 /P 123   <port 1; password ""123""> \n", szCommandStr);
  // printf("example -> %s /1 <activates the handset>\n", szCommandStr);
}

#else

// ---------------------------------------------------------------------------
// The Windows version of the "main" function appearing above, performing
// session initialization and end user initiated abort checking:
// ---------------------------------------------------------------------------
int VoiceAnswerMachine(char *szPassWord, unsigned int wComPort)
{
  EXTDATA ExtData;
  MSG msg;

  // ------------------------------------------------------------------------
  // Select the voice line to correspond to the parameter passed.
  // ------------------------------------------------------------------------
  if ( szPassWord == NULL )
    strcpy(USR.PASSWORD, "123");
  else
    strcpy(USR.PASSWORD, szPassWord);

  //------------------------------------------------------------------------
  // Set Init string
  //------------------------------------------------------------------------
  strcpy(USR.InitString, "#CLS=8#VSS=2#CLS=0");   // Set VSS to 2

  // ------------------------------------------------------------------------
  // Initialize Extended Data Structure.
  // ------------------------------------------------------------------------
  memset(&ExtData, 0, sizeof(EXTDATA));

  if (UpdateExtData(&ExtData))
  {
    WRError(hWndMain, "UpdateExtData", IS_EXTDATANOMEM);
    return (1);
  }

  // ------------------------------------------------------------------------
  // Determine if user has requested a different COMx port and close original
  // session.
  // ------------------------------------------------------------------------
  if ( (iOldComPort != ( int ) wComPort) || !RVGetSessCnt())
  {
    if ((iOldComPort > -1) && RVGetSessCnt())
      RVCloseSess();

    if (RVOpenSess(wComPort, (LONG)(LPEXTDATA)&ExtData) != RV_STATUS_NONE)
      return (1);

    iOldComPort = wComPort;
  }

  if (RZOpenCom())
    return( 1 );

  // ------------------------------------------------------------------------
  // Change state of primary window to reflect impending transaction.
  // ------------------------------------------------------------------------
  EnableCancel(hWndMain);
  DisableMenuItems(hWndMain, TRUE, 1);

  // -------------------------------------------------------------------------
  // Initialize VAPI and create instance thunks for VAPI call back functions:
  // -------------------------------------------------------------------------
  if ((lpfnGenCallBack = MakeProcInstance(RVCallBack, hInst)) == NULL)
    return(1);

  // -------------------------------------------------------------------------
  // User's initialization to use the handset or telco line:
  // -------------------------------------------------------------------------
  RVPollSysTimerInit();
  USR.ModemInUse = TRUE;
  USR.CurrentState = USR_STA_01;
  USR.Abort = FALSE;
  USR.Operation = USR_TELCO;

  // -------------------------------------------------------------------------
  // Select one of the two operations: handset or telco line:
  // -------------------------------------------------------------------------
  while (1)
  {
    if (PeekMessage((LPMSG)&msg, NULL, 0, 0, PM_REMOVE))
    {
      if (msg.message == WM_QUIT)
        break;
      if (!TranslateAccelerator(hWndMain, hAccelMain, &msg))
      {
        TranslateMessage((LPMSG)&msg);
        DispatchMessage((LPMSG)&msg);
      }
    }

    else if (USR.ModemInUse)
    {
      bModemInUse = USR.ModemInUse = USR_AnswerMachine();
      RVPoll();
    }

    else if ( !bAbortReq && RVStatus() == RV_STATUS_DONE )
    {
      USR.ModemInUse = TRUE;
      USR.CurrentState = USR_STA_01;
    }

    else
      break;
  }

  FreeProcInstance(lpfnGenCallBack);

  // -------------------------------------------------------------------------
  // Restore menu options to accessible state:
  // -------------------------------------------------------------------------
  DisableCancel( hWndMain, FALSE );
  DisableMenuItems( hWndMain, FALSE, 1 );

  if (RZCloseCom())
  {
    wprintf("Close Com%x Error\n", wComPort+1);
    return(1);
  }
  return(0);
}

int EX2InProgress( void )
{
  return ( !bModemInUse ? 0 : USR.CurrentState );
}

#endif

int USR_AnswerMachine(void)
{
     // Return ModemInUse as TRUE unless exits from USR_STA_LAST.
     // User can also set the variable to FALSE in USR2_ErrHandler as part
     // of Error shutdown sequence.
     USR.ModemInUse = TRUE;

     switch (USR.CurrentState)
     {
     case USR_STA_01:
          RVOpen(USR.InitString, lpfnGenCallBack);
          USR.fSUPER_STATE = FALSE;
          USR.CurrentState = USR_STA_02;
          break;

     case USR_STA_02:
          switch(RVStatus())
          {
          case RV_STATUS_DONE:
               USR.CurrentState = USR_STA_SET_VM_BAUD_01;
               break;

          case RV_STATUS_NONE:
               break;

          default:
               USR2_ErrHandler();
               break;
          }
          break;

     case USR_STA_SET_VM_BAUD_01:
          // Set DCE to vocie mode and leave the baudrate along.
          RVSetVMBaudRate(8, -1);
          USR.CurrentState= USR_STA_SET_VM_BAUD_02;
          break;

     case USR_STA_SET_VM_BAUD_02:
          switch(RVStatus())
          {
          case RV_STATUS_DONE:
               USR.CurrentState = USR_STA_GET_SETTING_01;
               break;

          case RV_STATUS_NONE:
               break;

          default:
               USR2_ErrHandler();
               break;
          }
          break;

     case USR_STA_GET_SETTING_01:
         RVGetCurrentSetting();
         USR.CurrentState = USR_STA_GET_SETTING_02;
         break;

     case USR_STA_GET_SETTING_02:
          switch(RVStatus())
          {
          case RV_STATUS_DONE:
               USR.CurrentState = USR_STA_SET_SETTING_01;
               break;

          case RV_STATUS_NONE:
               break;

          default:
               USR2_ErrHandler();
               break;
          }
         break;

     case USR_STA_SET_SETTING_01:

          RVSetCurrentSetting(&USR.VoiceParmInfo, &USR.ToneDetectionInfo, 16);
          USR.CurrentState = USR_STA_SET_SETTING_02;
          break;

     case USR_STA_SET_SETTING_02:
          switch(RVStatus())
          {
          case RV_STATUS_DONE:
               if (USR.Operation == USR_HANDSET)
                    USR.CurrentState = USR_STA_VOICE_COMMAND;
               else if (USR.Operation == USR_TELCO)
                    USR.CurrentState = USR_STA_AUTOANSWER_01;
               else
                    USR2_ErrHandler();
               break;

          case RV_STATUS_NONE:
               break;

          default:
               USR2_ErrHandler();
               break;
          }
          break;

     case USR_STA_AUTOANSWER_01:
          RVAnswer(0, 8, 16);
          USR.CurrentState = USR_STA_AUTOANSWER_02;
          break;

     case USR_STA_AUTOANSWER_02:
          switch(RVStatus())
          {
          case RV_STATUS_DONE:
               USR.CurrentState = USR_STA_PLAY_GREETMSG_01;
               USR.NextState = USR_STA_REC_MSG_01;
               // USR.CurrentState = USR_STA_VOICE_COMMAND;
               break;

          case RV_STATUS_TIMEOUT:
               USR.CurrentState = USR_STA_LAST;
               break;

          case RV_STATUS_NONE:
               break;

          default:
               USR2_ErrHandler();
               break;
          }
          break;

     case USR_STA_VOICE_COMMAND:
          switch(USR.Tone = USR2_GetTone())
          {
          case '*' :
               USR.CurrentState = USR_STA_REC_MSG_01;
               break;

          case '0' :
               USR.CurrentState = USR_STA_PLAY_RECMSG_01;
               break;


          case '4' :
          case 'b' :
               RVStopVoiceIO(1);
               USR.CurrentState = USR_STA_LAST;
               if (USR.fRECMSG)
                    USR.RecMsgIndex++;
               break;

          case '#' :
               USR.CurrentState = USR_STA_PASSWORD_01;
               USR.cbPwdIndex = 0;
               RVPlayTone("[1000,1300,2]");
               break;

          default:
               break;
          }
          USR.NextState = USR_STA_VOICE_COMMAND;
          break;

     case USR_STA_VOICE_SUPER_COMMAND:
          switch(USR.Tone = USR2_GetTone())
          {
          case '*' :
               USR.CurrentState = USR_STA_REC_MSG_01;
               break;

          case '0' :
               USR.CurrentState = USR_STA_PLAY_RECMSG_01;
               break;

          case '1' :
               // Use the Current Voice Parameter setting and Tone Detection Mask.
               // Let VAPI make an inquiry about the CMIdString.
               RVRecordFile(0, 0, USR.CMIdString, "GREETMSG.RIF");
               VAPIState = VAPI_RECORD ;
               USR.CurrentState = USR_STA_VOICE_ONLINE_01;
               USR.fRECMSG = FALSE;
               break;

          case '2' :
               // Use the Current Tone Detection Mask.
               // Let VAPI make an inquiry about the CMIdString.
               USR.fRECMSG = FALSE;
               RVPlayFile(0, "GREETMSG.RIF");
               USR.CurrentState = USR_STA_VOICE_ONLINE_01;
               VAPIState = VAPI_PLAY;
               break;

          case  '3' :
               USR.fRECMSG = FALSE;
               USR.PlayBackIndex=0;
               USR.CurrentState = USR_STA_PLAY_ALL_RECMSG_01;
               break;

          case '4' :
          case 'b' :
          case 'd' :
               RVStopVoiceIO(1);
               USR.CurrentState = USR_STA_LAST;
               if (USR.fRECMSG)
                    USR.RecMsgIndex++;
               break;

          case '9' :
               RVPlayTone("[1000,1300,2]");
               USR.fRECMSG = FALSE;
               USR.RecMsgIndex = 0;

          default:
               break;
          }
          USR.NextState = USR_STA_VOICE_SUPER_COMMAND;
          break;

     case USR_STA_VOICE_ONLINE_01:
          switch (RVStatus()) 
          {
            case RV_STATUS_DONE:
               USR.CurrentState = USR.NextState;
               VAPIState = VAPI_IDLE;
               break;

            case RV_STATUS_DATA:
               USR.CurrentState = USR_STA_DATA;
               break;

            case RV_STATUS_FAX:
               USR.CurrentState = USR_STA_FAX;
               break;

            default:
               break;

          }

          switch(USR.Tone = USR2_GetTone())
          {
          case '1':
          case '2':
          case '3':
          case '*':
          case '0':
          case 'c':
          case 'e':
          // case 'q':
          case 's':
          case '9':
          case '#':
          case 'b' :
          case 'd' :
               RVStopVoiceIO(0);
               USR.CurrentState = USR_STA_VOICE_ONLINE_02;
               break;

               // Uses DTMF 4  to stop record or playback of a message.
          case '4' :
               // Issue a stop command and wait in the same state
               // until the command is done.
               RVStopVoiceIO(0);
               USR.CurrentState = USR_STA_VOICE_ONLINE_01;
               break;
          default:
               break;
          }
          break;

     case USR_STA_VOICE_ONLINE_02:
          if (RVStatus() == RV_STATUS_DONE)
          {
               USR.ToneDetected = USR.Tone;
               if (USR.fSUPER_STATE)
                    USR.CurrentState = USR_STA_VOICE_SUPER_COMMAND;
               else
                    USR.CurrentState = USR_STA_VOICE_COMMAND;
          }
          break;

     case USR_STA_PLAY_GREETMSG_01:
          RVPlayFile(0, szGreetMsg);
          USR.CurrentState = USR_STA_VOICE_ONLINE_01;
          VAPIState = VAPI_PLAY;
          break;

     case USR_STA_REC_MSG_01:
          if (szRecMsg[USR.RecMsgIndex] != 0)
          {
               RVRecordFile(0, 0, USR.CMIdString, szRecMsg[USR.RecMsgIndex]);
               VAPIState = VAPI_RECORD ;
               USR.fRECMSG = TRUE;
               USR.CurrentState = USR_STA_VOICE_ONLINE_01;
               if (USR.fSUPER_STATE)
                    USR.NextState = USR_STA_VOICE_SUPER_COMMAND;
               else
                    USR.NextState = USR_STA_VOICE_COMMAND;
          }
          else
          {
               RVPlayTone("[1000,1300,1]");
               if (USR.fSUPER_STATE)
                    USR.CurrentState = USR_STA_VOICE_SUPER_COMMAND;
               else
                    USR.CurrentState = USR_STA_VOICE_COMMAND;
          }

          break;

     case USR_STA_PLAY_RECMSG_01:
          RVPlayFile(0, szRecMsg[USR.RecMsgIndex]);
          USR.CurrentState = USR_STA_VOICE_ONLINE_01;
          VAPIState = VAPI_PLAY;
          break;

     case USR_STA_PLAY_ALL_RECMSG_01:
          if (USR.PlayBackIndex  < USR.RecMsgIndex)
          {
               RVPlayFile(0, szRecMsg[USR.PlayBackIndex]);
               USR.CurrentState = USR_STA_VOICE_ONLINE_01;
               USR.NextState = USR_STA_PLAY_ALL_RECMSG_01;
               USR.PlayBackIndex++;
               VAPIState = VAPI_PLAY;
          }
          else
          {
               // Play a tone to indicate no more messages
               // RVPlayTone("{*,15}");
               RVPlayTone("[1000,1300,2]");
               USR.CurrentState = USR_STA_VOICE_SUPER_COMMAND;
          }
          break;

     case USR_STA_PASSWORD_01:
          switch (USR.Tone = USR2_GetTone())
          {
          case 'b' :
               // Issue a stop command
               RVStopVoiceIO(1);
               USR.CurrentState = USR_STA_LAST;
               break;

          case '0':
          case '1':
          case '2':
          case '3':
          case '4':
          case '5':
          case '6':
          case '7':
          case '8':
          case '9':
               if(USR.Tone == USR.PASSWORD[USR.cbPwdIndex])
               {
                    USR.cbPwdIndex++;
                    if (USR.PASSWORD[USR.cbPwdIndex] == '\0')
                    {
                         // USR.CurrentState = USR_STA_PASSWORD_02;
                         USR.CurrentState = USR_STA_VOICE_SUPER_COMMAND;
                         USR.fSUPER_STATE = TRUE;
                         RVPlayTone("[1000,1300,2]");
                    }
               }
               else
                    USR.cbPwdIndex = 0;
               break;

          case '#':
               USR.cbPwdIndex = 0;
               break;

          default:
               break;
          }
          break;

     case USR_STA_PASSWORD_02:
          switch(RVStatus())
          {
          case RV_STATUS_DONE:
               USR.CurrentState = USR_STA_VOICE_SUPER_COMMAND;
               break;

          case RV_STATUS_NONE:
               break;

          default:
               USR2_ErrHandler();
               break;
          }
          break;

     case USR_STA_LAST:
          switch(RVStatus())
          {
          case RV_STATUS_DONE:
               RVClose();
               USR.ModemInUse = FALSE;
               break;

          case RV_STATUS_NONE:
               break;

          default:
               USR2_ErrHandler();
               break;
          }
          break;
     }
     
     #ifdef VF_DOS
     // Allow key abort in DOS
     if (kbhit())
     {
       int Key;

       Key = getch();

       switch ( Key )
       {
         case CHAR_LC_S:
         case CHAR_UC_S:
           if ( VAPIState == VAPI_RECORD )
             RVSendDLE( DLE_XOFF );
           break;

         case CHAR_LC_Q:
         case CHAR_UC_Q:
           if ( VAPIState == VAPI_RECORD )
             RVSendDLE( DLE_XON );
           break;

         case CHAR_LC_U:
         case CHAR_UC_U:
           if ( VAPIState == VAPI_PLAY )
             RVSendDLE( CHAR_LC_U );
           break;

         case CHAR_LC_P:
         case CHAR_UC_P:
           if ( VAPIState == VAPI_PLAY )
             RVSendDLE( DLE_PAUSE );
           break;

         case CHAR_LC_R:
         case CHAR_UC_R:
           if ( VAPIState == VAPI_PLAY )
             RVSendDLE( DLE_RESUME );
           break;

         case CHAR_LC_C:
         case CHAR_UC_C:
           if ( VAPIState == VAPI_PLAY )
             RVSendDLE( DLE_CANCEL );
           break;

         // If a key is hit during voice TX or RX, terminate the 
         // current transfer operation. 
         default:
           if (USR.CurrentState == USR_STA_VOICE_ONLINE_01)
             RVStopVoiceIO(0);
           else 
           {
             // If a key is hit during any other states then issue the
             // Hangup command  then goto the last state 
             USR.CurrentState = USR_STA_LAST;
             USR.Abort = TRUE;
             RVStopVoiceIO(1);
           }
       }
     }
     #else  // Window version's Abort
        if (bAbortReq &&                        // Some kind of abort happened
            !USR.Abort &&                       // and not abort from the CANCEL menu
            (USR.CurrentState != USR_STA_LAST)) // and not already here
        {
             USR.CurrentState = USR_STA_LAST;   // Exit gracefully
             RVStopVoiceIO(1);
        }
     #endif
     return(USR.ModemInUse);
}


char USR2_GetTone()
{
     // When the VAPI detects the DTMF tones from DCE, it calls the callback
     // function supplied by the user. The assumption here is that the callback
     // function stores the tone in USR.LastToneDetected. The tone is passed
     // to the callback function as an integer in the form of <DLE>code.

     char TmpTone;

     TmpTone = (char) (USR.ToneDetected & 0x00ff);// Mask out the <DLE>
     USR.ToneDetected = 0;             // Reset the tone
     return(TmpTone);                  // Return the tone
}

void USR2_ErrHandler()
{
     USR.ModemInUse = FALSE;
     USR.Abort  = TRUE;
#if defined(VF_SWIN) 
     bAbortReq = TRUE;
#endif

     // Plus any other shutdown code.
}

