/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/*
**      Last PVCS update: $Date:   12 Sep 1992 14:49:30  $
*/

/*
**      TITLE:          EXAMPLE4.c
**
**      FACILITY:       
**
**      MODULE DESCRIPTION:
**
**      Source File for VAPI Example 4
**
*/

/*
**
**      Revision History:
**
**              $Log:   D:/api_lib/example4.c_v  $
 * 
 *    Rev 1.4   12 Sep 1992 14:49:30   Robert Chen
 * 
 *    Rev 1.3   10 Sep 1992  9:41:44   Robert Chen
 * 
 *    Rev 1.2   09 Sep 1992 17:32:04   Robert Chen
 * 
 *    Rev 1.1   07 Sep 1992 15:43:44   Robert Chen
 *  
 * 
 *    Rev 1.0   12 Aug 1992 19:56:20   Robert Chen
 * Initial revision.
 * 
 *    Rev 1.6   02 Jul 1992 15:20:58   Robert Chen
 *  
 * 
 *    Rev 1.5   02 Jul 1992  9:41:38   Robert Chen
 *  
 * 
 *    Rev 1.4   30 Jun 1992 14:30:04   Robert Chen
 *  
 * 
 *    Rev 1.3   26 Jun 1992 10:28:38   Robert Chen
 *  
 * 
 *    Rev 1.2   24 Jun 1992 15:58:44   Robert Chen
 * 
 *    Rev 1.1   15 Jun 1992 10:55:08   Robert Chen
 *  
 * 
 *    Rev 1.0   04 Jun 1992 11:32:38   Robert Chen
 * Initial revision.
 * 
 *    Rev 1.0   26 May 1992 14:38:20   Robert Chen
 * Initial revision.
 * 
 *    Rev 1.0   26 May 1992 14:23:00   Robert Chen
 * Initial revision.
** 
**
***************************************************************************/
/*
** 
** The following is an example program that uses the VAPI 
** to construct an answer machine. The answer machine allows
** a person to call in and leave a message. At the end of the 
** message, the person can play back  the message and has the 
** option to re-record it again. 
** 
** The answer machine also allows the owner to retrieve the 
** recorded message from an remote telephone and erase the 
** message after he is done with the them. The owner also has the 
** option to leave a new greeting message.
** 
** The following are the instructions for using the answer machine
** 
** To leave a message by a user:
**         1) Call in
**         
**         2) Wait for the greeting message to end then speak into 
**            the phone to leave a message.
**          or
**            press '*' during the greeting message then speak into 
**            the phone to leave a message.
** 
**         3) Press '4'  or hangup to  terminate the recording
** 
**         Following options are also available if the recording 
**         is terminated by pressing '4.'
** 
**         4) press '0' to listen to the recorded message
** 
**         5) press '*' to re-record the message 
**        
**         6) repeat step 3 to terminate the message
** 
** To retreive the recorded messages by owner
** 
**         1) Call in
**         
**         2) Press '#' then wait for the beep
** 
**         3) enter the password '123' and wait for the beep
** 
**         4) press '3' to listen to the messages
** 
**         5) press '9' to erase the messages
** 
**         6) Press '4' or hangup to terminate the call
** 
**         
** To leave a new greeting message by owner
** 
**         1) Call in
**         
**         2) Press '#' then wait for the beep
** 
**         3) Enter the password '123' then wait for the beep
** 
**         4) Press '1' then start recording
** 
**         5) Press '4' or hangup to terminate the recording
** 
**         Following options are also available if the recording
**         is terminated by pressing '4.'
** 
**         6) press '2' to listen to the greeting message
** 
**         7) press '1' to re-record the greeting message 
**        
**         8) repeat step 5 to terminate the message
*/ 

#if defined( VF_SWIN ) || defined( VF_MWIN )
  #include <windows.h>
#endif

#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <bios.h>
#include <process.h>

#include "zapi.h"
#include "vapi.h"
#include "example.h"
#ifdef VF_DOS
#define   USRprintf printf
#endif
#ifdef DO_FAX
#include "fapi.h"
#include "fapisess.h"
#endif

#if defined(VF_SWIN) 
  #include "rawglobl.h"
  #include "raw.h"
  #include "rawvoice.h"
  #include "rawsdio.h"
  #include "rawerr.h"
  #include "rawclas1.h"
  #include "zapicls1.h"
  #define USRprintf wprintf  
#endif

#define USR_TELCO   0
#define USR_HANDSET 1

#ifndef BOOL
#define BOOL int
#endif

static VAPI_STATE VAPIState = VAPI_IDLE;
struct USR_DATA   USR;
static   char     szGreetMsg[] = "GREETMSG.RIF";
static   char    *szRecMsg[] =
                 {
                      "RECMSG00.RIF",
                      "RECMSG01.RIF",
                      "RECMSG02.RIF",
                      "RECMSG03.RIF",
                      "RECMSG04.RIF",
                      NULL
                 };

static char USR_GetTone(void);
static void USR_ErrHandler(void);
RVCALLBACK lpfnGenCallBack;
static BOOL bModemInUse;
static void PrintTitle(char *);

#ifdef VF_DOS
// ---------------------------------------------------------------------------
// The DOS  "main" function.
// ---------------------------------------------------------------------------

void main(int argc, char *argv[])
{
   int argi=1;

   // Set default password, init string & port 
   strcpy(USR.PASSWORD, "123");
   strcpy (USR.InitString, "+FAE=1M0#CLS=8#VSS=2#CLS=0");
   USR.Port = 1;
   USR.Operation = USR_TELCO;

   while ((argc >= 2))
   {
          switch(argv[argi][1])
          {
            case 'P' :
               if (argv[argi+1] != NULL)
                  strcpy(USR.PASSWORD, argv[argi+1]);
               break;
            case 'i' :
               if (argv[argi+1] != NULL)
                  strcat(USR.InitString, argv[argi+1]);
               break;
            case 'p' :
               if (argv[argi+1] != NULL)
                  sscanf(argv[argi+1], "%d", &USR.Port);
               break;
            case 'l' :
               if (argv[argi+1] != NULL)
                  sscanf(argv[argi+1], "%d", &USR.Operation);
               break;
            default :
               PrintTitle(argv[0]);
               exit(1);
            }
            argi += 2;
            argc -= 2;
   }



     // User's initialization to use the handset or telco line
     USR_OpenVoiceCommPort(USR.Port);
     RVPollSysTimerInit();
     USR.Abort = FALSE;
     USR.CurrentState = USR_STA_01;
     USR.fVoiceFirstTime = TRUE;
     USR.ModemInUse = OP_VOICE;
     lpfnGenCallBack = RVCallBack;
#ifdef DO_FAX
     USR.CurrentFaxState = USR_STA_FAX_INIT;
     RFPollSysTimerInit();
     USR.ModemInUse = OP_FAX;    // if fax is active, init fax first.
#endif

     while (1)
     {
          // The following section of code can be inserted anywhere in the user's program.
          // However, it should be called frequently to guarrentee the proper
          // operation of the VAPIs
          switch (USR.ModemInUse)
          {
            case OP_VOICE:
               USR.ModemInUse = USR_AnswerMachine();
               RVPoll();
               break;

             case OP_FAX:
#ifdef DO_FAX
               USR.ModemInUse = USR_FaxOperation(0, "t.fax");
#else 
               USRprintf("Fax package not installed.\n");
               USRprintf("Hit any key to abort current operation\n");
               getch();
               RVPollSysTimerInit();        // Init Voice timer
               USR.ModemInUse = OP_VOICE;   // before going into voice mode
               USR.CurrentState = USR_STA_HANGUP;
#endif
               break;

            case OP_DATA:
               USR.ModemInUse = USR_DataOnline();
               break;

            default:
               if (USR.Abort)
               {
                  goto BAIL_OUT;
               }
               else 
               {
                  USR.ModemInUse = OP_VOICE;
                  USR.CurrentState = USR_STA_01;
                  RVPollSysTimerInit();
#ifdef DO_FAX
                  RFPollSysTimerInit();
#endif
                  RZFlushTxComm();
               }
               break;
          }
     }

BAIL_OUT:
     USRprintf("\nRestoring Comm Port...\n");
     USR_CloseVoiceCommPort();
}

static void PrintTitle(char *szCommandStr)
{
  USRprintf("\n\n                                VAPI Example Program ");
  USRprintf(  "\n                               Rockwell International\n");
  USRprintf(    "                                 All Rights Reserved\n");
  USRprintf(    "                        Copyright 1992 Rockwell International\n\n");
  USRprintf("Valid Switches:\n" );
  USRprintf("  /{P, p, i} - take parameters as follows:\n\n");
  USRprintf("  P - Password \n");
  USRprintf("  i - Initialization string\n");
  USRprintf("  p - Port \n");
  USRprintf("  l - controls voice line selection as follows:\n");
  USRprintf("     0 - telco line with autoanswer (default)\n");
  USRprintf("     1 - handset\n");
  USRprintf("     2 - speaker\n");
  USRprintf("     3 - microphone\n");
  USRprintf("     4 - speaker/handset/telco line combination\n\n");
  USRprintf(" example -> %s /p 1 /P 123   <port 1; password ""123""> \n", szCommandStr);
}

#else
// ---------------------------------------------------------------------------
// The Windows version of the "main" function appearing above, performing
// session initialization and end user initiated abort checking:
// ---------------------------------------------------------------------------
int VoiceAnswerMachineCD(char *szPassWord, unsigned int wComPort)
{
  EXTDATA ExtData;
  MSG msg;

  // ------------------------------------------------------------------------
  // Select the voice line to correspond to the parameter passed.
  // ------------------------------------------------------------------------
  if ( szPassWord == NULL )
    strcpy(USR.PASSWORD, "123");
  else
    strcpy(USR.PASSWORD, szPassWord);

  strcpy (USR.InitString, "+FAE=1M0#CLS=8#VSS=2#CLS=0");

  // ------------------------------------------------------------------------
  // Initialize Extended Data Structure.
  // ------------------------------------------------------------------------
  memset(&ExtData, 0, sizeof(EXTDATA));

  if (UpdateExtData(&ExtData))
  {
    WRError(hWndMain, "UpdateExtData", IS_EXTDATANOMEM);
    return (1);
  }

  // ------------------------------------------------------------------------
  // Determine if user has requested a different COMx port and close original
  // session.
  // ------------------------------------------------------------------------
  if ( (iOldComPort != ( int ) wComPort) || !RVGetSessCnt())
  {
    if ((iOldComPort > -1) && RVGetSessCnt())
      RVCloseSess();

    if (RVOpenSess(wComPort, (LONG)(LPEXTDATA)&ExtData) != RV_STATUS_NONE)
      return (1);

    iOldComPort = wComPort;
  }

  if (RZOpenCom())
    return( 1 );

  // ------------------------------------------------------------------------
  // Change state of primary window to reflect impending transaction.
  // ------------------------------------------------------------------------
  EnableCancel(hWndMain);
  DisableMenuItems(hWndMain, TRUE, 1);

  // -------------------------------------------------------------------------
  // Initialize VAPI and create instance thunks for VAPI call back functions:
  // -------------------------------------------------------------------------
  if ((lpfnGenCallBack = MakeProcInstance(RVCallBack, hInst)) == NULL)
    return(1);

  // -------------------------------------------------------------------------
  // User's initialization to use the handset or telco line:
  // -------------------------------------------------------------------------
  RVPollSysTimerInit();
  USR.ModemInUse = OP_VOICE;
  USR.CurrentState = USR_STA_01;
  USR.Abort = FALSE;
  USR.Operation = USR_TELCO;

  // -------------------------------------------------------------------------
  // Select one of the two operations: handset or telco line:
  // -------------------------------------------------------------------------
  while (1)
  {
    if (PeekMessage((LPMSG)&msg, NULL, 0, 0, PM_REMOVE))
    {
      if (msg.message == WM_QUIT)
        break;
      if (!TranslateAccelerator(hWndMain, hAccelMain, &msg))
      {
        TranslateMessage((LPMSG)&msg);
        DispatchMessage((LPMSG)&msg);
      }
    }

    else if (USR.ModemInUse)
    {
        switch (USR.ModemInUse)
       {
         case OP_VOICE:
            bModemInUse = USR.ModemInUse = USR_AnswerMachine();
            RVPoll();
            break;

         case OP_FAX:
               MessageBox( hWndMain, "Fax Package not installed", "Voice Transaction",
                          MB_ICONINFORMATION | MB_OK );
               // USRprintf("Fax package not installed.\n");
               RVPollSysTimerInit();        // Init Voice timer
               USR.ModemInUse = OP_VOICE;   // before going into voice mode
               USR.CurrentState = USR_STA_HANGUP;
            break;

         case OP_DATA:
               MessageBox( hWndMain, "Data Package not installed", "Voice Transaction",
                          MB_ICONINFORMATION | MB_OK );
               // USRprintf("Data package not installed.\n");
               RVPollSysTimerInit();        // Init Voice timer
               USR.ModemInUse = OP_VOICE;   // before going into voice mode
               USR.CurrentState = USR_STA_HANGUP;
            break;

         default:
              break;
        }

    }

    else if ( !bAbortReq && RVStatus() == RV_STATUS_DONE )
    {
      USR.ModemInUse = OP_VOICE;
      USR.CurrentState = USR_STA_01;
    }

    else
      break;
  }

  FreeProcInstance(lpfnGenCallBack);

  // -------------------------------------------------------------------------
  // Restore menu options to accessible state:
  // -------------------------------------------------------------------------
  DisableCancel( hWndMain, FALSE );
  DisableMenuItems( hWndMain, FALSE, 1 );

  if (RZCloseCom())
  {
    wprintf("Close Com%x Error\n", wComPort+1);
    return(1);
  }
  return(0);
}

int EX4InProgress( void )
{
  return ( !bModemInUse ? 0 : USR.CurrentState );
}
#endif

static int USR_AnswerMachine(void)
{
     // Return ModemInUse as TRUE unless exits from USR_STA_LAST.
     // User can also set the variable to FALSE in USR_ErrHandler as part
     // of Error shutdown sequence.
     USR.ModemInUse = OP_VOICE;

     switch (USR.CurrentState)
     {
     case USR_STA_01:
          RVOpen(USR.InitString, lpfnGenCallBack);
          USR.fSUPER_STATE = FALSE;
          USR.CurrentState = USR_STA_02;
          break;

     case USR_STA_02:
          switch(RVStatus())
          {
          case RV_STATUS_DONE:
               USR.CurrentState = USR_STA_SET_VM_BAUD_01;
               break;

          case RV_STATUS_NONE:
               break;

          default:
               USR_ErrHandler();
               break;
          }
          break;

     case USR_STA_SET_VM_BAUD_01:
          // Set DCE to vocie mode 
          RVSetVMBaudRate(8, -1);
          USR.CurrentState= USR_STA_SET_VM_BAUD_02;
          break;

     case USR_STA_SET_VM_BAUD_02:
          switch(RVStatus())
          {
          case RV_STATUS_DONE:
               USR.CurrentState = USR_STA_GET_SETTING_01;
               break;

          case RV_STATUS_NONE:
               break;

          default:
               USR_ErrHandler();
               break;
          }
          break;

     case USR_STA_GET_SETTING_01:
         RVGetCurrentSetting();
         USR.CurrentState = USR_STA_GET_SETTING_02;
         break;

     case USR_STA_GET_SETTING_02:
          switch(RVStatus())
          {
          case RV_STATUS_DONE:
               USR.CurrentState = USR_STA_SET_SETTING_01;
               break;

          case RV_STATUS_NONE:
               break;

          default:
               USR_ErrHandler();
               break;
          }
         break;

     case USR_STA_SET_SETTING_01:

          USR.VoiceParmInfo.VoiceLine = USR.Operation;
          RVSetCurrentSetting(&USR.VoiceParmInfo, &USR.ToneDetectionInfo, 16);
          USR.CurrentState = USR_STA_SET_SETTING_02;
          break;

     case USR_STA_SET_SETTING_02:
          switch(RVStatus())
          {
          case RV_STATUS_DONE:
               if (USR.Operation >= USR_HANDSET)
                    USR.CurrentState = USR_STA_VOICE_COMMAND;
               else if (USR.Operation == USR_TELCO)
                    USR.CurrentState = USR_STA_AUTOANSWER_01;
               else
                    USR_ErrHandler();
               break;

          case RV_STATUS_NONE:
               break;

          default:
               USR_ErrHandler();
               break;
          }
          break;

     case USR_STA_AUTOANSWER_01:
          RVAnswerCD(0,                         // WaitLimit
                     NULL,                      // ToneDetection mask
                     8,                         // Mode
                     16,                        // BaudRate
                     0,                         // Maximum Message
                     NULL,                      // Receive Voice Parm Setting
                     USR.CMIdString,            // CMId String
                     szRecMsg[USR.RecMsgIndex], // Incoming Message
                     "GREETMSG.RIF",            // Init OGM
                     NULL,                      // Short OGM
                     NULL                       // LOng OGM
                     );
          USR.CurrentState = USR_STA_VOICE_ONLINE_01;
          USR.NextState = USR_STA_VOICE_COMMAND;
          USR.fRECMSG = TRUE;
          break;

     case USR_STA_VOICE_COMMAND:
          switch(USR.Tone = USR_GetTone())
          {
          case '*' :
               USR.CurrentState = USR_STA_REC_MSG_01;
               break;

          case '0' :
               USR.CurrentState = USR_STA_PLAY_RECMSG_01;
               break;

          case '6' :   // User defined DTMF tone for switching to fax
          case 'c' :   // Fax Calling Tone
               USR.CurrentState = USR_STA_VOICE_TO_FAX_01;
               break;

          case 'e' :   // Data Calling Tone
          case 's' :   // Silence Token
               USR.CurrentState = USR_STA_DATA_FAX_01;
               break;

          case '4' :
          case 'b' :
               RVStopVoiceIO(1);
               USR.CurrentState = USR_STA_LAST;
               if (USR.fRECMSG)
                    USR.RecMsgIndex++;
               break;

          case '#' :
               USR.CurrentState = USR_STA_PASSWORD_01;
               USR.cbPwdIndex = 0;
               RVPlayTone("[1000,1300,2]");
               break;

          default:
               break;
          }
          USR.NextState = USR_STA_VOICE_COMMAND;
          break;

     case USR_STA_VOICE_CONFIG_01:
          switch(USR.Tone = USR_GetTone())
          {
          case '1' :
               USR.ConfigOp = CONFIG_BPS;
               break;

          case '2' :
               USR.ConfigOp = CONFIG_VSR;
               break;

          case '3' :
               USR.ConfigOp = CONFIG_VSD;
               break;

          case '4' :
               USR.ConfigOp = CONFIG_VSS;
               break;

          case '5' :
               USR.ConfigOp = CONFIG_VSP;
               break;

          case  '6' :
               USR.ConfigOp = CONFIG_VLS;
               break;

          default:
               break;
          }
         
          if (USR.Tone >= '1' && USR.Tone <= '6')
          {
               USR.CurrentState = USR_STA_VOICE_CONFIG_02;
               RVPlayTone("{*,5}");
               USRprintf("Enter value follow by #\n");
          }
          break;

     case USR_STA_VOICE_CONFIG_02:
          switch(USR.Tone = USR_GetTone())
          {
            case ALL_DIGITS:
               USR_ConvertDTMF(USR.Tone, &USR.DTMF_Value);
               break;

            case '#' : 
               RVPlayTone("{*,5}");
               switch (USR.ConfigOp)
               {
                  case CONFIG_BPS:
                     USR_SetVoiceParameter
                                 ( (int) USR.DTMF_Value, -1, -1, -1, -1, -1);
                     break;
                  case CONFIG_VSR:
                     USR_SetVoiceParameter
                                 (-1, USR.DTMF_Value, -1, -1, -1, -1);
                     break;
                  case CONFIG_VSD:
                     USR_SetVoiceParameter
                                 (-1, -1, (int) USR.DTMF_Value, -1, -1, -1);
                     break;
                  case CONFIG_VSS:
                     USR_SetVoiceParameter
                                 (-1, -1, -1, (int) USR.DTMF_Value, -1, -1);
                     break;
                  case CONFIG_VSP:
                     USR_SetVoiceParameter
                                 (-1, -1, -1, -1, (int) USR.DTMF_Value, -1);
                     break;
                  case CONFIG_VLS:
                     USR_SetVoiceParameter
                                 (-1, -1, -1, -1, -1, (int) USR.DTMF_Value);
                     break;
                  default:
                     break;
               }
               USR.CurrentState = USR_STA_VOICE_CONFIG_03;
               break;

            default:
               break;
          }
          break;

     case USR_STA_VOICE_CONFIG_03:
          switch(RVStatus())
          {
            case RV_STATUS_DONE:
               RVSetCurrentSetting(&USR.vps, NULL, -1);
               USR.CurrentState = USR_STA_VOICE_CONFIG_04;
               break;

            default:
               break;
          }
          break;

     case USR_STA_VOICE_CONFIG_04:
          switch(RVStatus())
          {
            case RV_STATUS_DONE:
               USR.CurrentState = USR.NextState;
               break;

            default:
               break;
          }
          break;

     case USR_STA_VOICE_SUPER_COMMAND:
          switch(USR.Tone = USR_GetTone())
          {
          case '#' :
               USR.CurrentState = USR_STA_VOICE_CONFIG_01;
               RVPlayTone("{*,5}");
               USRprintf("Enter 1 to change BPS\n");
               USRprintf("      2 to change VSR\n");
               USRprintf("      3 to change VSD\n");
               USRprintf("      4 to change VSS\n");
               USRprintf("      5 to change VSP\n");
               USR.DTMF_Value = 0;
               break;

          case '*' :
               USR.CurrentState = USR_STA_REC_MSG_01;
               break;

          case '0' :
               USR.CurrentState = USR_STA_PLAY_RECMSG_01;
               break;

          case '1' :
               // Use the Current Voice Parameter setting and Tone Detection Mask.
               // Let VAPI make an inquiry about the CMIdString.
               RVRecordFile(0, 0, USR.CMIdString, "GREETMSG.RIF");
               VAPIState = VAPI_RECORD;
               USR.CurrentState = USR_STA_VOICE_ONLINE_01;
               USR.fRECMSG = FALSE;
               break;

          case '2' :
               // Use the Current Tone Detection Mask.
               // Let VAPI make an inquiry about the CMIdString.
               USR.fRECMSG = FALSE;
               RVPlayFile(0, "GREETMSG.RIF");
               VAPIState = VAPI_PLAY;
               USR.CurrentState = USR_STA_VOICE_ONLINE_01;
               break;

          case  '3' :
               USR.fRECMSG = FALSE;
               USR.PlayBackIndex=0;
               USR.CurrentState = USR_STA_PLAY_ALL_RECMSG_01;
               break;

          case '4' :
          case 'b' :
          case 'd' :
               RVStopVoiceIO(1);
               USR.CurrentState = USR_STA_LAST;
               if (USR.fRECMSG)
                    USR.RecMsgIndex++;
               break;

          case '9' :
               RVPlayTone("[1000,1300,2]");
               USR.fRECMSG = FALSE;
               USR.RecMsgIndex = 0;

          default:
               break;
          }
          USR.NextState = USR_STA_VOICE_SUPER_COMMAND;
          break;

     case USR_STA_VOICE_ONLINE_01:
          switch (RVStatus()) 
          {
            case RV_STATUS_DONE:
               VAPIState = VAPI_IDLE;
               USR.CurrentState = USR.NextState;
               break;

            case RV_STATUS_DATA:
               USR.CurrentState = USR_STA_DATA;
               USR.fRECMSG = FALSE;
               break;

            case RV_STATUS_FAX:
               USR.CurrentState = USR_STA_FAX;
               USR.fRECMSG = FALSE;
               break;

            default:
               break;

          }

          switch(USR.Tone = USR_GetTone())
          {
          case '1':
          case '2':
          case '3':
          case '*':
          case '0':
          case '6':
          case 'c':
          case 'd':
          case 'b':
          case 'e':
          // case 'q':
          // case 's':
          case '9':
          case '#':
               RVStopVoiceIO(0);
               USR.CurrentState = USR_STA_VOICE_ONLINE_02;
               break;

               // Uses DTMF 4  to stop record or playback of a message.
          case '4' :
               // Send a stop command and wait in the same state
               // until the command is done.
               RVStopVoiceIO(0);
               USR.CurrentState = USR_STA_VOICE_ONLINE_01;
               break;
          default:
               break;
          }
          break;

     case USR_STA_VOICE_ONLINE_02:
          if (RVStatus() == RV_STATUS_DONE || 
              RVStatus() == RV_STATUS_DONE_CD_PLAY || 
              RVStatus() == RV_STATUS_DONE_CD_RECORD)
          {
               USR.ToneDetected = USR.Tone;
               if (USR.fSUPER_STATE)
                    USR.CurrentState = USR_STA_VOICE_SUPER_COMMAND;
               else
                    USR.CurrentState = USR_STA_VOICE_COMMAND;
          }
          break;

     case USR_STA_PLAY_GREETMSG_01:
          RVPlayFile(0, szGreetMsg);
          VAPIState = VAPI_PLAY;
          USR.CurrentState = USR_STA_VOICE_ONLINE_01;
          break;

     case USR_STA_REC_MSG_01:
          if (szRecMsg[USR.RecMsgIndex] != 0)
          {
               RVRecordFile(0, 0, USR.CMIdString, szRecMsg[USR.RecMsgIndex]);
               VAPIState = VAPI_RECORD;
               USR.fRECMSG = TRUE;
               USR.CurrentState = USR_STA_VOICE_ONLINE_01;
               if (USR.fSUPER_STATE)
                    USR.NextState = USR_STA_VOICE_SUPER_COMMAND;
               else
                    USR.NextState = USR_STA_VOICE_COMMAND;
          }
          else
          {
               RVPlayTone("[1000,1300,1]");
               if (USR.fSUPER_STATE)
                    USR.CurrentState = USR_STA_VOICE_SUPER_COMMAND;
               else
                    USR.CurrentState = USR_STA_VOICE_COMMAND;
          }

          break;

     case USR_STA_PLAY_RECMSG_01:
          RVPlayFile(0, szRecMsg[USR.RecMsgIndex]);
          VAPIState = VAPI_PLAY;
          USR.CurrentState = USR_STA_VOICE_ONLINE_01;
          break;

     case USR_STA_PLAY_ALL_RECMSG_01:
          if (USR.PlayBackIndex  < USR.RecMsgIndex)
          {
               RVPlayFile(0, szRecMsg[USR.PlayBackIndex]);
               VAPIState = VAPI_PLAY;
               USR.CurrentState = USR_STA_VOICE_ONLINE_01;
               USR.NextState = USR_STA_PLAY_ALL_RECMSG_01;
               USR.PlayBackIndex++;
          }
          else
          {
               // Play a tone to indicate no more messages
               // RVPlayTone("{*,5}");
               RVPlayTone("[1000,1300,2]");
               USR.CurrentState = USR_STA_VOICE_SUPER_COMMAND;
          }
          break;

     case USR_STA_PASSWORD_01:
          switch (USR.Tone = USR_GetTone())
          {
          case 'b' :
               // Issue a stop command
               RVStopVoiceIO(1);
               USR.CurrentState = USR_STA_LAST;
               break;

          case '0':
          case '1':
          case '2':
          case '3':
          case '4':
          case '5':
          case '6':
          case '7':
          case '8':
          case '9':
               if(USR.Tone == USR.PASSWORD[USR.cbPwdIndex])
               {
                    USR.cbPwdIndex++;
                    if (USR.PASSWORD[USR.cbPwdIndex] == '\0')
                    {
                         // USR.CurrentState = USR_STA_PASSWORD_02;
                         USR.CurrentState = USR_STA_VOICE_SUPER_COMMAND;
                         USR.fSUPER_STATE = TRUE;
                         RVPlayTone("[1000,1300,2]");
                    }
               }
               else
                    USR.cbPwdIndex = 0;
               break;

          case '#':
               USR.cbPwdIndex = 0;
               break;

          default:
               break;
          }
          break;

     case USR_STA_PASSWORD_02:
          switch(RVStatus())
          {
          case RV_STATUS_DONE:
               USR.CurrentState = USR_STA_VOICE_SUPER_COMMAND;
               break;

          case RV_STATUS_NONE:
               break;

          default:
               USR_ErrHandler();
               break;
          }
          break;

     case USR_STA_DATA_FAX_01:
          RVDataFax();
          USR.CurrentState = USR_STA_VOICE_ONLINE_01;
          break;

     case USR_STA_DATA:
          USR.ModemInUse = OP_DATA;
          break;

     case USR_STA_VOICE_TO_FAX_01:
          RVSetVMBaudRate(0, 0);
          USR.CurrentState = USR_STA_VOICE_TO_FAX_02;
          break;

     case USR_STA_VOICE_TO_FAX_02:
          switch(RVStatus())
          {
          case RV_STATUS_DONE:
               USR.CurrentState = USR_STA_FAX;
               break;

          case RV_STATUS_NONE:
               break;

          default:
               USR_ErrHandler();
               break;
          }
          break;

     case USR_STA_FAX:
          USR.ModemInUse = OP_FAX;
          RVClose();
          break;

    case USR_STA_HANGUP:
         RVStopVoiceIO(1);
         USR.CurrentState = USR_STA_LAST;
         break;
         

     case USR_STA_LAST:
          switch(RVStatus())
          {
          case RV_STATUS_DONE:
               RVClose();
               USR.ModemInUse = OP_NOP;
               break;

          case RV_STATUS_NONE:
               break;

          default:
               USR_ErrHandler();
               break;
          }
          break;
     }
     
     #ifdef VF_DOS
     // Allow key abort in DOS
     if (kbhit())
     {
       int Key;

       Key = getch();

       switch ( Key )
       {
         case CHAR_LC_S:
         case CHAR_UC_S:
           if ( VAPIState == VAPI_RECORD )
             RVSendDLE( DLE_XOFF );
           break;

         case CHAR_LC_Q:
         case CHAR_UC_Q:
           if ( VAPIState == VAPI_RECORD )
             RVSendDLE( DLE_XON );
           break;

         case CHAR_LC_U:
         case CHAR_UC_U:
           if ( VAPIState == VAPI_PLAY )
             RVSendDLE( CHAR_LC_U );
           break;

         case CHAR_LC_P:
         case CHAR_UC_P:
           if ( VAPIState == VAPI_PLAY )
             RVSendDLE( DLE_PAUSE );
           break;

         case CHAR_LC_R:
         case CHAR_UC_R:
           if ( VAPIState == VAPI_PLAY )
             RVSendDLE( DLE_RESUME );
           break;

         case CHAR_LC_C:
         case CHAR_UC_C:
           if ( VAPIState == VAPI_PLAY )
             RVSendDLE( DLE_CANCEL );
           break;

         // If a key is hit during voice TX or RX, terminate the 
         // current transfer operation. 
         default:
             USR.CurrentState = USR_STA_LAST;
             USR.Abort = TRUE;
             RVStopVoiceIO(1);
       }
     }
     #else  // Window version's Abort
        if (bAbortReq &&                        // Some kind of abort happened
            !USR.Abort &&                       // and not abort from the CANCEL menu
            (USR.CurrentState != USR_STA_LAST)) // and not already here
        {
             USR.CurrentState = USR_STA_LAST;   // Exit gracefully
             RVStopVoiceIO(1);
        }
     #endif
     return(USR.ModemInUse);
}


static char USR_GetTone()
{
     // When the VAPI detects the DTMF tones from DCE, it calls the callback
     // function supplied by the user. The assumption here is that the callback
     // function stores the tone in USR.LastToneDetected. The tone is passed
     // to the callback function as an integer in the form of <DLE>code.

     char TmpTone;

     TmpTone = (char) (USR.ToneDetected & 0x00ff);// Mask out the <DLE>
     USR.ToneDetected = 0;             // Reset the tone
     return(TmpTone);                  // Return the tone
}

static void USR_ErrHandler()
{
     USR.ModemInUse = OP_NOP;
     USR.Abort = TRUE;
#if defined(VF_SWIN) 
     bAbortReq = TRUE;
#endif

     // Plus any other shutdown code.
}

/*
** =======================================================================
** USR_ConvertDTMF     
** =======================================================================
*/
void USR_ConvertDTMF(int tone, long far *lpValue)
{
   *lpValue *= 10;
   *lpValue += tone - '0';
}

/*
** =======================================================================
** USR_SetVoiceParameter
** =======================================================================
*/
void USR_SetVoiceParameter(int bps, long vsr, int vsd, 
                           int vss, int vsp, int vls)
{
   USR.vps.BPS = bps;
   USR.vps.SampleRate  = vsr;
   USR.vps.SilenceSensitivity  = vss;
   USR.vps.SilenceDeletion  = vsd; 
   USR.vps.SilenceDetectPeriod  = vsp;
   USR.vps.VoiceLine  = vls; 
}

#ifdef VF_DOS
/*
** =======================================================================
**     USRDataOnline(void)
** 
**      Get Data from keyboard and send it out on a COM port
**      Recevice data from a COM port and output it to screen
**
** =======================================================================
*/
int USR_DataOnline(void)
{
static   int   FirstTime=TRUE;
         int   Oper;
unsigned char   InData, OutData;

   
   if (FirstTime)
   {
      RZWriteCom("ato\r", 4);  // Tell modem to go online
      USRprintf("Data mode... To go back to voice mode, wait for \"CONNECT XXX\"\n");
      USRprintf("then type : \n");
      USRprintf("   +++\n");          
      USRprintf("   atz\[CR]\n");          
      USRprintf("   ath\[CR]\n");          
      USRprintf("   \[ESC\]\n");          
      FirstTime =FALSE;
   }

   Oper = OP_DATA;
   // Get Data from keyboard and send it out on COM port
   if (kbhit())
   {
      OutData = (unsigned char) getch();
      if ( (OutData == 0x1b) || (OutData == 0x04) )
      {
         // USR.Abort =TRUE;
         Oper = OP_NOP;
         FirstTime=TRUE;
      }
      else
         RZWriteCom(&OutData, 1);
    }

   // Get data from serial IO and put it on screen
   if (RZReadCom(&InData, 1))
   {
      putch(InData);
   }
   return (Oper);
}

/*
** =======================================================================
**     USR_OpenVocieCommPort
** =======================================================================
*/
void USR_OpenVoiceCommPort(int port)
{
     if (RVOpenSess(RZRetIrqId()+port-1,0))
          exit(1);

     /*
      ** Open the Comp Port
      */
     if (RZOpenCom())
     {
          USRprintf("Open Com%x Error\n",RZRetIrqId()+1);
          exit(1);
     }
     USRprintf("\nDefault COM port - COM%x - 16550 %s\n",
          RZRetIrqId()+1,RZFifoPresent() ? "Present" : "Not Present");

}


/*
** =======================================================================
**     USR_CloseVocieCommPort
** =======================================================================
*/
void USR_CloseVoiceCommPort(void)
{
     // Restore the interrupt vector
     if (RZCloseCom())
     {
          USRprintf("Close Com%x Error\n",RZRetIrqId()+1);
          exit(1);
     }
}
#endif

#ifdef DO_FAX
/*
** =======================================================================
**     USR_FAXOperation(void)
** =======================================================================
*/
int USR_FAXOperation(int op, char *file)
{
   int   Oper;

   Oper = OP_FAX;
   switch (USR.CurrentFaxState)
   {
      case USR_STA_FAX_INIT:
         if (RFOpenforCap())
         {
            USRprintf("Error in RFOpenforCap- Error Code: %x\n\n", RFStatus());
            Oper = OP_NOP;
         }
         USR.CurrentFaxState = USR_STA_FAX_01;
         break;

      case USR_STA_FAX_01:
         if (RFStatus() != RF_STATUS_NONE)
         {
            USR.CurrentFaxState = USR_STA_FAX_02;
            Oper = OP_NOP;
         }
         break;

      case USR_STA_FAX_02:
            unlink(file);
            if (RFOpenforRx(1,POLL_NONE, file, T30_SPEEDS_BEST,USE_MEDIA_HD,0))
            {
               USRprintf("Cannot Start Transmit - Error Code: %x\n\n", RFStatus());
               Oper = OP_NOP;
               break;
            }
            USR.CurrentFaxState = USR_STA_FAX_IN_PROGRESS;
         break;

      case USR_STA_FAX_IN_PROGRESS:
       
         /*
         ** Check if Transmit is done
         */
         if (RFStatus() != RF_STATUS_NONE)
         {
           Oper = OP_NOP;
           USR.CurrentFaxState = USR_STA_FAX_02;
           RFClose();
         }
         break;
         
      default:
         Oper = OP_NOP;
         USR.CurrentFaxState = USR_STA_FAX_01;
         RFClose();
         break;
   }

   RFPoll();
   return (Oper);
}
#endif


