/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:   
**	Last PVCS update: $Date:   07 Sep 1992 15:44:22  $ 
*/

/*
**	TITLE:		raw.h
**
**	FACILITY:
**    Windows application header file.
**
**	MODULE DESCRIPTION:
**    This header file should be included by all Windows application
**    modules.
**
*/

/*
**
**	Revision History:
**
**		$Log:   D:/api_lib/raw.h_v  $
   
      Rev 1.1   07 Sep 1992 15:44:22   Robert Chen
    
   
      Rev 1.0   12 Aug 1992 20:06:44   Robert Chen
   Initial revision.
** 
**    Rev 1.6   17 Oct 1991 10:42:32   JIM
** Global update of T.30/T.4 API source for version 1.00.
** 
**    Rev 1.5   12 Sep 1991 11:20:04   JIM
** Global update of T.30/T.4 API source for version 0.22B.
** 
**    Rev 1.4   08 Aug 1991 18:49:04   JIM
** Update to facilitate single session DLL version of API.
** 
**    Rev 1.1   20 May 1991 09:15:28   JIM
** 
**    Rev 1.0   13 May 1991 10:06:06   JIM
** Initial Revision
** 
** 
*/
// -------------------------------------------------------------------------
// ToDo: 
// - Convert static id constants to -1.
// - Change IDM to IM.
// -------------------------------------------------------------------------

#define PROP_FILENAME	szPropertyName	/* name of property for dialog */

#define ATTR_DIRS	    0xC010		// find drives and directories 
#define ATTR_FILES	  0x0000		// find ordinary files	       
#define DIALSTRMAX    ( TELE_BUF_SIZE - sizeof( ATDIAL ) ) //
#define BUFEDITMAX    5         // Used in the edit fields of Fax Modem dialog.
#define ASCIMAX       15360
#define TSIFRAMEMAX   21
#define CSIFRAMEMAX   21

// COMx port constants used in FaxModem dialog:
#define SPKROFF     0
#define SPKRCONNECT 1
#define SPKRALWAYS  2

#define ATSPKR      "M"
#define ATDIAL      "T"

// Logging Dialog MAX Values:
#define XMITBUFMAX    24576
#define XMITBUFMIN    2048
#define RECVBUFMAX    24576
#define RECVBUFMIN    2048
#define RECVTOMAX     60
#define FBTHOLDMAX    60000

// Asci Format Dialog MAX Values:
#define PAGELENMAX    50
#define TABSTOPMAX    80
#define LTMARMAX      50
#define RTMARMAX      50
#define TPMARMAX      50
#define BTMARMAX      50

// Xmit List Dialog MAX Values:
#define PAGEFILLMAX   48

//--------------------------------------------------------------------------
// Delay Function constants:
//--------------------------------------------------------------------------
#define _0_SEC_05 1						// ~55 MS
#define _0_SEC_1	2						 
#define _0_SEC_15	3
#define _0_SEC_2	4
#define _0_SEC_25	5
#define _0_SEC_3	6
#define _0_SEC_4  7
#define _0_SEC_5	9
#define _0_SEC_6	11
#define _0_SEC_7	13
#define _0_SEC_8	15
#define _0_SEC_9	16
#define _1_SEC_0	18

//--------------------------------------------------------------------------
// Dialog Id Constant Naming Conventions:
//--------------------------------------------------------------------------
// GD_ = Group Box Id
// BD_ = Button Id
// SD_ = Static Text Id
// ED_ = Edit Box Id
// CD_ = Combo Box Id
// ID_ = Icon Id
// IM_ = Menu Id
// IS_ = String Table Id

//--------------------------------------------------------------------------
// About Box Dialog Id's for About:
//--------------------------------------------------------------------------
#define ID_TTYICON    90
#define SD_VERSION    91
#define SD_DATECOMP   92
#define SD_TITLE      93

//--------------------------------------------------------------------------
// Resource Dialog Id's for TestEnv:
//--------------------------------------------------------------------------
#define GD_LOGGING    100
#define BD_PHASEAS    101
#define BD_PHASEBS    102
#define BD_PHASECS    103
#define BD_PHASEDS    104
#define BD_PHASEAF    106
#define BD_PHASEBF    107
#define BD_PHASECF    108
#define BD_PHASEDF    109
#define BD_DFCALLS    110

#define SD_MEM        111
#define SD_FILE       112
#define SD_PHASEA     113
#define SD_PHASEB     114
#define SD_PHASEC     115
#define SD_PHASED     116

#define GD_BUFFERSIZE 200
#define ED_TRANSMIT   201
#define ED_RECEIVE    202

#define SD_TRANSMIT   203
#define SD_RECEIVE    204

//--------------------------------------------------------------------------
// Resource Dialog Id's for XmitList:
//--------------------------------------------------------------------------
#define ED_FILENAME   300
#define CD_SPEED      301

#define GD_MEDIA      302
#define BD_HARD       303
#define BD_FLOPPY     304

#define GD_RESOLUTION 305
#define BD_ASIS       306
#define BD_STANDARD   307
#define BD_FINE       308

#define GD_DOCTYPE    309
#define BD_MERGE      310
#define BD_COVER      311

#define ED_PAGEFILL   312

#define BD_NEXT       313
#define BD_PREV       314
#define BD_DELETE     315
#define BD_ASCII      316

#define SD_FILENAME   317
#define SD_SPEED      318
#define SD_ITEMNUM    319
#define SD_PAGEFILL   320

//--------------------------------------------------------------------------
// Resource Id's for Cancel Modeless Dialog:
//--------------------------------------------------------------------------
#define SD_MESSAGE    601

//--------------------------------------------------------------------------
// Resource Id's for Receive Dialog:
//--------------------------------------------------------------------------
// Uses the same resource Id's as those for XmitParm.
//#define ED_FILENAME
//#define SD_FILENAME

//--------------------------------------------------------------------------
// Resource Id's for Logging Dialog:
//--------------------------------------------------------------------------
#define GD_VERBLEVEL  700
#define BD_ATCM       701
#define BD_HDLC       702
#define BD_WARN       703
#define BD_DEVL       704

#define GD_MESSWIND   800
#define BD_SCROLL     801
#define ED_SBUFFER    802
#define BD_SAVEDISK   803
// Uses the same resource Id's as those for XmitParm.
//#define ED_FILENAME   902

// Uses the same resource Id's as those for XmitParm.
//#define SD_FILENAME   1000
#define SD_SBUFFER    804

//--------------------------------------------------------------------------
// Resource Id's for Dial String Dialog:
//--------------------------------------------------------------------------
#define ED_DIALSTR    1100
#define SD_DIALSTR    1200

//--------------------------------------------------------------------------
// Resource Id's for Subscriber Id Dialog:
//--------------------------------------------------------------------------
#define ED_TSIFRAME   1300
#define ED_CSIFRAME   1301

#define SD_TSIFRAME   1350
#define SD_CSIFRAME   1351

//--------------------------------------------------------------------------
// Resource Id's for Fax Modem Dialog:
//--------------------------------------------------------------------------
#define GD_PORT       1400
#define BD_COM1       1401
#define BD_COM2       1402

#define GD_FLOW       1450
#define BD_XONXOFF    1451
#define BD_RTSCTS     1452

#define GD_IRQBUF     1500
#define ED_XMITBUF    1501
#define ED_RECVBUF    1502

#define GD_XSPEAKER   1550
#define BD_OFF        1551
#define BD_ONCONNECT  1552 
#define BD_ONALWAYS   1553

#define ED_RECVTO     1600
#define ED_FBTHOLD    1601

#define SD_XMITBUF    1620
#define SD_RECVBUF    1621
#define SD_RECVTO     1622
#define SD_FBTHOLD    1623

//--------------------------------------------------------------------------
// Resource Id's for ASCII Format Dialog:
//--------------------------------------------------------------------------
#define BD_RAMFILE    1650
#define BD_WRAP       1651

#define ED_PAGELEN    1700
#define ED_TABSTOP    1701

#define GD_MARGINS    1750
#define ED_LEFT       1751
#define ED_RIGHT      1752
#define ED_TOP        1753
#define ED_BOTTOM     1754

#define SD_PAGELEN    1800
#define SD_TABSTOP    1801
#define SD_LEFT       1802
#define SD_RIGHT      1803
#define SD_TOP        1804
#define SD_BOTTOM     1805
#define SD_INCHES     1806

//-------------------------------------------------------------------------
// Resource Id's for Open File Dialog:
//-------------------------------------------------------------------------
#define LD_FILES      1851
#define LD_DIRS       1852
#define SD_PATH       1853

//-------------------------------------------------------------------------
// Resource Id's for Save As File Dialog:
//--------------------------------------------------------------------------
#define ED_SAVETO     1900
#define SD_SAVEFROM   1901

//--------------------------------------------------------------------------
// Menu Resource Id's (1-50): 
//--------------------------------------------------------------------------
#define IM_FTRANSMIT    1 
#define IM_FMANXMIT     2
#define IM_FRECEIVE     3 
#define IM_FMANRECV     4
#define IM_FVIEW        5
#define IM_FVIEW_DONE   6
#define IM_FPRINT       7
#define IM_FCLRSCRN     8 
#define IM_EXIT         9 

#define IM_VPLAY        15
#define IM_VRECORD      16
#define IM_VHANDMICRO   17
#define IM_VMACHINE1    18
#define IM_VTELCOFAX    19

#define IM_TEDIT        25
#define IM_TOPEN        26
#define IM_TSAVE        27
#define IM_TSAVEAS      28
#define IM_TVIEW        29
#define IM_TPRINT       30

#define IM_VLEDIT       35
#define IM_VLOPEN       36
#define IM_VLSAVE       37
#define IM_VLSAVEAS     38
#define IM_VLVIEW       39

#define IM_CDIALSTRING  45
#define IM_CFAXMODEM    46
#define IM_CINITIALIZE  47
#define IM_CSUBID       48
#define IM_CLOGGING     49
#define IM_CASCIIFORM   50
#define IM_CMULTITASK   51
#define IM_CREXMIT      52 
#define IM_COPEN        53
#define IM_CSAVE        54
#define IM_CSAVEAS      55

#define IM_ABOUT        65
#define IM_CANCEL       66
#define IM_VMACHINE2    67

// -------------------------------------------------------------------------
// Assorted String Table Resoure Id's (350 - 399):
// -------------------------------------------------------------------------
#define IS_INIFILENAME   350
#define IS_INIXLKEYFILE  351
#define IS_INICPKEYFILE  352
#define IS_INIXLDEFFILE  353
#define IS_INICPDEFFILE  354
#define IS_DEFXLFILESRCH 355
#define IS_DEFCPFILESRCH 356
#define IS_LOGDEFFILE    357

#define IS_VERSION       358
#define IS_TITLE         359
#define IS_ENDOFLOG      360

#define IU_FAXPOLL      WM_USER + 1
#define IU_VOICEPOLL    WM_USER + 2

// -------------------------------------------------------------------------
// Resource Id's for String Table (50-100):
//--------------------------------------------------------------------------
// TD = Transmit Dialog, "enum" may not be used due to RC preprocessor errors.

#define TD_SPEED2400  50
#define TD_SPEED4800  ( TD_SPEED2400 + 1 )
#define TD_SPEED7200  ( TD_SPEED2400 + 2 )
#define TD_SPEED72V17 ( TD_SPEED2400 + 3 )
#define TD_SPEED9600  ( TD_SPEED2400 + 4 )
#define TD_SPEED96V17 ( TD_SPEED2400 + 5 )
#define TD_SPEED12V33 ( TD_SPEED2400 + 6 )
#define TD_SPEED12V17 ( TD_SPEED2400 + 7 )
#define TD_SPEED14V33 ( TD_SPEED2400 + 8 )
#define TD_SPEED14V17 ( TD_SPEED2400 + 9 )
#define TD_SPEEDBEST  ( TD_SPEED2400 + 10 )

#define TD_SPEED_FIRSTIDX  TD_SPEED2400
#define TD_SPEED_LASTIDX   TD_SPEEDBEST

#define TD_FORMATFAX   70
#define TD_FORMATASCII ( TD_FORMATFAX + 1 )
#define TD_FORMATBUFF  ( TD_FORMATFAX + 2 )

#define TD_FORMAT_FIRSTIDX  TD_FORMATFAX
#define TD_FORMAT_LASTIDX   TD_FORMATBUFF

#define TD_MEDIAHARD   80
#define TD_MEDIAFLOPPY ( TD_MEDIAHARD + 1 )

#define TD_MEDIA_FIRSTIDX  TD_MEDIAHARD
#define TD_MEDIA_LASTIDX   TD_MEDIAFLOPPY

#define TD_RESASIS 90
#define TD_RESSTAN ( TD_RESASIS + 1 )
#define TD_RESFINE ( TD_RESASIS + 2 )

#define TD_RES_FIRSTIDX    TD_RESASIS
#define TD_RES_LASTIDX     TD_RESFINE

// --------------------------------------------------------------------------
// Dialog box data structures:
// --------------------------------------------------------------------------
typedef struct AsciFormTag
{
  unsigned char bfWrap    : 1; // 0000000?
  unsigned char bfRAMFile : 1; // 000000?0
  unsigned char dummy     : 6; // ??????00
  WORD          wPageLen;
  WORD          wTabStop;
  WORD          wLeft;
  WORD          wRight;
  WORD          wTop;
  WORD          wBottom;
} ASCIFORM;

typedef struct XmitListTag
{
  char          szFileName[ _MAX_PATH ];
  int           iSpeed;
  int           iMedia;
  int           iResolution;
  WORD          wPageFill;
  unsigned char bfMerge     : 1;    // 0000000?
  unsigned char bfCover     : 1;    // 000000?0
  unsigned char dummy       : 6;    // ??????00
  ASCIFORM      AsciFormDlg;    
} XMITLIST;

typedef struct LogEnvTag
{
  WORD         wLogOutStat;
  BOOL         bScrlStat;
  WORD         wScrlBuf;
  char         szLogFileName[ _MAX_PATH ];
  BOOL         bDiskStat;
} LOGENV;

typedef struct SubIdTag
{
  char szTSIFrame[ TSIFRAMEMAX ];
  char szCSIFrame[ CSIFRAMEMAX ];
} SUBID;

typedef struct FaxModemTag
{
  WORD wSpkrStat;
  WORD wComPort;
  WORD wXmitBuf;
  WORD wRecvBuf;
  WORD wRecvTo;
  WORD wFBThold;
  BOOL bManual;
  BYTE bfXonXoff : 1;  //0000000?
  BYTE bfRtsCts : 1;   //000000?0
} FAXMODEM;

typedef struct ConfigFlagsTag
{
  unsigned char bfMultiTask : 1; // 0000000?
  unsigned char bfReXmit    : 1; // 000000?0
} CONFIGFLAGS;

// --------------------------------------------------------------------------
// These structures contain only one field and could just as easily have been
// defined as a global variable without the additional overhead of a structure
// reference.  This method was chosen, however, for consistency with previous
// dialogs and simplification of maintenance when new fields and child controls
// are added.
// --------------------------------------------------------------------------
typedef struct FileNameTag
{
  char szCaption[ CAPSTRMAX ];
  char szFileName[ _MAX_PATH ];
} FILENAME;

typedef FILENAME far *LPFILENAME;

typedef struct DialStrTag
{
  char szDialStr[ DIALSTRMAX ];
} DIALSTR;

//--------------------------------------------------------------------------
// Application level state constants:
//--------------------------------------------------------------------------
typedef enum FaxStatesTag
{
  FAX_REST,
  FAX_CAP,
  FAX_POLL_CAP,
  FAX_XMIT,
  FAX_RECEIVE,
  FAX_POLL_XMIT,
  FAX_POLL_RECV,
  FAX_DONE,
  FAX_ERROR
} FAXSTATES;

extern struct SessParm APISession; 

// Dialog structures:
extern XMITLIST    XmitListDlg;   
extern FILENAME    ReceiveDlg;    
extern FILENAME    VARecordDlg;
extern LOGENV      LogEnvDlg;     
extern FILENAME    ReceiveDlg;
extern FILENAME    VAPlayDlg;
extern FILENAME    VARecordDlg;
extern DIALSTR     DialStrDlg;    
extern SUBID       SubIdDlg;      
extern FAXMODEM    FMDlg;   
extern ASCIFORM    AsciFormDlg;   
extern CONFIGFLAGS ConfigFlags;  

//--------------------------------------------------------------------------
// Function Prototypes:
//--------------------------------------------------------------------------

// File: rawmain.c
int      PASCAL WinMain( HANDLE, HANDLE, LPSTR, int );
LONG FAR PASCAL MainWndProc( HWND, unsigned, WORD, LONG );
BOOL FAR PASCAL AboutWndProc( HWND, unsigned, WORD, LONG );

// File: rawappmn.c
int             FaxInit( WORD );
void            FaxClose( void );
int             FaxFileSetup( void );
DWORD           FaxInProgress( void );
FAXSTATES       FaxPoll( void );
int             PrintTxList( void );

// File: raw

// File: rawdlg1.c
BOOL FAR PASCAL AboutWndProc( HWND, WORD, WORD, LONG );
BOOL FAR PASCAL FileNameWndProc( HWND, WORD, WORD, LONG );
BOOL FAR PASCAL LogEnvWndProc( HWND, WORD, WORD, LONG );
BOOL FAR PASCAL DialStrWndProc( HWND, WORD, WORD, LONG );
BOOL FAR PASCAL SubIdWndProc( HWND, WORD, WORD, LONG );
BOOL FAR PASCAL FaxModemWndProc( HWND, WORD, WORD, LONG );
int  FAR        CPInit( NPSTR ); 

// File: rawdlg2.c
BOOL FAR PASCAL XmitListWndProc( HWND hDlg, WORD wMessage, WORD wParam, LONG lParam );  
unsigned        XLDel( HWND, unsigned, unsigned );
unsigned        XLItems( void );
int FAR         XLInit( HWND, NPSTR );
int FAR         XLLoad( HWND, NPSTR );
HWND            XLOpenLB( HWND );
int             XLCloseLB( HWND );
XMITLIST FAR *  GetXLItem( HWND, WORD, BOOL );
void            SetXLStat( BOOL );
BOOL            GetXLStat( void );

// File: rawdlg3.c
BOOL FAR PASCAL AsciFormWndProc( HWND hDlg, WORD wMessage, WORD wParam, LONG lParam );
int             AsciForm( HWND, ASCIFORM FAR * );

// File: rawdlg4.c
int             GetFileName( NPSTR, NPSTR );       
BOOL FAR PASCAL OpenFileWndProc( HWND, WORD, WORD, LONG );
int             SaveAsFileName( NPSTR, NPSTR );
BOOL FAR PASCAL SaveFileWndProc( HWND, WORD, WORD, LONG );

// File: rawcnfio.c
int FAR         XLRead( NPSTR, XMITLIST * );
int FAR         XLSave( NPSTR );  
int FAR         CPLoad( NPSTR );
int FAR         CPSave( NPSTR );
  

