#**************************************************************************
#*              ROCKWELL CONFIDENTIAL AND PROPRIETARY
#*        This source is the sole property of ROCKWELL Inc.
#*    Reproduction or utilization of this source in whole or in 
#*  part is forbidden without the written consent of ROCKWELL Inc.
#**************************************************************************
#*                 (c) Copyright ROCKWELL, INC. 1991
#*                       All Rights Reserved
#**************************************************************************
#*
#* 
#* Last update:   
#*	Last PVCS update: $Date:   21 Aug 1992 22:18:20  $ 
#*
#*	TITLE:	  rawclas1.mak (NOT included in API Windows deliverable)
#*
#*	FACILITY: T30/T4 Application Utility DLL Make File
#*
#*	MODULE DESCRIPTION:
#*        This make file recreates the DLL RAWCLAS1.DLL.  This DLL contains
#*        the utility functions called by the Windows test harness
#*        WAPIMAIN.EXE and the generalized text I/O functions called
#*        using the function "wputs".
#*
#*	REVISION HISTORY:
#*
#*		$Log:   D:/api_lib/rawapisd.mav  $ 
#  
#     Rev 1.4   21 Aug 1992 22:18:20   Robert Chen
#  
#     Rev 1.3   20 Aug 1992  0:35:30   Robert Chen
#  
#     Rev 1.2   20 Aug 1992  0:21:36   Robert Chen
#  
#     Rev 1.1   19 Aug 1992 16:44:34   Robert Chen
#  
#     Rev 1.9   09 Jul 1992 19:21:10   JIM
#  Global update of T.30/T.4 API (FAPI) source for version 1.05.
#  
#     Rev 1.8   29 Apr 1992 16:33:08   JIM
#  Global update of T.30/T.4 API (FAPI) source for version 1.03.
#  
#     Rev 1.7   27 Apr 1992 15:59:56   JIM
#  Global update of T.30/T.4 API (FAPI) source for version 1.02.
#  
#     Rev 1.7   27 Apr 1992 11:30:08   JIM
#  Global update of T.30/T.4 API source for version 1.01.
#  
#     Rev 1.6   02 Apr 1992 15:13:44   JIM
#  Global update of T.30/T.4 API source for version 1.01.
#  
#     Rev 1.5   17 Oct 1991 10:42:58   JIM
#  Global update of T.30/T.4 API source for version 1.00.
#  
#     Rev 1.4   12 Sep 1991 11:20:34   JIM
#  Global update of T.30/T.4 API source for version 0.22B.
#  
#     Rev 1.3   09 Aug 1991 09:57:52   JIM
#  Update to facilitate single session DLL version of API.
#*
#----------------------------------------------------------------------------
!if "$(SYSTEM)"=="DEVELOPMENT"
APIPATH1=..\\
APIPATH2=.\\win
!else
APIPATH1=.\\
APIPATH2=.\\
!endif
OB=winobjs\\
# ---------------------------------------------------------------------------
# New file extensions to be used in the following inference rule.  The 
# inference rule will not be valid without this statement.
# ---------------------------------------------------------------------------
.SUFFIXES : .def .lib

# ---------------------------------------------------------------------------
# Inference rule for creating an Import Library:  
#
# IFLAGS - parameters controlling translation from a *.def file to an import
#          library.
# ---------------------------------------------------------------------------
.def.lib:
  implib $(IFLAGS) $*.lib $<

.c.obj:
  cl $(CFLAGS) $<

.asm.obj:
  masm $(AFLAGS) $<, $(OB)

# ---------------------------------------------------------------------------
# Link flags for LINK4.EXE:
#
# /NOD - No default library search
# /F   - Optimizes intra-segment far calls.
# /PACKCODE - Packs adjacent code segments into 63488 maximum chunks.
# /align:16 - Aligns code and data segments on 16 byte boundary rather than
#             the default of 512 byte boundaries.
# /CO  - Enables symbolic debugging (optional).
# ---------------------------------------------------------------------------
# Link command line flags, debug capable.
#LFLAGS   = /NOD /CO /F /PACKCODE:63488 /align:16 
LFLAGS   = /NOD /F /PACKCODE:63488 /align:16 

# ---------------------------------------------------------------------------
# Link and destination file names:
# ---------------------------------------------------------------------------
DESTFILE = rawapisd
LINKFILE = $(DESTFILE).lnk
IMPLIB   = rfrawdll

# ---------------------------------------------------------------------------
# srfgenw - Small model library containing DLL startups for APICLAS1.DLL and
#           RAWCLAS1.DLL
# ---------------------------------------------------------------------------
GENLIB = srfgenw

# ---------------------------------------------------------------------------
# RECOMPILATION REQUIRES MSC 6.00a
#
# Compiler flags for desired memory model:
#
# CFLAGS is the macro used in the predefined inference rule for C to OBJ
# translation.
# 
# -W3  - Warning level 3
# -c   - Compile to object file, do not invoke linker.
# -ASw - Small memory model, SS is not equal to DS
# -Gsw - Removes calls to stack checking routine, compiles code for Windows (TM)
# -I   - Path for locating application include files.
# -Zpei- Packs structures on byte boundary, enables MSC extensions, compiles
#        with symbolic debugging information (optional).
# -O   - Optimation flags, d=disabled, s=size, l=loop, e=global register
#        allocation enabled, w=Assume no aliasing, windows (TM), z=Aggressive
#        optimizations enabled 
# ---------------------------------------------------------------------------
# Compile command line flags, debug capable:
#C51 = -W2 -c -ASw -Gsw -I$(APIPATH1) -Zpei -Od -DMSC510 -DFF_DLL -DFASTCALL
#C60 = -W3 -c -ASw -Gsw -I$(APIPATH1) -Zpei -Od -DMSC600 -DFF_DLL -DFASTCALL=_fastcall

C51 = -W2 -c -ASw -Gsw -Fo$(OB) -I$(APIPATH1) -Zpe -Ox -DMSC510 -DFASTCALL 
C60 = -W3 -c -ASw -Gsw -Fo$(OB) -I$(APIPATH1) -Zpe -Owxz -DMSC600 -DFASTCALL=_fastcall 

CFLAGS = $(C60)

# ---------------------------------------------------------------------------
# Assembler flags:
#
# AFLAGS is the macro used in the predefined inference rule for ASM to OBJ
# translation.
#
# -W2  - Warning level 2
# -D<a>- Defines symbol appearing immediately after
# -DNT - Defines name of code segment, overriding default _TEXT.
# -Zi  - Assembles with symbolic debugging information (optional).
# ---------------------------------------------------------------------------
AFLAGS = -W2 -D_fastcall -Dmem_s -Zi

# ---------------------------------------------------------------------------
# Libraries required to create the DLL:
#
# faxfile - Contains code for accessing TIFF image files.
# libw    - Windows (TM) primary import library.
# sdllcew - Specialized C runtime library functions for DLL's.
# ---------------------------------------------------------------------------
LINKLIBS = $(GENLIB).lib
SYSLIBS  = libw.lib sdllcew.lib

# ---------------------------------------------------------------------------
# Object modules to be placed in DLL and object module LIB file:
# ---------------------------------------------------------------------------
OBJSW1 = $(OB)libentry.obj $(OB)rawdllmn.obj $(OB)rawerr.obj 
OBJSW2 = $(OB)rawsdio1.obj $(OB)rawsdio2.obj $(OB)rawdutl1.obj 
OBJSW3 = $(OB)rawdtdll.obj 

all: $(LINKLIBS) $(IMPLIB).lib $(DESTFILE).res $(DESTFILE).dll

# ---------------------------------------------------------------------------
# DLL error and startup object modules:
# ---------------------------------------------------------------------------
$(OB)libentry.obj: libentry.asm
     masm $(AFLAGS) libentry.asm, $(OB);

$(OB)rawdllmn.obj: rawdllmn.c
     cl $(CFLAGS) rawdllmn.c  

$(OB)rawerr.obj:   rawerr.c $(APIPATH1)fapi.h rawglobl.h rawerr.h
     cl $(CFLAGS) rawerr.c 


# ---------------------------------------------------------------------------
# DLL "stdio" object modules:
# ---------------------------------------------------------------------------
$(OB)rawsdio1.obj: rawsdio1.c rawglobl.h rawclas1.h rawsdio.h rawsdio.d \
              rawerr.h $(APIPATH1)fapi.h
     cl $(CFLAGS) rawsdio1.c 

$(OB)rawsdio2.obj: rawsdio2.c rawglobl.h rawclas1.h rawsdio.h rawsdio.d \
              rawerr.h $(APIPATH1)fapi.h
     cl $(CFLAGS) rawsdio2.c 

$(OB)rawdutl1.obj: rawdutl1.c rawglobl.h rawclas1.h rawsdio.h rawerr.h \
              $(APIPATH1)fapi.h $(APIPATH1)faxfile.h
     cl $(CFLAGS) rawdutl1.c 

$(OB)rawdtdll.obj: rawdtdll.c rawglobl.h rawclas1.h  
     cl $(CFLAGS) rawdtdll.c 


# ---------------------------------------------------------------------------
# Compilation of Windows resource file:
# ---------------------------------------------------------------------------
rawapisd.res: rawapisd.rc rawerr.rc rawerr.h

# ---------------------------------------------------------------------------
# Developer object module library:
# ---------------------------------------------------------------------------
$(GENLIB).lib: $(OBJSW1)
  @if exist $(GENLIB).lib del $(GENLIB).lib
  lib $(GENLIB).lib;

  @echo $(GENLIB).lib                                   > $(GENLIB).LNK
  @echo +$(OB)libentry +$(OB)rawerr +$(OB)rawdllmn     >> $(GENLIB).LNK
  @echo $(GENLIB).lst;                                 >> $(GENLIB).LNK

  lib @$(GENLIB).lnk
  if exist \work\nul copy $(GENLIB).lib ..

# ---------------------------------------------------------------------------
# Import library:
# ---------------------------------------------------------------------------
$(IMPLIB).lib: $(DESTFILE).def
  implib $(IFLAGS) $*.lib $**
  if exist \work\nul copy $(IMPLIB).lib ..

# ===========================================================================
# Top Level Target.
# ===========================================================================
$(DESTFILE).dll: $(OBJSW2) $(OBJSW3) $(LINKLIBS) $(DESTFILE).res $(DESTFILE).def
  @echo $(LFLAGS) +                                  >  $(LINKFILE)
  @echo $(GENLIB).lib +                              >> $(LINKFILE)
  @echo $(OBJSW2) +                                  >> $(LINKFILE)
  @echo $(OBJSW3),                                   >> $(LINKFILE)
  @echo $(DESTFILE).dll,NUL,$(LINKLIBS) $(SYSLIBS), $(DESTFILE).def >> $(LINKFILE)
  @echo Beginning link of DLL . . .
  link @$(LINKFILE)
  rc $(DESTFILE).res $(DESTFILE).dll




