#include <windows.h>
#include <stdlib.h>  
#include <string.h>
#include <bios.h>
#include <sys\timeb.h>
#include "rawglobl.h"
#include "rawsdio.h"
#include "rawerr.h"
#include "zapi.h"
#include "zapicls1.h"

LONG FAR PASCAL FooTimer( BOOL bState, NPSTR szParmFuncName )
{
  static struct timeb tbTimeStart, tbTimeEnd;
  static char szOldFuncName[ 32 ], szFuncName[ 32 ];
  static BOOL bDupFuncName;

  // Print the name of the developer function executed.
  if ( bState )
  {
    if ( strcmp( szParmFuncName, szOldFuncName ) )// Do not repeat output of
    {                                             // function name excessively.
      strcpy( szOldFuncName, szParmFuncName );
      if ( bDupFuncName )                         // If no CR in output of "."
        wsprintf( szTmpStr0, "\nFunction Executed: %s\n", ( LPSTR ) szParmFuncName );
      else
        wsprintf( szTmpStr0, "Function Executed: %s\n", ( LPSTR ) szParmFuncName );
      bDupFuncName = FALSE;
      wputs( pExtData->hWndMain, szTmpStr0 );
      return ( 0L );
    }
    else
    {
      bDupFuncName = TRUE;
      wputs( pExtData->hWndMain, "." );
    }
  }    
  return ( 0L );

  // The following represents an alternate use of this function to time
  // the duration of execution of each developer function. JYW
  if ( bState )
  {
    ftime( &tbTimeStart );
    strcpy( szFuncName, szParmFuncName );
    return( 0L );
  }
  else
  {
    LONG lDuration;

    ftime( &tbTimeEnd );
    lDuration = ( 1000 * ( tbTimeEnd.time - tbTimeStart.time ) ) +
                tbTimeEnd.millitm - tbTimeStart.millitm; 
    wsprintf( szTmpStr0, "Function: %s, Duration: %i\n\0", ( LPSTR ) szFuncName, 
              lDuration );
    wputs( pExtData->hWndMain, szTmpStr0 );
    return ( lDuration );
  }
}

//---------------------------------------------------------------------------
// Return Value: Negative value indicates error, zero value success
//---------------------------------------------------------------------------
int FAR PASCAL UpdateCommState( DCB FAR *CommDCB )
{
  return( SetCommState( CommDCB ) );
}  

//---------------------------------------------------------------------------
// Return Value: zero value success, negative value indicates failure.  
//---------------------------------------------------------------------------
int FAR PASCAL InitDCB( DCB FAR *CommDCB, WORD wRecvBuf )
{
  int iReturn = BuildCommDCB( COMMSETTINGS, CommDCB );

  CommDCB->CtsTimeout = 5000;	     // Set Cts Timeout value.
  CommDCB->DsrTimeout = 5000;	     // Set Dsr Timeout value.
  CommDCB->fOutxDsrFlow = 0;        // Dsr output flow control off.
  CommDCB->fOutxCtsFlow = 0;        // Cts output flow control off.
  CommDCB->fDtrflow   = 0;          // Dtr receive flow control off.
  CommDCB->fRtsflow   = 0;          // Rts receive flow control off.
  CommDCB->fOutX      = 0;	         // Output Xon/Xoff flow control off.
  CommDCB->fInX       = 0;	         // Input Xon/Xoff flow control off.
  CommDCB->XonChar    = 0x11;	     // Specify the Xon character.
  CommDCB->XoffChar   = 0x13;       // Specify the Xoff character.

  CommDCB->ByteSize   = 8;          // Number of bits per byte.
  CommDCB->StopBits   = ONESTOPBIT; // Number of stop bits.
  CommDCB->fNull      = 0;	         // Do not strip null characters.
//  CommDCB->XoffLim    = wRecvBuf - CommDCB->XoffLim; 
//  CommDCB->XonLim     = 128;
  CommDCB->XoffLim    = 128; 
  CommDCB->XonLim     = wRecvBuf - CommDCB->XoffLim ; 
  CommDCB->fBinary    = 1; 		     // Do not process EOF char. 
//  CommDCB->fBinary    = 0; 		     // Do not process EOF char. 
  CommDCB->fChEvt     = 0;    	     // Do not allow event processing.

  return( iReturn );
}

//---------------------------------------------------------------------------
// Return Value: zero value success, positive indicates error encounter during
// GetCommError call.
//---------------------------------------------------------------------------
int FAR PASCAL CheckCommError( LPCOMSTAT CommStat, int iCodeLine )
{
  int  iReturn; 
  int  nErr;
  WORD wCommEvt;

  //-------------------------------------------------------------------------
  // CE_OVERRUN will commonly occur when switching between active DOS
  // applications.  The reception of a fax image during Phase C is half
  // duplex, synchronous with no flow control. JYW
  // ------------------------------------------------------------------------
  if ( iReturn = GetCommError( pCommDCB->Id, CommStat ) )
  {
    // Add parameter to control level of error checking, checked in statement below.

    if ( !( iReturn & CE_FRAME || iReturn & CE_BREAK ) )
    {
      if ( iReturn & CE_OVERRUN )
      {
        wputs( pExtData->hWndMain, "-\n" );
      }
      else
      {
        *szTmpStr0 = NULL;
        for ( nErr = 1; nErr != 0; nErr <<= 1 )
        {
          if ( nErr & iReturn )  
          {
            LoadString( GetWindowWord( pExtData->hWndMain, GWW_HINSTANCE ), 
                        nErr, szErrStr, ERRSTRMAX );
            strcat( szTmpStr0, szErrStr );
            strcat( szTmpStr0, "\n" );
          }
        }
        strcat( szTmpStr0, "Code Line: " );
        strcat( szTmpStr0, itoa( iCodeLine, szTmpStr1, 10 ) );
        strcat( szTmpStr0, "\n" );
        MessageBox( pExtData->hWndMain, szTmpStr0, 
                    "CheckCommError: GetCommError Error", MB_OK );
        return ( 1 );
      }
    }
  }
  wCommEvt = GetCommEventMask( pCommDCB->Id, 0xFFFF );
  return ( 0 );
}

WORD FAR PASCAL IsLogStat( WORD wTestStat )
{
  return ( pExtData->wLogOutStat & wTestStat );
}

BOOL _cdecl wprintf( LPSTR lpszFmt, ... )
{
  if ( _fstrstr( lpszFmt, "%" ) )
    wvsprintf( szTmpStr, lpszFmt, ( ( LPSTR ) &lpszFmt + sizeof( lpszFmt ) ) );
  else
    lstrcpy( szTmpStr, lpszFmt );
    
  return ( wputs( pExtData->hWndMain, szTmpStr ) );
}
