/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:   
**	Last PVCS update: $Date:   12 Aug 1992 19:58:18  $ 
*/

/*
**	TITLE:		rawcnfio.c
**
**	FACILITY:
**
**	MODULE DESCRIPTION:
**
*/

/*
**
**	Revision History:
**
**		$Log:   D:/api_lib/rawcnfio.c_v  $
 * 
 *    Rev 1.0   12 Aug 1992 19:58:18   Robert Chen
 * Initial revision.
** 
**    Rev 1.5   17 Oct 1991 10:40:18   JIM
** Global update of T.30/T.4 API source for version 1.00.
** 
**    Rev 1.4   12 Sep 1991 11:17:38   JIM
** Global update of T.30/T.4 API source for version 0.22B.
** 
**    Rev 1.3   08 Aug 1991 18:46:36   JIM
** Update to facilitate single session DLL version of API.
** 
**    Rev 1.0   13 May 1991 09:41:54   JIM
** Initial Revision
** 
** 
*/
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "zapi.h"
#include "fapi.h"
#include "rawglobl.h"
#include "raw.h"

int FAR XLRead( char *szFileName, XMITLIST *pXLEntry )
{
  OFSTRUCT     ofStruct;
  static int   iFileHandle;
  int          iReturn;

  if ( !iFileHandle )          // Has file been opened?
    if ( ( iFileHandle = ROpen( szFileName, OF_READ, &ofStruct ) ) < 0 ) 
      return ( -1 );

  if ( ( iReturn = RRead( iFileHandle, ( LPSTR ) pXLEntry, sizeof( XMITLIST ) ) ) <
       sizeof( XMITLIST ) )
  {
    RClose( iFileHandle );
    iFileHandle = 0;           // Clear file handle to allow reopening.
    return( iReturn < 0 ? -1 : 0 );
  }
  return ( 1 );
}

int FAR XLSave( char *szFileName )
{
  XMITLIST FAR  *pXLItem;
  XMITLIST      XLItem;
  GLOBALHANDLE  hXLItem;
  OFSTRUCT      ofStruct;
  int           iFileHandle;
  WORD          wXLIdx; 
  WORD          wXLIdxMax;

  if ( ( iFileHandle = RCreate( szFileName, &ofStruct ) ) == -1 )
    return ( -1 );
  for ( wXLIdxMax = ( WORD ) XLItems( ), wXLIdx = 1; wXLIdx <= wXLIdxMax;
                                                               ++wXLIdx )
  {
    hXLItem = GetProp( hWndMain, MAKEINTRESOURCE( wXLIdx ) );
    pXLItem = ( XMITLIST FAR * ) GlobalLock( hXLItem );

    // Since RWrite will not access global data across data segment boundaries,
    // the structure is copied to the local data segment.
    XLItem = *pXLItem;         

    RWrite( iFileHandle, ( LPSTR ) &XLItem, sizeof( XMITLIST ) );
    GlobalUnlock( hXLItem );
  }
  RClose( iFileHandle );
  
  return ( 0 );
}

int FAR CPLoad( char *szFileName )
{
  OFSTRUCT lpOfStruct;
  int      iFileHandle;

  if ( ( iFileHandle = ROpen( szFileName, OF_READ, &lpOfStruct ) ) < 0 )
    return ( -1 );

  RRead( iFileHandle, ( LPSTR ) &FMDlg, sizeof( FAXMODEM ) );
  RRead( iFileHandle, ( LPSTR ) &LogEnvDlg, sizeof( LOGENV ) );
  RRead( iFileHandle, ( LPSTR ) &DialStrDlg, sizeof( DIALSTR ) );
  RRead( iFileHandle, ( LPSTR ) &SubIdDlg, sizeof( SUBID ) );
  RClose( iFileHandle );
  
  return( 0 );
}

int FAR CPSave( char *szFileName )
{
  OFSTRUCT ofStruct;
  int      iFileHandle;

  if ( ( iFileHandle = RCreate( szFileName, &ofStruct ) ) < 0 )
    return ( -1 );

  RWrite( iFileHandle, ( LPSTR ) &FMDlg, sizeof( FAXMODEM ) );
  RWrite( iFileHandle, ( LPSTR ) &LogEnvDlg, sizeof( LOGENV ) );
  RWrite( iFileHandle, ( LPSTR ) &DialStrDlg, sizeof( DIALSTR ) );
  RWrite( iFileHandle, ( LPSTR ) &SubIdDlg, sizeof( SUBID ) );
  RClose( iFileHandle );
  
  return( 0 );
}

