/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:   
**	Last PVCS update: $Date:   07 Sep 1992 15:44:48  $ 
*/

/*
**	TITLE:		rawdlg1.c
**
**	FACILITY:
**
**	MODULE DESCRIPTION:
**
*/

/*
**
**	Revision History:
**
**		$Log:   D:/api_lib/rawdlg1.c_v  $
 * 
 *    Rev 1.2   07 Sep 1992 15:44:48   Robert Chen
 *  
 * 
 *    Rev 1.1   16 Aug 1992 22:49:02   Robert Chen
 * 
 *    Rev 1.0   12 Aug 1992 19:58:24   Robert Chen
 * Initial revision.
** 
**    Rev 1.6   17 Oct 1991 10:40:22   JIM
** Global update of T.30/T.4 API source for version 1.00.
** 
**    Rev 1.5   12 Sep 1991 11:17:42   JIM
** Global update of T.30/T.4 API source for version 0.22B.
** 
**    Rev 1.4   08 Aug 1991 18:46:40   JIM
** Update to facilitate single session DLL version of API.
** 
**    Rev 1.1   20 May 1991 09:11:52   JIM
** 
**    Rev 1.0   13 May 1991 09:54:18   JIM
** Initial Revision
** 
** 
*/

// Talk to OnLine about the following:
//      if ( HIWORD( lParam ) == BN_CLICKED )
//        bButtonCheck = SendDlgItemMessage( hDlg, wParam, BM_GETCHECK, 0, 0L );
// The following line causes crash in dialog box function when pressing OK:
//        bButtonCheck = SendMessage( LOWORD( lParam ), BM_GETCHECK, 0, 0L );

// When pressing the return key this line of code will not cause the cancel
// button to become grey. 
//        EnableWindow( LOWORD( lParam ), FALSE ); // Disable cancel button.
// This line of code was replaced with:
//        EnableWindow( GetDlgItem( hDlg, IDCANCEL ), FALSE ); 
// producing the desired results.
//
// Use of the "std" header files changes the translation of sizeof and 
// the resulting machine code in ways that I do not yet understand.

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "zapi.h"
#include "fapi.h"
#include "vapi.h"
#include "rawglobl.h"
#include "rawvoice.h"
#include "rawclas1.h"
#include "rawsdio.h"
#include "rawerr.h"
#include "raw.h"

// Local utility functions:
static void NEAR LoadCombos( HWND, WORD, WORD, WORD );

// Module variables:
HCURSOR hCursor;

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
BOOL FAR PASCAL AboutWndProc( HWND hDlg, WORD wMessage, WORD wParam, LONG lParam )
{
  switch ( wMessage ) 
  {
    case WM_INITDIALOG:	   // wMessage: initialize dialog box
      LoadString( hInst, IS_VERSION, szTmpStr, TMPSTRMAX );
      SetDlgItemText( hDlg, SD_VERSION, ( LPSTR ) szTmpStr );
      LoadString( hInst, IS_TITLE, szTmpStr, TMPSTRMAX );
      SetDlgItemText( hDlg, SD_TITLE, ( LPSTR ) szTmpStr );
      SetDlgItemText( hDlg, SD_DATECOMP, __DATE__ );
      break;

    case WM_COMMAND:	             // wMessage: received a command  
	   if ( wParam == IDOK ||       // "OK" box selected?	      
           wParam == IDCANCEL )    // System menu close command?  
		    EndDialog( hDlg, TRUE );   // Exits the dialog box	      
	   break;

    default:
      return ( FALSE );
  }
  return ( TRUE );		             // Didn't process a wMessage     
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
BOOL FAR PASCAL FileNameWndProc( HWND hDlg, WORD wMessage, WORD wParam, LONG lParam )
{
  static BOOL bFileName = FALSE;
  static FILENAME Tmp;
  static LPFILENAME pFileNameDlg;
  char szMessage[ TMPSTRMAX ];
  OFSTRUCT ofOpenData;

  switch ( wMessage )
  {
    case WM_INITDIALOG:
      if ( lParam )
      {
        pFileNameDlg = ( LPFILENAME ) lParam;
        Tmp = *pFileNameDlg;
        SetDlgItemText( hDlg, ED_FILENAME, 
                        ( LPSTR ) ( ( LPFILENAME ) lParam )->szFileName );
        SetWindowText( hDlg, ( LPSTR ) ( ( LPFILENAME ) lParam )->szCaption );
      }
      else
      {
        WRError( hDlg, "FileNameWndProc", IS_DIALOGCALL );
        EndDialog( hDlg, 0 );
        break;
      }
      SendDlgItemMessage( hDlg, ED_FILENAME, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );
      SendDlgItemMessage( hDlg, ED_FILENAME, EM_LIMITTEXT, _MAX_PATH, 0L );
      break;

    case WM_COMMAND:
      switch ( wParam )
      {
        case IDOK:
          if ( bFileName )
            GetDlgItemText( hDlg, ED_FILENAME, Tmp.szFileName, _MAX_PATH );
          // Fall through.

        case IDCANCEL:                        
          // Inform user of impending overwrite of existing fax file:

          // Allow user to abort receive:
          if ( wParam == IDCANCEL )
          {
            EndDialog( hDlg, IDCANCEL );
            break;
          }

          // Check for invalid file name.  Asteriks and question marks must be
          // checked in another function since OpenFile considers them valid.
          if ( !FileValidate( hDlg, Tmp.szFileName, "Receive Fax...", ED_FILENAME ) )
            return ( FALSE );

          // Check for existence of file.
          if ( strstr( Tmp.szCaption, "Record" ) )
          {
            if ( OpenFile( Tmp.szFileName, ( LPOFSTRUCT ) &ofOpenData, OF_EXIST ) > -1 )
            {
              int iReturn;

              sprintf( szMessage, "The File:\n\n%s\n\nalready exists.  \
Do you wish it to be overwritten?", ofOpenData.szPathName );
  
              iReturn = MessageBox( hDlg, ( LPSTR ) szMessage, "File Name",
                                  MB_YESNO | MB_DEFBUTTON2 | MB_ICONQUESTION ) ;
              if ( iReturn == IDYES )
              {
                *pFileNameDlg = Tmp;
                EndDialog( hDlg, wParam );
              }
              else
              { // Direct focus back to dialog.
                SetFocus( GetDlgItem( hDlg, ED_FILENAME ) );  
                return ( FALSE );
              }
            }
          }

          // File does not exist and is a valid format so it may be saved 
          // if user pressed OK button.
          else
          {
            *pFileNameDlg = Tmp;
            EndDialog( hDlg, wParam );
          }
          break;

        case ED_FILENAME:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bFileName = TRUE;
          break;
        
        default:
          return ( FALSE );
      }

    default:
      return ( FALSE );
  }
  return ( TRUE );
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#pragma optimize("egl",off)  // Temporarily deactivates global optimization.
BOOL FAR PASCAL LogEnvWndProc( HWND hDlg, WORD wMessage, WORD wParam, LONG lParam )
{
  static LOGENV Tmp;
  static BOOL bScrlBuf;
  static BOOL bLogFileName;
  BOOL bButtonCheck;

  switch ( wMessage )
  {
    case WM_INITDIALOG:
      Tmp = LogEnvDlg;       // Copy current dialog screen values to tmp variable.

      // Initialize dialog resources to current values.
      // Check boxes:
      SendDlgItemMessage( hDlg, BD_ATCM,     BM_SETCHECK, ( Tmp.wLogOutStat & ATCMLOGOUT ), 0L );
      SendDlgItemMessage( hDlg, BD_HDLC,     BM_SETCHECK, ( Tmp.wLogOutStat & HDLCLOGOUT ), 0L );
      SendDlgItemMessage( hDlg, BD_WARN,     BM_SETCHECK, ( Tmp.wLogOutStat & WARNLOGOUT ), 0L );
      SendDlgItemMessage( hDlg, BD_DEVL,     BM_SETCHECK, ( Tmp.wLogOutStat & DEVLLOGOUT ), 0L );
      SendDlgItemMessage( hDlg, BD_SCROLL,   BM_SETCHECK, Tmp.bScrlStat, 0L ); 
      SendDlgItemMessage( hDlg, BD_SAVEDISK, BM_SETCHECK, Tmp.bDiskStat, 0L );

      // Edit field values:
      SetDlgItemText( hDlg, ED_SBUFFER,  ( LPSTR ) ltoa( ( LONG ) Tmp.wScrlBuf, szTmpStr, 10 ) );

      if ( *Tmp.szLogFileName )
        SetDlgItemText( hDlg, ED_FILENAME, Tmp.szLogFileName );
      else
      {
        LoadString( hInst, IS_LOGDEFFILE, szTmpStr, TMPSTRMAX );
        SetDlgItemText( hDlg, ED_FILENAME, szTmpStr );
      }

      // Edit field text selections:
      SendDlgItemMessage( hDlg, ED_SBUFFER,  EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );
      SendDlgItemMessage( hDlg, ED_FILENAME, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );
      SendDlgItemMessage( hDlg, ED_FILENAME, EM_LIMITTEXT, _MAX_PATH, 0L );

      // Enable and disable fields where necessary:
      if ( !Tmp.bScrlStat )
        EnableWindow( GetDlgItem( hDlg, ED_SBUFFER ), FALSE );

      if ( !Tmp.bDiskStat )
        EnableWindow( GetDlgItem( hDlg, ED_FILENAME ), FALSE );

      SetFocus( GetDlgItem( hDlg, IDOK ) );
      return ( FALSE );

    case WM_COMMAND:
      if ( HIWORD( lParam ) == BN_CLICKED )
        bButtonCheck = ( BOOL ) SendDlgItemMessage( hDlg, wParam, BM_GETCHECK, 
                                                    0, 0L );
      switch ( wParam )
      {
        case IDOK:
          // Retrieve and verify the value in the scrolling buffer field.
          if ( bScrlBuf )
          {
            GetDlgItemText( hDlg, ED_SBUFFER, ( LPSTR ) szTmpStr, TMPSTRMAX );
            if ( ChkNumVal( hDlg, ED_SBUFFER, szTmpStr, ( LONG ) MINSCRBUF,
                            ( LONG ) MAXSCRBUF, IS_SCRBUFLIM ) )
              break;
            else
            {
              Tmp.wScrlBuf = ( unsigned int ) atol( szTmpStr );
              SetStdioMem( hWndMain, Tmp.wScrlBuf );
            }
          }

          if ( bLogFileName )
          {
            GetDlgItemText( hDlg, ED_FILENAME, ( LPSTR ) Tmp.szLogFileName, _MAX_PATH );
            if ( !FileValidate( hDlg, Tmp.szLogFileName, "Logging...", ED_FILENAME ) )
              return ( FALSE );
          }
          LogEnvDlg = Tmp;      // Save final values in global variable.
          EndDialog( hDlg, IDOK );
          break;
  
        case IDCANCEL:
          EndDialog( hDlg, IDCANCEL );
          break;

        case BD_ATCM:
          if ( bButtonCheck )
            Tmp.wLogOutStat |= ATCMLOGOUT;
          else
            CLRBIT( Tmp.wLogOutStat, ATCMBITNUM );
          break;

        case BD_HDLC:
          if ( bButtonCheck )
            Tmp.wLogOutStat |= HDLCLOGOUT;
          else
            CLRBIT( Tmp.wLogOutStat, HDLCBITNUM );
          break;

        case BD_WARN:
          if ( bButtonCheck )
            Tmp.wLogOutStat |= WARNLOGOUT;
          else
            CLRBIT( Tmp.wLogOutStat, WARNBITNUM );
          break;

        case BD_DEVL:
          if ( bButtonCheck )
            Tmp.wLogOutStat |= DEVLLOGOUT;
          else
            CLRBIT( Tmp.wLogOutStat, DEVLBITNUM );
          break;

        case BD_SCROLL:  
          EnableWindow( GetDlgItem( hDlg, ED_SBUFFER ), bButtonCheck );
          Tmp.bScrlStat = bButtonCheck;
          bScrlBuf = TRUE;

          if ( !bButtonCheck )
          {
            SetDlgItemText( hDlg, ED_SBUFFER, ( LPSTR ) itoa( MINSCRBUF,
                                              szTmpStr, 10 ) );
            Tmp.wScrlBuf = MINSCRBUF;
          }
          else
          {
            SetDlgItemText( hDlg, ED_SBUFFER, ( LPSTR ) ltoa( ( LONG ) MAXSCRBUF,
                                              szTmpStr, 10 ) );
            Tmp.wScrlBuf = MAXSCRBUF;
          }
          break;

        case ED_SBUFFER:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bScrlBuf = TRUE;
          else if ( HIWORD( lParam ) == EN_KILLFOCUS )
          {
            GetDlgItemText( hDlg, ED_SBUFFER, szTmpStr, TMPSTRMAX );
            if ( atol( szTmpStr ) == ( LONG ) MINSCRBUF )
            {
              SendDlgItemMessage( hDlg, BD_SCROLL, BM_SETCHECK, FALSE, 0L );
              EnableWindow( GetDlgItem( hDlg, ED_SBUFFER ), FALSE );
              Tmp.bScrlStat = FALSE;
            }
          }
          break;

        case BD_SAVEDISK:
          EnableWindow( GetDlgItem( hDlg, ED_FILENAME ), bButtonCheck );
          Tmp.bDiskStat = bButtonCheck;
          break;

        case ED_FILENAME:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bLogFileName = TRUE;
          break;

        default:
          return ( FALSE );
      }

    default:
      return ( FALSE );
  }
  return ( TRUE );
}      
#pragma optimize("",on)  // Reactivates default optimization from CL.

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
BOOL FAR PASCAL DialStrWndProc( HWND hDlg, WORD wMessage, WORD wParam, LONG lParam )
{ 
  static DIALSTR Tmp;
  static BOOL bDialStr;

  switch ( wMessage )
  {
    case WM_INITDIALOG:
      Tmp = DialStrDlg;

      // Initialize dialog resources to current values.

      // Edit fields:
      SetDlgItemText( hDlg, ED_DIALSTR, ( LPSTR ) Tmp.szDialStr );

      // Edit field dial string max length:
      SendDlgItemMessage( hDlg, ED_DIALSTR, EM_LIMITTEXT, DIALSTRMAX, 0L );

      // Edit field text selections:
      SendDlgItemMessage( hDlg, ED_DIALSTR, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );

      EnableWindow( GetDlgItem( hDlg, IDOK ), strlen( Tmp.szDialStr ) );

      SetFocus( GetDlgItem( hDlg, ED_DIALSTR ) );
      return ( FALSE );

    case WM_COMMAND:
      switch ( wParam )
      {
        case IDOK:
          if ( bDialStr )
            GetDlgItemText( hDlg, ED_DIALSTR, ( LPSTR ) Tmp.szDialStr, DIALSTRMAX );
          DialStrDlg = Tmp;  // Save final values in global variable.
          EndDialog( hDlg, IDOK );
          break;

        case IDCANCEL:
          EndDialog( hDlg, IDCANCEL );
          break;

        case ED_DIALSTR:
          if ( HIWORD( lParam ) == EN_UPDATE )
          {
            bDialStr = TRUE;
            EnableWindow ( GetDlgItem( hDlg, IDOK ),
	  	                     GetWindowTextLength( ( HWND ) LOWORD( lParam ) ) );
          }

          break;

        default:
          return ( FALSE );
      }

    default:
      return ( FALSE );
  }
  return ( TRUE );
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
BOOL FAR PASCAL SubIdWndProc( HWND hDlg, WORD wMessage, WORD wParam, LONG lParam )
{
  static SUBID Tmp;
  static BOOL bTSIFrame;
  static BOOL bCSIFrame;

  switch ( wMessage )
  {
    case WM_INITDIALOG:
      Tmp = SubIdDlg;

      // Initialize dialog resources to current values.

      // Edit fields:
      SetDlgItemText( hDlg, ED_TSIFRAME, ( LPSTR ) Tmp.szTSIFrame );
      SetDlgItemText( hDlg, ED_CSIFRAME, ( LPSTR ) Tmp.szCSIFrame );

      // Edit field text selection:
      SendDlgItemMessage( hDlg, ED_TSIFRAME, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );
      SendDlgItemMessage( hDlg, ED_CSIFRAME, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );

      // Edit field text length limits:
      SendDlgItemMessage( hDlg, ED_TSIFRAME, EM_LIMITTEXT, TSIFRAMEMAX - 1, 0L );
      SendDlgItemMessage( hDlg, ED_CSIFRAME, EM_LIMITTEXT, CSIFRAMEMAX - 1, 0L );

      SetFocus( GetDlgItem( hDlg, ED_TSIFRAME ) );
      return ( FALSE );

    case WM_COMMAND:
      switch ( wParam )
      {
        case IDOK:
          if ( bTSIFrame )
            GetDlgItemText( hDlg, ED_TSIFRAME, ( LPSTR ) Tmp.szTSIFrame, 
                            TSIFRAMEMAX );
          if ( bCSIFrame )
            GetDlgItemText( hDlg, ED_CSIFRAME, ( LPSTR ) Tmp.szCSIFrame,
                            CSIFRAMEMAX );
          SubIdDlg = Tmp;
          EndDialog( hDlg, IDOK );
          break;

        case IDCANCEL:
          EndDialog( hDlg, IDCANCEL );
          break;

        case ED_TSIFRAME:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bTSIFrame = TRUE;
          break;

        case ED_CSIFRAME:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bCSIFrame = TRUE;
          break;

        default:
          return ( FALSE );
      }
    default:
      return ( FALSE );
  }
  return ( TRUE );
}

#pragma optimize("egl",off)  // Temporarily deactivates global optimization.
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
BOOL FAR PASCAL FaxModemWndProc( HWND hDlg, WORD wMessage, WORD wParam, LONG lParam )
{
  static FAXMODEM Tmp;
  static BOOL bXmitBuf;
  static BOOL bRecvBuf;
  static BOOL bRecvTo;
  static BOOL bFBThold;
  BOOL bButtonCheck;

  switch ( wMessage )
  {
    int iResId;

    case WM_INITDIALOG:
      Tmp = FMDlg;

      // Initialize dialog resources to current values.

      // Button fields:
      switch ( FMDlg.wComPort )
      {
        case 0: iResId = BD_COM1; break;
        case 1: iResId = BD_COM2; break;
      }
      SendDlgItemMessage( hDlg, iResId, BM_SETCHECK, 1, 0L );

      SendDlgItemMessage( hDlg, BD_XONXOFF, BM_SETCHECK, FMDlg.bfXonXoff, 0L );
      SendDlgItemMessage( hDlg, BD_RTSCTS, BM_SETCHECK, FMDlg.bfRtsCts, 0L );

      switch ( FMDlg.wSpkrStat )
      {
        case SPKROFF:     iResId = BD_OFF;       break;
        case SPKRCONNECT: iResId = BD_ONCONNECT; break;
        case SPKRALWAYS:  iResId = BD_ONALWAYS;  break;
      }
      SendDlgItemMessage( hDlg, iResId, BM_SETCHECK, 1, 0L );

      // Set focus to first field for input in Fax Modem dialog.
      SetFocus( GetDlgItem( hDlg, BD_COM1 ) );

      // Edit field text:
      SetDlgItemText( hDlg, ED_XMITBUF, 
                      ( LPSTR ) itoa( Tmp.wXmitBuf, szTmpStr, 10 ) );
      SetDlgItemText( hDlg, ED_RECVBUF,
                      ( LPSTR ) itoa( Tmp.wRecvBuf, szTmpStr, 10 ) );
      SetDlgItemText( hDlg, ED_RECVTO,
                      ( LPSTR ) itoa( Tmp.wRecvTo / 1000, szTmpStr, 10 ) );
      SetDlgItemText( hDlg, ED_FBTHOLD,
                      ( LPSTR ) ltoa( ( LONG ) Tmp.wFBThold, szTmpStr, 10 ) );
                      
      // Edit field text selection:
      SendDlgItemMessage( hDlg, ED_XMITBUF, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );
      SendDlgItemMessage( hDlg, ED_RECVBUF, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );
      SendDlgItemMessage( hDlg, ED_RECVTO,  EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );
      SendDlgItemMessage( hDlg, ED_FBTHOLD, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );

      // Edit field text length limits:
      SendDlgItemMessage( hDlg, ED_XMITBUF, EM_LIMITTEXT, BUFEDITMAX, 0L );
      SendDlgItemMessage( hDlg, ED_RECVBUF, EM_LIMITTEXT, BUFEDITMAX, 0L );
      SendDlgItemMessage( hDlg, ED_RECVTO,  EM_LIMITTEXT, BUFEDITMAX, 0L );
      SendDlgItemMessage( hDlg, ED_FBTHOLD, EM_LIMITTEXT, BUFEDITMAX, 0L );

      // Initialize edit status variables.
      bXmitBuf = bRecvBuf = bRecvTo = bFBThold = 0;

      return ( FALSE );

    case WM_COMMAND:

      if ( HIWORD( lParam ) == BN_CLICKED )
        bButtonCheck = ( BOOL ) SendDlgItemMessage( hDlg, wParam, BM_GETCHECK, 
                                                    0, 0L );
      switch( wParam )
      {
        case IDOK:

          // Retrieve values in text fields:
          if ( bXmitBuf )
          {
            GetDlgItemText( hDlg, ED_XMITBUF, ( LPSTR ) szTmpStr, TMPSTRMAX );
            if ( ChkNumVal( hDlg, ED_XMITBUF, szTmpStr, ( LONG ) XMITBUFMIN,
                            ( LONG ) XMITBUFMAX, IS_XMITBUFLIM ) )
              break;              
            Tmp.wXmitBuf = atoi( szTmpStr );
          }
          if ( bRecvBuf )
          {
            GetDlgItemText( hDlg, ED_RECVBUF, ( LPSTR ) szTmpStr, TMPSTRMAX );
            if ( ChkNumVal( hDlg, ED_RECVBUF, szTmpStr, ( LONG ) RECVBUFMIN,
                            ( LONG ) RECVBUFMAX, IS_RECVBUFLIM ) )
              break;
            Tmp.wRecvBuf = atoi( szTmpStr );
          }
          if ( bRecvTo )
          {
            GetDlgItemText( hDlg, ED_RECVTO, ( LPSTR ) szTmpStr, TMPSTRMAX );
            if ( ChkNumVal( hDlg, ED_RECVTO, szTmpStr, 0L, 
                            ( LONG ) RECVTOMAX, IS_RECVTOMAX ) )
              break;
            Tmp.wRecvTo = atoi( szTmpStr ) * 1000;
          }
          if ( bFBThold )
          {
            GetDlgItemText( hDlg, ED_FBTHOLD, ( LPSTR ) szTmpStr, TMPSTRMAX );
            if ( ChkNumVal( hDlg, ED_FBTHOLD, szTmpStr, 0L,
                            ( LONG ) FBTHOLDMAX, IS_FBTHOLDMAX ) )
              break;
            Tmp.wFBThold = ( unsigned ) atol( szTmpStr );
          }
          FMDlg = Tmp;      // Save final values to global variable.
          EndDialog( hDlg, IDOK );
          break;
            
        case IDCANCEL:
          EndDialog( hDlg, IDCANCEL );
          break;

        case BD_COM1:
          if ( bButtonCheck )
            Tmp.wComPort = 0;
          break;

        case BD_COM2:
          if ( bButtonCheck )
            Tmp.wComPort = 1;
          break;

        case BD_XONXOFF:
          if ( bButtonCheck )
          {
            Tmp.bfXonXoff = TRUE;
            Tmp.bfRtsCts = FALSE;
          }
          break;

        case BD_RTSCTS:
          if ( bButtonCheck )
          {
            Tmp.bfRtsCts = TRUE;
            Tmp.bfXonXoff = FALSE;
          }
          break;

        case ED_XMITBUF:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bXmitBuf = TRUE;
          break;

        case ED_RECVBUF:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bRecvBuf = TRUE;
          break;

        case BD_OFF:
          if ( bButtonCheck )
            Tmp.wSpkrStat = SPKROFF;
          break;

        case BD_ONCONNECT:
          if ( bButtonCheck )
            Tmp.wSpkrStat = SPKRCONNECT;
          break;

        case BD_ONALWAYS:
          if ( bButtonCheck )
            Tmp.wSpkrStat = SPKRALWAYS;
          break;

        case ED_RECVTO:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bRecvTo = TRUE;
          break;

        case ED_FBTHOLD:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bFBThold = TRUE;
          break;

        default:
          return ( FALSE );
      }
    default:
      return ( FALSE );
  }
  return ( TRUE );
}
#pragma optimize("",on)  // Reactivates default optimization from CL.

int FAR CPInit( char *szFileName )
{
  if ( !FileExists( NULL, szFileName, 0L, 0 ) )
    return ( 0 );    // Initialization of WRDATA.C will be retained.

  return ( CPLoad( szFileName ) );
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
VOID EnableCancel( HWND hWnd )
{
  HMENU hMenu = GetMenu( hWnd );

  if ( !ConfigFlags.bfMultiTask )
  {
    EnableMenuItem( hMenu, IM_CANCEL, MF_GRAYED );
    hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
    ShowCursor( TRUE );
    SetCapture( hWnd );   // Do not allow other windows to change the
  }                       // shape of the cursor.
  else
    EnableMenuItem( hMenu, IM_CANCEL, MF_ENABLED );
}

VOID DisableCancel( HWND hWnd, BOOL bMenuClicked )
{
  HMENU hMenu = GetMenu( hWnd );

  if ( !ConfigFlags.bfMultiTask )    // Deactivate hour glass cursor.
  {
    ShowCursor( FALSE );   // Restore mouse cursor and release capture of
    SetCursor( hCursor );  // mouse messages.
    ReleaseCapture( );
    return;
  }

  if ( bMenuClicked )      // Function was called to perform cancelation.
  {
    bAbortReq = TRUE;
#ifdef DO_FAX
    if ( FaxInProgress( ) )
      RFSysAbortReq( );
    else
#endif
#ifdef DO_VOICE
        if ( IsVCON() )
    {
      RVStopVoiceIO( GOTOONHOOK );
      SetLastVState();
    }
    else
      RVStopVoiceIO( GOTOVCON );
#endif
    return;
  }

  if ( bAbortReq )    // Function was called to announce completed cancel.
  {
    WORD wTransType;
#if defined (DO_FAX)   
    if ( ( wTransType = LOWORD( FaxInProgress( ) ) ) == 0 )
#if defined (DO_VOICE)
      wTransType = LOWORD( VoiceInProgress( ) );
#endif
#endif

    switch( wTransType )
    {
      case IM_FRECEIVE:
        strcpy( szTmpStr, "Receive Fax" );
        break;
      
      case IM_FTRANSMIT:
        strcpy( szTmpStr, "Transmit Fax" );
        break;

      case IM_VPLAY:
      case IM_VRECORD:
      case IM_VHANDMICRO:
      case IM_VMACHINE1:
      case IM_VMACHINE2:
      case IM_VTELCOFAX:
        strcpy( szTmpStr, "Voice Transaction" );
        break;

      default:
        strcpy( szTmpStr, "Voice Transaction" );
    }

    MessageBox( hWnd, "Transaction Cancelled.", szTmpStr,
                MB_ICONINFORMATION | MB_OK );
    bAbortReq = FALSE;
  }

  EnableMenuItem( hMenu, IM_CANCEL, MF_GRAYED );
}

VOID DisableClose( HWND hWnd )
{
  HMENU hSysMenu;

  hSysMenu = GetSystemMenu( hWnd, FALSE );
  EnableMenuItem( hSysMenu, SC_CLOSE, MF_GRAYED );
}
  
VOID EnableClose( HWND hWnd )
{
  GetSystemMenu( hWnd, TRUE );
}




