/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:   
**	Last PVCS update: $Date:   20 Aug 1992  1:56:28  $ 
*/

/*
**	TITLE:		rawdlg2.c
**
**	FACILITY:
**
**	MODULE DESCRIPTION:
**
*/

/*
**
**	Revision History:
**
**		$Log:   D:/api_lib/rawdlg2.c_v  $
 * 
 *    Rev 1.3   20 Aug 1992  1:56:28   Robert Chen
 * 
 *    Rev 1.2   19 Aug 1992 22:30:22   Robert Chen
 * 
 *    Rev 1.1   16 Aug 1992 22:49:12   Robert Chen
 * 
 *    Rev 1.0   12 Aug 1992 19:58:28   Robert Chen
 * Initial revision.
** 
**    Rev 1.6   17 Oct 1991 10:40:26   JIM
** Global update of T.30/T.4 API source for version 1.00.
** 
**    Rev 1.5   12 Sep 1991 11:17:48   JIM
** Global update of T.30/T.4 API source for version 0.22B.
** 
**    Rev 1.4   08 Aug 1991 18:46:48   JIM
** Update to facilitate single session DLL version of API.
** 
**    Rev 1.1   20 May 1991 09:13:16   JIM
** Changes made to support Print and View modules.
** 
** 
**    Rev 1.0   13 May 1991 09:59:10   JIM
** Initial Revision
** 
** 
*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "zapi.h"
#include "fapi.h"
#include "rawglobl.h"
#include "rawclas1.h"
#include "rawerr.h"
#include "raw.h"

WORD  wXLItems;
WORD  wXLOldItems;
WORD  wXLCurItem;
HWND  hXLDlg;
BOOL  bXLStat;
BOOL  bFileName;
BOOL  bPageFill;

XMITLIST FAR *pXLDlg;            // Pointer to currently active Xmit List active.

static void NEAR           LoadCombos( HWND, WORD, WORD, WORD );
static int  NEAR           XLValidate( HWND hDlg );
static void NEAR           XLOpen( void );
static void NEAR           XLClose( void );
static void NEAR           XLDisp( void );
static int  NEAR           XLAdd( void );
static int  NEAR           XLCopy( HWND, HWND, int );
static XMITLIST FAR * NEAR XLItem( WORD );
static XMITLIST FAR * NEAR XLAlloc( HWND hWnd, GLOBALHANDLE *hListMem );

#pragma optimize("egl",off)  // Temporarily deactivates global optimization.
BOOL FAR PASCAL XmitListWndProc( HWND hDlg, WORD wMessage, WORD wParam, LONG lParam )
{
  switch ( wMessage )
  {
    case WM_INITDIALOG:
      hXLDlg = hDlg;

      // Load selections for combo boxes from string table.
      LoadCombos( hXLDlg, CD_SPEED, TD_SPEED_FIRSTIDX, TD_SPEED_LASTIDX );

      XLCopy( hDlg, hWndMain, wXLItems );
      XLOpen( );       // Activate first item for display.
      wXLOldItems = wXLItems;

      EnableWindow( GetDlgItem( hDlg, BD_PREV ), FALSE );
      if ( wXLItems == 1 )
      { // Disable buttons where only single page exists.
        EnableWindow( GetDlgItem( hDlg, BD_DELETE ), FALSE );
      }
      bPageFill =
      bFileName = FALSE;

      break;

    case WM_COMMAND:
      switch ( wParam )
      {
        case IDOK:
        {
          int iReturn = IDOK;

          // Validate numeric values and existence of fax file.
          if ( XLValidate( hDlg ) )
            return ( FALSE );

          // Transfer Xmit List entries in dialog property list up to 
          // main window.
          XLClose( );     // Unlock memory of current Xmit List item.

          // Delete Xmit List handles in main window.
          XLDel( hWndMain, 0, wXLOldItems );

          // Copy those in the local dialog property list upto main window.
          iReturn = XLCopy( hWndMain, hDlg, wXLItems );

          // Remove property list entries and associated global memory.
          XLDel( hDlg, 0, wXLItems );

          // Set the Xmit List status flag to TRUE indicating an adjustment in
          // the Xmit List.
          SetXLStat( TRUE );

          // Ready to return to main window!
          hXLDlg = NULL;
          EndDialog( hDlg, iReturn );

          break;
        }
        
        case IDCANCEL:
          // Discard local Xmit List entries.
          XLClose( );

          XLDel( hDlg, 0, wXLItems );
          wXLItems = wXLOldItems;   // Return item count to previous value.

          EndDialog( hDlg, IDCANCEL );
          break;
#ifdef DO_FAX
        // Display next item in Xmit List and save current.
        case BD_NEXT:
          // Validate numeric values and existence of fax file.
          if ( XLValidate( hDlg ) )
            return ( FALSE );

          // Is this the first item?
          if ( wXLCurItem == 1 )
          {
            EnableWindow( GetDlgItem( hDlg, BD_PREV ), TRUE );
            // Redraw without default button border.
            SendDlgItemMessage( hDlg, BD_PREV, BM_SETSTYLE, 
                                ( WORD ) BS_PUSHBUTTON, 1L );
          }

          // Is this a newly added item?
          if ( wXLItems == 1 )
          {
            EnableWindow( GetDlgItem( hDlg, BD_DELETE ), TRUE );
            // Redraw without default button border.
            SendDlgItemMessage( hDlg, BD_DELETE, BM_SETSTYLE, 
                                ( WORD ) BS_PUSHBUTTON, 1L );
          }

          if ( wXLCurItem == 1 || wXLItems == 1 )
            SendDlgItemMessage( hDlg, BD_NEXT, BM_SETSTYLE, 
                                ( WORD ) BS_DEFPUSHBUTTON, 1L );

          // Is this entry the last allowable according to the API?
          if ( wXLCurItem + 1 == ( WORD ) RFMaxTxEntries( ) )
          {
            SetFocus( GetDlgItem( hDlg, BD_PREV ) );
            EnableWindow( GetDlgItem( hDlg, BD_NEXT ), FALSE );
            SendDlgItemMessage( hDlg, BD_PREV, BM_SETSTYLE, 
                                ( WORD ) BS_DEFPUSHBUTTON, 1L );
          }
          if ( wXLCurItem + 1 > wXLItems )
          {
            if ( XLAdd( ) )
              SendMessage( hDlg, WM_COMMAND, IDCANCEL, 0L );
          }
          else
            XLItem( wXLCurItem + 1 );

          break;

        case BD_PREV:
          if ( !FileExists( hDlg, pXLDlg->szFileName, "Xmit List...", ED_FILENAME ) )
            return ( FALSE );

          // Enable next button if necessary.
          if ( !IsWindowEnabled( GetDlgItem( hDlg, BD_NEXT ) ) )
          {
            EnableWindow( GetDlgItem( hDlg, BD_NEXT ), TRUE );
            // Redraw without default button border.
            SendDlgItemMessage( hDlg, BD_NEXT, BM_SETSTYLE, 
                                ( WORD ) BS_PUSHBUTTON, 1L );
          }

          XLItem( wXLCurItem - 1 );

          // Is this the first page?
          if ( wXLCurItem == 1 )
          {
            SetFocus( GetDlgItem( hDlg, BD_NEXT ) );
            EnableWindow( GetDlgItem( hDlg, BD_PREV ), FALSE );
            SendDlgItemMessage( hDlg, BD_NEXT, BM_SETSTYLE, 
                                ( WORD ) BS_DEFPUSHBUTTON, 1L );
            return ( FALSE );  // Return FALSE since default focus was changed.
          }
          break;
        case BD_DELETE:
        {
          WORD uNewItem;

          // Choose next item to display after delete.
          uNewItem = ( wXLCurItem == wXLItems ? wXLCurItem - 1 : wXLCurItem );
          
          // Enable next button if necessary.
          if ( !IsWindowEnabled( GetDlgItem( hDlg, BD_NEXT ) ) )
          {
            EnableWindow( GetDlgItem( hDlg, BD_NEXT ), TRUE );
            SendDlgItemMessage( hDlg, BD_NEXT, BM_SETSTYLE, 
                                ( WORD ) BS_PUSHBUTTON, 1L );
          }

          XLDel( hDlg, wXLCurItem, 0 );
          XLItem( uNewItem );

          // Disable deletion button if only one Xmit List item remains.
          if ( wXLItems == 1 )
          {
            SetFocus( GetDlgItem( hDlg, BD_NEXT ) );
            EnableWindow( GetDlgItem( hDlg, BD_DELETE ), FALSE );
            SendDlgItemMessage( hDlg, BD_NEXT, BM_SETSTYLE, 
                                ( WORD ) BS_DEFPUSHBUTTON, 1L );
            return ( FALSE );
          }
          break;
        }

        case BD_ASCII:
          // Transfer control to another dialog.
          AsciForm( hDlg, &pXLDlg->AsciFormDlg );
          break;

        case ED_FILENAME:
          if ( HIWORD( lParam ) == EN_UPDATE )
          {
            bFileName = TRUE;
            GetDlgItemText( hDlg, ED_FILENAME, pXLDlg->szFileName, _MAX_PATH );
          }
          // EN_KILLFOCUS should only be processed if dialog is still valid.
          else if ( hXLDlg && HIWORD( lParam ) == EN_KILLFOCUS )
          {
					 if ( bFileName && FileExists( NULL, ( LPSTR ) pXLDlg->szFileName, 0L, 0 ) )
            {
              SetDlgItemText( hXLDlg, ED_FILENAME, pXLDlg->szFileName );
              SendDlgItemMessage( hXLDlg, ED_FILENAME, EM_SETSEL, 0, 
                                  MAKELONG( 0, 0x7fff ) );
              if ( IsFaxFile( pXLDlg->szFileName ) )
              {
                _fmemset( &pXLDlg->AsciFormDlg, 0, 
                          sizeof( XmitListDlg.AsciFormDlg ) );
                EnableWindow( GetDlgItem( hXLDlg, BD_ASCII ), FALSE );
              }
              else
              {
                pXLDlg->AsciFormDlg = XmitListDlg.AsciFormDlg;
                EnableWindow( GetDlgItem( hXLDlg, BD_ASCII ), TRUE );
              }
					 }
          }
          break;
#endif

        case CD_SPEED:
          if ( HIWORD( lParam ) == CBN_SELCHANGE )
            pXLDlg->iSpeed = ( int ) ( TD_SPEED_FIRSTIDX +
                             SendDlgItemMessage( hDlg, CD_SPEED, CB_GETCURSEL,
                             0, 0L ) );
          break;

        case BD_HARD:
          if ( HIWORD( lParam ) == BN_CLICKED )
            if ( ( BOOL ) SendDlgItemMessage( hDlg, BD_HARD, BM_GETCHECK, 0, 0L ) )
              pXLDlg->iMedia = TD_MEDIAHARD;
          break;

        case BD_FLOPPY:
          if ( HIWORD( lParam ) == BN_CLICKED )
            if ( ( BOOL ) SendDlgItemMessage( hDlg, BD_FLOPPY, BM_GETCHECK, 0, 0L ) )
              pXLDlg->iMedia = TD_MEDIAFLOPPY;
          break;

        case BD_ASIS:
          if ( HIWORD( lParam ) == BN_CLICKED )
            if ( ( BOOL ) SendDlgItemMessage( hDlg, BD_ASIS, BM_GETCHECK, 0, 0L ) )
              pXLDlg->iResolution = TD_RESASIS;
          break;

        case BD_STANDARD:
          if ( HIWORD( lParam ) == BN_CLICKED )
            if ( ( BOOL ) SendDlgItemMessage( hDlg, BD_STANDARD, BM_GETCHECK, 0, 0L ) )
              pXLDlg->iResolution = TD_RESSTAN;
          break;

        case BD_FINE:
          if ( HIWORD( lParam ) == BN_CLICKED )
            if ( ( BOOL ) SendDlgItemMessage( hDlg, BD_FINE, BM_GETCHECK, 0, 0L ) )
              pXLDlg->iResolution = TD_RESFINE;
          break;

        case BD_MERGE:
          if ( HIWORD( lParam ) == BN_CLICKED )
            pXLDlg->bfMerge = ( BYTE ) SendDlgItemMessage( hDlg, BD_MERGE,
                              BM_GETCHECK, 0, 0L );
          break;

        case BD_COVER:
          if ( HIWORD( lParam ) == BN_CLICKED )
            pXLDlg->bfCover = ( BYTE ) SendDlgItemMessage( hDlg, BD_COVER,
                              BM_GETCHECK, 0, 0L );
          break;

        case ED_PAGEFILL:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bPageFill = TRUE;
          break;

        default:
          return ( FALSE );
      }
    default:
      return ( FALSE );
  }
  return ( TRUE );
}
#pragma optimize("",on)  // Reactivates default optimization from CL.

int FAR XLInit( HWND hWnd, NPSTR szFileName )
{
  GLOBALHANDLE hListMem;
  XMITLIST FAR *pXLInitDlg;

  // Initialize Xmit List entries from configuration file.
  if ( FileExists( NULL, szFileName, 0L, 0 ) )
  {
    if ( XLLoad( hWnd, szFileName ) < 0 )
      return ( -1 );
  }
  else
  {
    if ( ( pXLInitDlg = XLAlloc( hWnd, &hListMem ) ) < 0 )
      return ( -1 );
    *pXLInitDlg = XmitListDlg;
    GlobalUnlock( hListMem );
  }
  SetXLStat( TRUE );

  return ( 0 );
}

//---------------------------------------------------------------------------
// Load Xmit List entries from the specified file...
//---------------------------------------------------------------------------
int FAR XLLoad( HWND hWnd, NPSTR szFileName )
{
  GLOBALHANDLE hListMem;
  XMITLIST FAR *pXLInitDlg;
  XMITLIST XLInitDlg;
  int iContinue;
  WORD wXLItemCnt = 0;

  XLDel( hWnd, 0, wXLItems );  // Delete current Xmit List entries.
  wXLItems = 0;

  while ( ( iContinue = XLRead( szFileName, &XLInitDlg ) ) > 0 )
  {
    if ( ( pXLInitDlg = XLAlloc( hWnd, &hListMem ) ) < 0 )
      return( -1 ); 

    *pXLInitDlg = XLInitDlg;
    GlobalUnlock( hListMem );  // Unlock memory allocated in XLAlloc.
  };

  return ( iContinue );
}  

//---------------------------------------------------------------------------
// Allocate memory and enter handle in property list.  Increment total 
// item count.
//--------------------------------------------------------------------------- 
static XMITLIST FAR * NEAR XLAlloc( HWND hWnd, GLOBALHANDLE *hListMem )
{
  if ( !( *hListMem = GlobalAlloc( GHND, ( DWORD ) sizeof( XMITLIST ) ) ) )
  {
    WRError( hWnd, "XLInit", IS_OUTOFMEM );
    return ( ( XMITLIST FAR * ) -1 );
  }

  // Save handle to moveable memory in property list of Xmit List dialog window.
  if ( !SetProp( hWnd, MAKEINTRESOURCE( ++wXLItems ), *hListMem ) )
  {
    WRError( hWnd, "XLInit", IS_PROPNOTADD );
    return ( ( XMITLIST FAR * ) -1 );
  }
  return ( ( XMITLIST FAR * ) GlobalLock( *hListMem ) );
}

// Access function for static variable.
WORD XLItems( void )
{
  return ( wXLItems );  
}

// Return total number remaining Xmit List items.
WORD XLDel( HWND hWnd, WORD wItem, WORD wItems )
{
  GLOBALHANDLE hListMem;
  WORD wItemIdx;

  if ( wItem )
  {
    hListMem = GetProp( hWnd, MAKEINTRESOURCE( wItem ) );

    if ( wItem == wXLCurItem )
    {
      GlobalUnlock( hListMem );   // Release current locked Xmit List item.
      pXLDlg = NULL;              // Clear pointer to Xmit List item.
      wXLCurItem = 0;             // Make current item unknown.
    }
    GlobalFree( hListMem );       // Free global memory.

    // Move property upper property list entries into entry to be deleted.
    for ( wItemIdx = wItem + 1; wItemIdx <= wXLItems; ++wItemIdx )
      SetProp( hXLDlg, MAKEINTRESOURCE( wItemIdx - 1 ), 
               GetProp( hXLDlg, MAKEINTRESOURCE( wItemIdx ) ) );

    // Remove last property list entry.                             
    RemoveProp( hXLDlg, MAKEINTRESOURCE( wXLItems ) );
    wXLItems--;                   // Reduce total of Xmit List items.
  }                               

  // Delete all property and entries and associated handles in 
  // main application window.
  else
  {
    for ( wItemIdx = 1; wItemIdx <= wItems; ++wItemIdx )
    {
      GlobalFree( GetProp( hWnd, MAKEINTRESOURCE( wItemIdx ) ) );
      RemoveProp( hWnd, MAKEINTRESOURCE( wItemIdx ) );
    }
  }
  return ( wXLItems );
}

// Return handle to Xmit List item or NULL if item in not entered in property
// list.
static XMITLIST FAR * NEAR XLItem( WORD wItem )
{
  GLOBALHANDLE hListMem;

  // Attempt to retrieve handle to requested Xmit List item, return NULL if
  // failed.
  if ( !( hListMem = GetProp( hXLDlg, MAKEINTRESOURCE( wItem ) ) ) )
    return( NULL );

  if ( wXLCurItem )
    GlobalUnlock( GetProp( hXLDlg, MAKEINTRESOURCE( wXLCurItem ) ) );
  pXLDlg = ( XMITLIST FAR * ) GlobalLock( hListMem );
  wXLCurItem = wItem;
  XLDisp( );

  return ( pXLDlg );
}

static VOID NEAR LoadCombos( HWND hDlg, WORD wComboId, WORD wBegResIdx, WORD wEndResIdx )
{
  WORD  i;

  for ( i = wBegResIdx; i <= wEndResIdx; ++i )
  {
    LoadString( hInst, i, szTmpStr, TMPSTRMAX );
    SendDlgItemMessage( hDlg, wComboId, CB_ADDSTRING, 0, ( DWORD ) ( LPSTR ) szTmpStr );
  }
}

// -------------------------------------------------------------------------
// Verify range of numeric data and existence of file.
//
// Return:  A return value of TRUE indicates an error, and FALSE that the
//          data validated is acceptable.
// -------------------------------------------------------------------------
static int NEAR XLValidate( HWND hDlg )
{
  if ( !FileExists( hDlg, pXLDlg->szFileName, "Xmit List...", ED_FILENAME ) )
    return ( TRUE );

  if ( bPageFill )
  {
    GetDlgItemText( hXLDlg, ED_PAGEFILL, szTmpStr, TMPSTRMAX );
    if ( ChkNumVal( hXLDlg, ED_PAGEFILL, szTmpStr, 0L, ( LONG ) PAGEFILLMAX,
                    IS_PAGEFILLMAX ) )
      return ( TRUE );
    pXLDlg->wPageFill = ( WORD ) ( atof( szTmpStr ) * 100 );
  }
  return ( FALSE );
}

static int NEAR XLCopy( HWND hWndTo, HWND hWndFr, int iSize )
{
  int iItem;
  XMITLIST FAR *TmpFr, FAR *TmpTo;
  GLOBALHANDLE hListMemTo, hListMemFr;

  for ( iItem = 1; iItem <= iSize; ++iItem )
  {
    if ( !( hListMemTo = GlobalAlloc( GHND, ( DWORD ) sizeof( XMITLIST ) ) ) )
    {
      MessageBox( hXLDlg, "GlobalAlloc: Out of memory.", 
                               "Function: XLCopy", MB_OK | MB_ICONEXCLAMATION );
      return ( -1 );
    }
    TmpTo = ( XMITLIST FAR * ) GlobalLock( hListMemTo );
    
    hListMemFr = GetProp( hWndFr, MAKEINTRESOURCE( iItem ) );
    if ( !( TmpFr = ( XMITLIST FAR * ) GlobalLock( hListMemFr ) ) )
    {
      MessageBox( hXLDlg, "GlobalLock: Out of memory.",
                               "Function: XLCopy", MB_OK | MB_ICONEXCLAMATION );
      return ( -1 );
    }
    *TmpTo = *TmpFr; // Copy of contents of Xmit List structure to local version.

    SetProp( hWndTo, MAKEINTRESOURCE( iItem ), hListMemTo );
    GlobalUnlock( hListMemFr );
    GlobalUnlock( hListMemTo );
  }
  return ( 0 );
}

static VOID NEAR XLOpen( void )
{
  XLItem( 1 );               // Lock first Xmit List item.
}

static VOID NEAR XLClose( void )
{
  GlobalUnlock( GetProp( hXLDlg, MAKEINTRESOURCE( wXLCurItem ) ) );
  wXLCurItem = 0;
}

static VOID NEAR XLDisp( void )
{
#ifdef DO_FAX
  // Initialize the File Name field:
  SetDlgItemText( hXLDlg, ED_FILENAME, ( LPSTR ) pXLDlg->szFileName );
  SendDlgItemMessage( hXLDlg, ED_FILENAME, EM_LIMITTEXT, _MAX_PATH, 0L );
  SendDlgItemMessage( hXLDlg, ED_FILENAME, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );

  // Initialize the Speed combo box field:
  SendDlgItemMessage( hXLDlg, CD_SPEED, CB_SETCURSEL, 
                      pXLDlg->iSpeed - TD_SPEED_FIRSTIDX, 0L );

  // Initialize the Media radio buttons:
  SendDlgItemMessage( hXLDlg, BD_HARD, BM_SETCHECK, 
                      ( pXLDlg->iMedia == TD_MEDIAHARD ), 0L );
  SendDlgItemMessage( hXLDlg, BD_FLOPPY, BM_SETCHECK, 
                      ( pXLDlg->iMedia == TD_MEDIAFLOPPY ), 0L );

  // Initialize the Resolution radio buttons:
  SendDlgItemMessage( hXLDlg, BD_ASIS, BM_SETCHECK, 
                      ( pXLDlg->iResolution == TD_RESASIS ), 0L );
  SendDlgItemMessage( hXLDlg, BD_STANDARD, BM_SETCHECK, 
                      ( pXLDlg->iResolution == TD_RESSTAN ), 0L );
  SendDlgItemMessage( hXLDlg, BD_FINE, BM_SETCHECK, 
                      ( pXLDlg->iResolution == TD_RESFINE ), 0L );

  // Initialize the Merge check box:                               
  SendDlgItemMessage( hXLDlg, BD_MERGE, BM_SETCHECK, ( WORD ) ( pXLDlg->bfMerge ), 0L );

  // Initialize the Cover Sheet check box:
  SendDlgItemMessage( hXLDlg, BD_COVER, BM_SETCHECK, ( WORD ) ( pXLDlg->bfCover ), 0L );

  // Initialize the ASCII format button:
  EnableWindow( GetDlgItem( hXLDlg, BD_ASCII ), !IsFaxFile( pXLDlg->szFileName ) );
  // Initialize the Page Fill edit field:
  SetDlgItemText( hXLDlg, ED_PAGEFILL, ( LPSTR ) AppendZero(
                  gcvt( ( double ) pXLDlg->wPageFill / 100, 4, szTmpStr ) ) );
  SendDlgItemMessage( hXLDlg, ED_PAGEFILL, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );

  // Update text "Item ## of ##" in dialog.
  sprintf( szTmpStr, "Item %2i of %2i", wXLCurItem, wXLItems );
  SetDlgItemText( hXLDlg, SD_ITEMNUM, ( LPSTR ) szTmpStr );

  bFileName = FALSE;
  bPageFill = FALSE;
#endif
}

static int NEAR XLAdd( void )
{
  GLOBALHANDLE hListMem;

  // Release currently locked XL dialog structure if it exists.
  if ( wXLItems )
    GlobalUnlock( GetProp( hXLDlg, MAKEINTRESOURCE( wXLCurItem ) ) );

  // Allocate moveable memory of Xmit List structure.
  if ( !( hListMem = GlobalAlloc( GHND, ( DWORD ) sizeof( XMITLIST ) ) ) )
  {
    MessageBox( hXLDlg, "GlobalAlloc: Out of memory.",
                "Function: XLAdd", MB_OK | MB_ICONEXCLAMATION );
    return ( -1 );
  }

  // Save handle to moveable memory in property list of Xmit List dialog window.
  if ( !SetProp( hXLDlg, MAKEINTRESOURCE( ++wXLItems ), hListMem ) )
  {
    MessageBox( hXLDlg, "SetProp: Handle to resource not added.", 
                "Function: XLAdd", MB_OK | MB_ICONEXCLAMATION );
    return ( -1 );
  }

  // Lock data for use.
  pXLDlg = ( XMITLIST FAR * ) GlobalLock( hListMem );
  *pXLDlg = XmitListDlg;  // Intialize values of new Xmit List item.
  wXLCurItem = wXLItems;  // Make Xmit List item last item.
  XLDisp( );              // Display Xmit List item.
  SendDlgItemMessage( hXLDlg, ED_FILENAME, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );
                          // Highlight File Name field.
  return ( 0 );
}
//---------------------------------------------------------------------------
// Create a list box containing the file names entered in the Transmit List.
//
// Return handle of list box if successful, 0 if creation of list box 
// was unsuccessful.
// 
// PARM1 - Handle of the window containing the property list entries
//         representing the global memory handles to the XMITLIST structures.
//---------------------------------------------------------------------------        
HWND XLOpenLB( HWND hWnd )
{
#ifdef DO_FAX
  HWND hWndListBox;
  WORD wXLIdxMax = XLItems( );
  WORD wXLIdx;
  XMITLIST FAR *pXLItem;
  char szFileName[ _MAX_PATH ];

  if ( !( hWndListBox =
	       CreateWindow( "listbox", NULL, WS_CHILD, 0, 0, 0, 0, hWnd,
				               1, hInst, NULL ) ) )
	 return ( 0 );

  // Make received file if its exists the first in the list.
  lstrcpy( ( LPSTR ) szFileName, ReceiveDlg.szFileName );
  if ( FileExists( NULL, szFileName, NULL, NULL ) )
	 SendMessage( hWndListBox, LB_ADDSTRING, 0, ( LONG ) ( LPSTR ) szFileName );

  for ( wXLIdx = 1; wXLIdx <= wXLIdxMax; ++wXLIdx )
  {
	 pXLItem = GetXLItem( hWnd, wXLIdx, TRUE );
	 if ( !pXLItem )
		 return ( 0 );

	 if ( IsFaxFile( pXLItem->szFileName ) )
	   SendMessage( hWndListBox, LB_ADDSTRING, 0, ( LONG ) pXLItem->szFileName );

	 GetXLItem( hWnd, wXLIdx, FALSE );   // Unlock global memory.
  }

  return ( hWndListBox );
#else
  return (0);
#endif
}

//---------------------------------------------------------------------------
// Destroy the list box containing the file names entered in the Transmit
// List.
//	
// Return 0 if successful and -1 if not.
//
// PARM1 - Handle of the list box to destroy.
//---------------------------------------------------------------------------
int XLCloseLB( HWND hWnd )
{
  if ( !DestroyWindow( hWnd ) )
    return ( 0 );
  return ( -1 );
}

//---------------------------------------------------------------------------
// Return a far pointer to the XMITLIST structure.
//
// PARM1 - Handle to window with XMITLIST memory handles in the property list
// PARM2 - Index of desired XMITLIST item.
// PARM3 - TRUE lock memory associated with the XMITLIST handle retreived.
//         FALSE unlock memory associated with the XMITLIST handle retrieved.
//---------------------------------------------------------------------------
XMITLIST FAR *GetXLItem( HANDLE hWnd, WORD wXLIdx, BOOL bLock )
{
  GLOBALHANDLE hXLItem;
  XMITLIST FAR *pXLItem;

  if ( bLock )
  {
    hXLItem = GetProp( hWnd, MAKEINTRESOURCE( wXLIdx ) );
    pXLItem = ( XMITLIST FAR * ) GlobalLock( hXLItem );

    if ( !pXLItem )
	   return ( 0 );
	 return ( pXLItem );
  }
  else
  {
    hXLItem = GetProp( hWnd, MAKEINTRESOURCE( wXLIdx ) );
	 GlobalUnlock( hXLItem );
	 return ( 0 );
  }
}

//--------------------------------------------------------------------------
// Toggle the status of the Xmit List change flag.  This is used in determining
// if the List has been amended since the last transmission.
// 
// No parameters required.
//--------------------------------------------------------------------------
VOID SetXLStat( BOOL bNewStat )
{
  bXLStat = bNewStat;
}

BOOL GetXLStat( VOID )
{
  return ( bXLStat );
}

