/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:   
**	Last PVCS update: $Date:   12 Aug 1992 19:58:32  $ 
*/

/*
**	TITLE:		rawdlg3.c
**
**	FACILITY:
**
**	MODULE DESCRIPTION:
**
*/

/*
**
**	Revision History:
**
**		$Log:   D:/api_lib/rawdlg3.c_v  $
 * 
 *    Rev 1.0   12 Aug 1992 19:58:32   Robert Chen
 * Initial revision.
** 
**    Rev 1.6   17 Oct 1991 10:40:32   JIM
** Global update of T.30/T.4 API source for version 1.00.
** 
**    Rev 1.5   12 Sep 1991 11:17:52   JIM
** Global update of T.30/T.4 API source for version 0.22B.
** 
**    Rev 1.4   08 Aug 1991 18:46:54   JIM
** Update to facilitate single session DLL version of API.
** 
**    Rev 1.1   20 May 1991 09:14:10   JIM
** No change.
** 
**    Rev 1.0   13 May 1991 10:00:34   JIM
** Initial Revision
** 
** 
*/
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "zapi.h"
#include "fapi.h"
#include "rawglobl.h"
#include "rawsdio.h"
#include "rawclas1.h"
#include "rawerr.h"
#include "raw.h"

int AsciForm( HWND hDlg, ASCIFORM FAR *pAFItem )
{
  return ( CallDialog( "AsciForm", AsciFormWndProc, ( hDlg ? hDlg : hWndMain ),
           ( LONG ) pAFItem ) );
}

#pragma optimize("egl",off)  // Temporarily deactivates global optimization.
BOOL FAR PASCAL AsciFormWndProc( HWND hDlg, WORD wMessage, WORD wParam, LONG lParam )
{
  static BOOL bPageLen;
  static BOOL bTabStop;
  static BOOL bLeft;
  static BOOL bRight;
  static BOOL bTop;
  static BOOL bBottom;

  static ASCIFORM Tmp;
  static ASCIFORM FAR *pAsciFormDlg;

  switch ( wMessage )
  {
    case WM_INITDIALOG:
      pAsciFormDlg = ( ASCIFORM FAR * ) lParam;
      Tmp = *pAsciFormDlg;

      // Initialize dialog resources to current values.

      // Check box:
      SendDlgItemMessage( hDlg, BD_RAMFILE, BM_SETCHECK, Tmp.bfRAMFile, 0L );
      SendDlgItemMessage( hDlg, BD_WRAP, BM_SETCHECK, Tmp.bfWrap, 0L );

      // Edit fields:
      SetDlgItemText( hDlg, ED_PAGELEN, 
                      ( LPSTR ) AppendZero( 
                      gcvt( ( double ) Tmp.wPageLen / 100, 4, szTmpStr ) ) );
      SetDlgItemText( hDlg, ED_TABSTOP,
                      ( LPSTR ) ltoa( ( LONG ) Tmp.wTabStop, szTmpStr, 10 ) );
      SetDlgItemText( hDlg, ED_LEFT, ( LPSTR ) AppendZero( 
                      gcvt( ( double ) Tmp.wLeft / 100, 3, szTmpStr ) ) );
      SetDlgItemText( hDlg, ED_RIGHT, ( LPSTR ) AppendZero( 
                      gcvt( ( double ) Tmp.wRight / 100, 3, szTmpStr ) ) );
      SetDlgItemText( hDlg, ED_TOP, ( LPSTR ) AppendZero (
                      gcvt( ( double ) Tmp.wTop / 100, 3, szTmpStr ) ) );
      SetDlgItemText( hDlg, ED_BOTTOM, ( LPSTR ) AppendZero ( 
                      gcvt( ( double ) Tmp.wBottom / 100, 3, szTmpStr ) ) );

      // Edit field text selections:
      SendDlgItemMessage( hDlg, ED_PAGELEN, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );
      SendDlgItemMessage( hDlg, ED_TABSTOP, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );
      SendDlgItemMessage( hDlg, ED_LEFT,    EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );
      SendDlgItemMessage( hDlg, ED_RIGHT,   EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );
      SendDlgItemMessage( hDlg, ED_TOP,     EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );
      SendDlgItemMessage( hDlg, ED_BOTTOM,  EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );

      SetFocus( GetDlgItem( hDlg, IDOK ) );
      return ( FALSE );

    case WM_COMMAND:
      switch ( wParam )
      {
        case IDOK:
          if ( bPageLen )
          {
            GetDlgItemText( hDlg, ED_PAGELEN, ( LPSTR ) szTmpStr, TMPSTRMAX );
            if ( ChkNumVal( hDlg, ED_PAGELEN, szTmpStr, 0L,
                            ( LONG ) PAGELENMAX, IS_PAGELENMAX ) )
              break;
            Tmp.wPageLen = ( unsigned ) ( atof( szTmpStr ) * 100 );
          }
          if ( bTabStop )
          {
            GetDlgItemText( hDlg, ED_TABSTOP, ( LPSTR ) szTmpStr, TMPSTRMAX );
            if ( ChkNumVal( hDlg, ED_TABSTOP, szTmpStr, 0L,
                            ( LONG ) TABSTOPMAX, IS_TABSTOPMAX ) )
              break;
            Tmp.wTabStop = ( unsigned ) atol( szTmpStr );
          }
          if ( bLeft )
          {
            GetDlgItemText( hDlg, ED_LEFT, ( LPSTR ) szTmpStr, TMPSTRMAX );
            if ( ChkNumVal( hDlg, ED_LEFT, szTmpStr, 0L,
                            ( LONG ) LTMARMAX, IS_LTMARMAX ) )
              break;
            Tmp.wLeft = ( unsigned ) ( atof( szTmpStr ) * 100 );
          }
          if ( bRight )
          {
            GetDlgItemText( hDlg, ED_RIGHT, ( LPSTR ) szTmpStr, TMPSTRMAX );
            if ( ChkNumVal( hDlg, ED_RIGHT, szTmpStr, 0L,
                            ( LONG ) RTMARMAX, IS_RTMARMAX ) )
              break;
            Tmp.wRight = ( unsigned ) ( atof( szTmpStr ) * 100 );
          }
          if ( bTop )
          {
            GetDlgItemText( hDlg, ED_TOP, ( LPSTR ) szTmpStr, TMPSTRMAX );
            if ( ChkNumVal( hDlg, ED_TOP, szTmpStr, 0L,
                            ( LONG ) TPMARMAX, IS_TPMARMAX ) )
              break;
            Tmp.wTop = ( unsigned ) ( atof( szTmpStr ) * 100 );
          }
          if ( bBottom )
          {
            GetDlgItemText( hDlg, ED_BOTTOM, ( LPSTR ) szTmpStr, TMPSTRMAX );
            if ( ChkNumVal( hDlg, ED_BOTTOM, szTmpStr, 0L,
                            ( LONG ) BTMARMAX, IS_BTMARMAX ) )
              break;
            Tmp.wBottom = ( unsigned ) ( atof( szTmpStr ) * 100 );
          }

          *pAsciFormDlg = Tmp;   // Save final values in global variable.
          EndDialog( hDlg, IDOK );
          break;

        case IDCANCEL:
          EndDialog( hDlg, IDCANCEL );
          break;

        case BD_RAMFILE:
          if ( HIWORD( lParam ) == BN_CLICKED )
            Tmp.bfRAMFile = ( BYTE ) !Tmp.bfRAMFile;
          break;

        case BD_WRAP:
          if ( HIWORD( lParam ) == BN_CLICKED )
            Tmp.bfWrap = ( BYTE ) !Tmp.bfWrap;
          break;

        case ED_PAGELEN:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bPageLen = TRUE;
          break;

        case ED_TABSTOP:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bTabStop = TRUE;
          break;

        case ED_LEFT:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bLeft = TRUE;
          break;

        case ED_RIGHT:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bRight = TRUE;
          break;

        case ED_TOP:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bTop = TRUE;
          break;

        case ED_BOTTOM:
          if ( HIWORD( lParam ) == EN_UPDATE )
            bBottom = TRUE;
          break;

        default:
          return ( FALSE );
      }
    default:
      return ( FALSE );
  }
}
#pragma optimize("",on)  // Reactivates default optimization from CL.




