/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:   
**	Last PVCS update: $Date:   20 Aug 1992  0:24:20  $ 
*/

/*
**	TITLE:		rawutil2.c
**
**	FACILITY:
**
**	MODULE DESCRIPTION:
**
*/

/*
**
**	Revision History:
**
**		$Log:   D:/api_lib/rawdutl1.c_v  $
 * 
 *    Rev 1.2   20 Aug 1992  0:24:20   Robert Chen
 * 
 *    Rev 1.1   19 Aug 1992 18:20:40   Robert Chen
** 
**    Rev 1.8   09 Jul 1992 19:19:02   JIM
** Global update of T.30/T.4 API (FAPI) source for version 1.05.
** 
**    Rev 1.7   29 Apr 1992 16:31:40   JIM
** Global update of T.30/T.4 API (FAPI) source for version 1.03.
** 
**    Rev 1.6   27 Apr 1992 15:58:30   JIM
** Global update of T.30/T.4 API (FAPI) source for version 1.02.
** 
**    Rev 1.6   27 Apr 1992 11:28:30   JIM
** Global update of T.30/T.4 API source for version 1.01.
** 
**    Rev 1.5   02 Apr 1992 15:11:32   JIM
** Global update of T.30/T.4 API source for version 1.01.
** 
**    Rev 1.4   17 Oct 1991 10:40:58   JIM
** Global update of T.30/T.4 API source for version 1.00.
** 
**    Rev 1.3   12 Sep 1991 11:18:20   JIM
** Global update of T.30/T.4 API source for version 0.22B.
** 
**    Rev 1.2   08 Aug 1991 18:47:26   JIM
** Update to facilitate single session DLL version of API.
** 
**    Rev 1.1   20 May 1991 09:14:46   JIM
** 
**    Rev 1.0   13 May 1991 09:47:50   JIM
** Initial Revision
** 
** 
*/
#include <windows.h>
#include <stdlib.h>  
#include <stdio.h>   
#include <string.h>
#include "rawglobl.h"
#include "rawclas1.h"
#include "rawsdio.h"
#include "rawerr.h"
#include "fapi.h"

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int FAR PASCAL DisableMenuItems( HWND hWnd, BOOL bStatus, WORD wDeduct )
{
  HMENU hMenu = GetMenu( hWnd );
  WORD wMenuAct;
  int iMenuCount;
  int iReturn;

  wMenuAct = MF_BYPOSITION | ( bStatus ? MF_GRAYED : MF_ENABLED );

  for ( iMenuCount = iReturn = GetMenuItemCount( hMenu ) - 1 - wDeduct; 
        iMenuCount >= 0; --iMenuCount )
    EnableMenuItem( hMenu, iMenuCount, wMenuAct );

  DrawMenuBar( hWnd );
  return ( iReturn );
}

//---------------------------------------------------------------------------
//  FUNCTION   : FileExists(pch)           
//
//  PURPOSE    : Checks to see if a file exists with the path/filename 
//               described by the string pointed to by 'pch'.          
//
//  RETURNS    : TRUE  - if the described file does exist.             
//               FALSE - otherwise.                                    
//---------------------------------------------------------------------------
BOOL FAR PASCAL FileExists( HWND hWnd, LPSTR szFileName, LPSTR szWindowTitle, WORD wDlgId )
{
  OFSTRUCT ofStruct;

  if ( OpenFile( szFileName, &ofStruct, OF_EXIST ) == -1 )
  {
    if ( hWnd )
    {
      WRError( hWnd, szWindowTitle, IS_CANTFIND, 
               fRightStr( szFileName, _MAX_PATH / 4 ) );
      SetFocus( GetDlgItem( hWnd, wDlgId ) );  
      SetActiveWindow( hWnd );
      SendDlgItemMessage( hWnd, wDlgId, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );
    }
    return ( FALSE );
  }
  lstrcpy( szFileName, ofStruct.szPathName );
  _fstrlwr( szFileName );
  return ( TRUE );
}

BOOL FAR PASCAL FileValidate( HWND hWnd, LPSTR szFileName, LPSTR szWindowTitle, WORD wDlgId )
{
  OFSTRUCT ofFileData;

  if ( OpenFile( szFileName, ( LPOFSTRUCT ) &ofFileData, OF_PARSE ) == -1 )
  {
    WRError( hWnd, szWindowTitle, IS_ILLFNM, 
             fRightStr( szFileName, _MAX_PATH / 4 ) );
    SetFocus( GetDlgItem( hWnd, wDlgId ) );  
    SetActiveWindow( hWnd );
    SendDlgItemMessage( hWnd, wDlgId, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );

    return ( FALSE );
  }
  return ( TRUE );
}

LPSTR FAR PASCAL fRightStr( LPSTR szStr, WORD wNumChars )
{
  WORD wStrLen;

  wStrLen   = lstrlen( szStr );
  wNumChars = min( wStrLen, wNumChars );

  return ( szStr + wStrLen - wNumChars );
}

NPSTR FAR PASCAL RightStr( NPSTR szStr, WORD wNumChars )
{
  WORD wStrLen;

  wStrLen   = strlen( szStr );
  wNumChars = min( wStrLen, wNumChars );

  return ( szStr + wStrLen - wNumChars );
}

int FAR PASCAL ChkNumVal( HWND hWnd, int iResId, LPSTR szStrNum, LONG lMinVal, LONG lMaxVal, 
                          int iErrCode )
{
  double fCurVal;

  lstrcpy( szTmpStr, szStrNum );
  fCurVal = atof( szTmpStr );

  if ( fCurVal > ( double ) lMaxVal || fCurVal < ( double ) lMinVal )
  {
    WRError( hWnd, "ChkNumVal", iErrCode, lMinVal, lMaxVal );
    SendDlgItemMessage( hWnd, iResId, EM_SETSEL, 0, MAKELONG( 0, 0x7fff ) );
    SetFocus( GetDlgItem( hWnd, iResId ) );
    SetActiveWindow( hWnd );
    return ( -1 );
  }
  return ( 0 );
}

LPSTR FAR PASCAL AppendZero( LPSTR szNumStr )
{
  if ( szNumStr[ lstrlen( szNumStr ) - 1 ] == '.' )
    lstrcat( szNumStr, "0" );
  if ( !_fstrstr( szNumStr, "." ) )
    lstrcat( szNumStr, ".0" );

  return ( szNumStr );
}

int FAR PASCAL CheckCom( WORD wComPort )
{
  int iErrorCode;
  static char szComStr[][ 5 ] = { COM1, COM2, COM3, COM4 };

  if ( wComPort > COMPORTMAX )
    return ( IE_HARDWARE );     // Return code indicating COM port not supported.

  if ( ( iErrorCode = OpenComm( szComStr[ wComPort ], 1, 1 ) ) < 0 )
    return ( iErrorCode );      // Return IE_ error code.

  CloseComm( iErrorCode );
  return ( 0 );
}

