#include <windows.h>
#include <stdlib.h>  
#include <stdio.h>   
#include <string.h>  
#include "zapi.h"
#include "rawglobl.h"
#include "rawerr.h"

// --------------------------------------------------------------------------
// These functions are linked locally since the ellipsis operator may not be
// used in exported functions.  The string table is embedded in each module
// to simplify development.  
//
// IS_APPNAME must be defined in the STRINGTABLE of the calling application.
// --------------------------------------------------------------------------
int _cdecl WRError( HWND hWnd, LPSTR szFunction, WORD id, ... )
{
  char szMsg[ TMPSTRMAX * 2 ];
  char szFmt[ TMPSTRMAX ];

  LoadString( GetWindowWord( hWnd, GWW_HINSTANCE ), id, szFmt, 
              sizeof( szFmt ) );
  if ( _fstrstr( szFmt, "%" ) )  // Check for formatting characters.
    wvsprintf( szMsg, szFmt, ( LPSTR )( &id + 1 ) );
  else
    lstrcpy( szMsg, szFmt );

  LoadString( GetWindowWord( hWnd, GWW_HINSTANCE ), IS_APPNAME, szFmt, 
              sizeof( szFmt ) );
  lstrcat( szFmt, ", Function - " );
  lstrcat( ( LPSTR ) szFmt, szFunction );

  return ( MessageBox( hWnd, szMsg, szFmt, MB_OK | MB_ICONEXCLAMATION ) );
}

LPSTR _cdecl StrError( HWND hWnd, NPSTR szFunction, WORD id, ... )
{
  static char szFmt[ TMPSTRMAX ];
  char szMsg[ TMPSTRMAX ];

  LoadString( GetWindowWord( hWnd, GWW_HINSTANCE ), id, szFmt, 
              sizeof( szFmt ) );
  if ( strstr( szFmt, "%" ) )  // Check for formatting characters.
    wvsprintf( szMsg, szFmt, ( LPSTR )( &id + 1 ) );
  else
    lstrcpy( szMsg, szFmt );

  lstrcpy( szFmt, "Function: " );
  lstrcat( szFmt, szFunction );
  lstrcat( szFmt, ", " );
  lstrcat( szFmt, szMsg );
  lstrcat( szFmt, "\n" );

  return ( szFmt );
}

