/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:   
**	Last PVCS update: $Date:   12 Aug 1992 20:06:56  $ 
*/

/*
**	TITLE:		rawerr.h
**
**	FACILITY:
**    Windows Error Reporting Module
**
**	MODULE DESCRIPTION:
**    This header file should be included by all code modules which must
**    report errors in a dialog box using the function WRError.  All
**    error codes are made global by including a copy of this header file
**    in the resource scripts of all modules.  The object modules for 
**    the error reporting function WRError are linked into all Windows
**    DLL's and EXE's to allow the use of the ellipsis operator (FAR
**    PASCAL functions may not use this operator).
*/

/*
**
**	Revision History:
**
**		$Log:   D:/api_lib/rawerr.h_v  $
   
      Rev 1.0   12 Aug 1992 20:06:56   Robert Chen
   Initial revision.
** 
**    Rev 1.4   17 Oct 1991 10:42:40   JIM
** Global update of T.30/T.4 API source for version 1.00.
** 
**    Rev 1.3   12 Sep 1991 11:20:12   JIM
** Global update of T.30/T.4 API source for version 0.22B.
** 
**    Rev 1.2   08 Aug 1991 18:49:12   JIM
** Update to facilitate single session DLL version of API.
** 
**    Rev 1.1   20 May 1991 09:14:18   JIM
** 
**    Rev 1.0   13 May 1991 10:02:50   JIM
** Initial Revision
** 
** 
*/
// General error messages Id's (200 - 349):
#define IS_CANTOPEN	    257
#define IS_CANTREAD	    258
#define IS_CANTCREATE	  259
#define IS_CANTWRITE    260
#define IS_ILLFNM	      261
#define IS_ADDEXT	      262
#define IS_CLOSESAVE	  263
#define IS_CANTFIND	    264
#define IS_HELPNOTAVAIL 265

#define IS_CLIENTTITLE  266
#define IS_UNTITLED	    267

#define IS_PRINTJOB	    268
#define IS_PRINTERROR	  269
#define IS_NOSTDIOINIT  270
#define IS_OUTOFMEM     271
#define IS_OUTOFLOCALMEM 272
#define IS_REOUTOFMEM   273
#define IS_NOLOCK       274
#define IS_NOFREE       275
#define IS_LISTBOXERR   276
#define IS_PROPNOTADD   277
#define IS_DCBINITERROR 278
#define IS_UPCSERROR    279
#define IS_XMITQUEFULL  280
#define IS_RXFLUSHERROR 281
#define IS_TXFLUSHERROR 282
#define IS_PAGEFILL     283
#define IS_XMITBUFLIM   284
#define IS_RECVBUFLIM   285
#define IS_RECVTOMAX    286
#define IS_FBTHOLDMAX   287
#define IS_PAGELENMAX   288
#define IS_TABSTOPMAX   289
#define IS_LTMARMAX     290
#define IS_RTMARMAX     291
#define IS_TPMARMAX     292
#define IS_BTMARMAX     293
#define IS_PAGEFILLMAX  294
#define IS_SCRBUFLIM    295
#define IS_SESSIONINUSE 296
#define IS_SESSIONNOUSE 297
#define IS_SESSIONNOMEM 298
#define IS_EXTDATANOMEM 299
#define IS_NONEG        300
#define IS_NODIALSTR    301
#define IS_UNDERCNSTRCT 302
#define IS_DIALOGCALL   303
#define IS_VOICEPOLL    304

#define IS_APPNAME      400  // This string constant is defined in the module
                             // using these error codes.
#ifdef RC_INVOKED
  /* Error Flags */
  #define CE_RXOVER	    0x0001  // Receive Queue overflow
  #define CE_OVERRUN	  0x0002  // Receive Overrun Error 
  #define CE_RXPARITY	  0x0004  // Receive Parity Error	 
  #define CE_FRAME	    0x0008  // Receive Framing error 
  #define CE_BREAK	    0x0010  // Break Detected
  #define CE_CTSTO	    0x0020  // CTS Timeout	 
  #define CE_DSRTO	    0x0040  // DSR Timeout	 
  #define CE_RLSDTO	    0x0080  // RLSD Timeout	 
  #define CE_TXFULL	    0x0100  // TX Queue is full
  #define CE_PTO		    0x0200  // LPTx Timeout		 
  #define CE_IOE		    0x0400  // LPTx I/O Error	 
  #define CE_DNS		    0x0800  // LPTx Device not selected
  #define CE_OOP		    0x1000  // LPTx Out-Of-Paper	
  #define CE_MODE 	    0x8000  // Requested mode unsupported

  #define IE_BADID	    (-1)    // Invalid or unsupported id 
  #define IE_OPEN 	    (-2)    // Device Already Open 
  #define IE_NOPEN	    (-3)    // Device Not Open
  #define IE_MEMORY	    (-4)    // Unable to allocate queues
  #define IE_DEFAULT	  (-5)    // Error in default parameters
  #define IE_HARDWARE	  (-10)   // Hardware Not Present
  #define IE_BYTESIZE	  (-11)   // Illegal Byte Size
  #define IE_BAUDRATE	  (-12)   // Unsupported BaudRate	
#endif /* RC_INVOKED */

// --------------------------------------------------------------------------
// These functions must be statically linked to the modules in which they
// are required, due to the use of the ellipsis operator.  The "cdecl" calling
// convention is required for functions with "..." parameter lists and 
// consequently may not be placed in DLL's.
// --------------------------------------------------------------------------
int   _cdecl WRError( HWND, LPSTR, WORD, ... );
LPSTR _cdecl StrError( HWND, NPSTR, WORD, ... );


