/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:   
**	Last PVCS update: $Date:   12 Aug 1992 20:07:02  $ 
*/

/*
**	TITLE:		rawglobl.h
**
**	FACILITY:
**    Windows Global Constants
**
**	MODULE DESCRIPTION:
**    This header file should be included in ALL modules, both application
**    and DLL.
*/

/*
**
**	Revision History:
**
**		$Log:   D:/api_lib/rawglobl.h_v  $
   
      Rev 1.0   12 Aug 1992 20:07:02   Robert Chen
   Initial revision.
** 
**    Rev 1.4   17 Oct 1991 10:42:44   JIM
** Global update of T.30/T.4 API source for version 1.00.
** 
**    Rev 1.3   12 Sep 1991 11:20:16   JIM
** Global update of T.30/T.4 API source for version 0.22B.
** 
**    Rev 1.2   08 Aug 1991 18:49:16   JIM
** Update to facilitate single session DLL version of API.
** 
**    Rev 1.1   20 May 1991 09:14:18   JIM
** 
**    Rev 1.0   13 May 1991 10:02:50   JIM
** Initial Revision
** 
** 
*/
#ifndef _TIMEB_DEFINED
  #include <sys\timeb.h>
#endif

//--------------------------------------------------------------------------
// Logfile status constants:
//--------------------------------------------------------------------------
#define ATCMLOGOUT  0x0001  // 0000000?
#define HDLCLOGOUT  0x0002  // 000000?0
#define WARNLOGOUT  0x0004  // 00000?00
#define DEVLLOGOUT  0x0008  // 0000?000

#define ATCMBITNUM  0
#define HDLCBITNUM  1
#define WARNBITNUM  2
#define DEVLBITNUM  3

//--------------------------------------------------------------------------
// Miscellaneous constants:
//--------------------------------------------------------------------------
typedef unsigned char far * LPUSTR;

#define YES    TRUE
#define NO     FALSE

#define ID(x)              GetWindowWord( x,GWW_ID )
#define PARENT(x)          GetWindowWord( x,GWW_HWNDPARENT )
#define INSTANCE(x)        GetWindowWord( x,GWW_HINSTANCE )
#define CLRBIT( word, bit ) ( word &= ~( 1 << bit ) )         

#ifndef _MAX_PATH
  #define _MAX_PATH 128
#endif

#ifndef TMPSTRMAX
  #define TMPSTRMAX 128
#endif

#ifndef ERRSTRMAX
  #define ERRSTRMAX 128
#endif

#ifndef CAPSTRMAX
  #define CAPSTRMAX 81
#endif

#ifndef PROFILESTRMAX
  #define PROFILESTRMAX 15
#endif

#define DEFFSRCHMAX   6

// COMx port constants used in Communication Service Routines:
#define COM1  "com1"
#define COM2  "com2"
#define COM3  "com3"
#define COM4  "com4"
#define COMPORTMAX    3  // 0 = COM1, 1 = COM2, ...
#define COMMSETTINGS  "com1:96,n,8,1"
#define COMDRIVER     "COMM.DRV"
#define SYSTEMINI     "SYSTEM.INI"

typedef struct ExtDataTag
{
  WORD  wComPort;
  WORD  wRecvBuf;
  WORD  wXmitBuf;
  WORD  wLogOutStat;
  BYTE  bfXonXoff : 1; //0000000?
  BYTE  bfRtsCts : 1;  //000000?0
  HWND  hWndMain;

  struct timeb tbTimeStart;
  int   iPortId;
  DCB   CommDCB;
} EXTDATA;

typedef EXTDATA * NPEXTDATA;
typedef EXTDATA FAR * LPEXTDATA;
typedef COMSTAT * NPCOMSTAT;
typedef COMSTAT FAR * LPCOMSTAT;
typedef DCB     * NPDCB;
typedef DCB FAR * LPDCB;

//--------------------------------------------------------------------------
// Variables global to application, declared in wrdata.c:
//--------------------------------------------------------------------------
extern HWND   hWndMain;      
extern HANDLE hAccelMain;
extern HANDLE hInst;         
extern WORD   wCurrOutStat;  
extern BOOL   bAbortReq;
extern int    DOSerrnum;
extern int    iOldComPort;
extern char   szDefFileSrch[ DEFFSRCHMAX ];
extern char   szTmpStr[ TMPSTRMAX ];
extern char   szErrStr[ ERRSTRMAX ];
extern char   szTmpStr0[ TMPSTRMAX * 2 ];
extern char   szTmpStr1[ TMPSTRMAX ];
extern char   szTmpStr2[ TMPSTRMAX ];
extern char   szTmpStr3[ TMPSTRMAX ];

// -------------------------------------------------------------------------
// Function Prototypes:
// -------------------------------------------------------------------------

// File: rawio.c
int             ROpen( LPSTR, int, OFSTRUCT * );
int             RCreate( LPSTR, OFSTRUCT * );
int             RDelete( LPSTR );
int             RClose( int );
int             RRead( int, LPSTR, WORD );
int             RWrite( int, LPSTR, WORD );
LONG            RSeek( int, LONG, int );

// File: rawdlg1.c
void            EnableCancel( HWND );
void            DisableCancel( HWND, BOOL );
void            EnableClose( HWND );
void            DisableClose( HWND );

// File: rawtutl1.c
int             UpdateExtData( LPEXTDATA );
int             SaveLogFile( void );
LPSTR           GetConfStr( NPSTR );
LPSTR           GetDialStr( NPSTR );
void            TestStdio( unsigned );
int             CallDialog( char *, FARPROC, HWND, LONG );
BOOL            APIFaxPollChk( void );
BOOL            IsVCON( void );
void            SetLastVState( void );

