/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:   
**	Last PVCS update: $Date:   12 Aug 1992 19:59:14  $ 
*/

/*
**	TITLE:		rawio.c
**
**	FACILITY:
**
**	MODULE DESCRIPTION:
**
*/

/*
**
**	Revision History:
**
**		$Log:   D:/api_lib/rawio.c_v  $
 * 
 *    Rev 1.0   12 Aug 1992 19:59:14   Robert Chen
 * Initial revision.
** 
**    Rev 1.5   17 Oct 1991 10:41:06   JIM
** Global update of T.30/T.4 API source for version 1.00.
** 
**    Rev 1.4   12 Sep 1991 11:18:30   JIM
** Global update of T.30/T.4 API source for version 0.22B.
** 
**    Rev 1.3   08 Aug 1991 18:47:34   JIM
** Update to facilitate single session DLL version of API.
** 
**    Rev 1.0   13 May 1991 09:56:04   JIM
** Initial Revision
** 
** 
*/
#include <windows.h>
#include <io.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include "zapi.h"
#include "fapi.h"
#include "rawglobl.h"
#include "rawerr.h"
#include "raw.h"

int ROpen( LPSTR szPath, int iMethod, OFSTRUCT *pofStruct )
{
  int iReturn;

  if ( !szPath[ 0 ] )
    return ( DOSerrnum = -1 );   // ERROR: Invalid DOS path name in parm.

  iReturn = OpenFile( szPath, pofStruct, iMethod );

  if ( iReturn == -1 )
    WRError( GetFocus( ), "APIDOSOpen", IS_CANTOPEN, szPath, pofStruct->nErrCode );

  DOSerrnum = ( iReturn == -1 ? -1 : 0 );

  return ( iReturn ); // Return error code provided by
}

//---------------------------------------------------------------------------
// Return Value: -1 is an error, otherwise indicates file handle.
//---------------------------------------------------------------------------
int RCreate( LPSTR szPath, OFSTRUCT *pofStruct )
{
  int iReturn;

  if ( !szPath[ 0 ] )
    return ( DOSerrnum = -1 );               // ERROR: Invalid DOS path name in parm.

  iReturn = OpenFile( szPath, pofStruct, OF_CREATE );
  if ( iReturn == -1 )
    WRError( GetFocus( ), "APIWDOSCreate", IS_CANTCREATE, szPath, pofStruct->nErrCode );

  DOSerrnum = ( iReturn == -1 ? -1 : 0 );

  return ( iReturn );  // Return error code provided by Windows
}

// --------------------------------------------------------------------------
// Return Value: -1 is an error, 0 is success.
// --------------------------------------------------------------------------
int RDelete( LPSTR szPath )
{
  lstrcpy( ( LPSTR ) szTmpStr, szPath );
  return ( DOSerrnum = remove( ( NPSTR ) szTmpStr ) );
}

//---------------------------------------------------------------------------
// Return Value: -1 is an error, 0 is success.
//---------------------------------------------------------------------------
int RClose( int iHandle )
{
  return ( DOSerrnum = _lclose( iHandle ) ); // Return error code provided by 
}                                    // Windows file I/O routine.

//---------------------------------------------------------------------------
// Return Value: -1 is an error, otherwise return value equals number 
// of bytes successfully read.
//---------------------------------------------------------------------------
int RRead( int iHandle, LPSTR sBuffer, unsigned int iCount )
{
  int iReturn;

  iReturn = _lread( iHandle, sBuffer, iCount );
  if ( iReturn == -1 )
    WRError( GetFocus( ), "APIDOSRead", IS_CANTREAD, iHandle );
  DOSerrnum = ( iReturn == -1 ? -1 : 0 );
  return ( iReturn );
}

//---------------------------------------------------------------------------
// Return Value: -1 is an error, otherwise return value equals number 
// of bytes successfully written.
//---------------------------------------------------------------------------
int RWrite( int iHandle, LPSTR sBuffer, unsigned int iCount )
{
  int iReturn;

  iReturn = _lwrite( iHandle, sBuffer, iCount );
  if ( iReturn == -1 )
    WRError( GetFocus( ), "APIDOSWrite", IS_CANTWRITE, iHandle );
  DOSerrnum = ( iReturn == -1 ? -1 : 0 );

  return ( iReturn );
}

//---------------------------------------------------------------------------
// Return Value: -1 is an error, otherwise new file pointer position
//               (absolute byte offset from beginning of file). 
//---------------------------------------------------------------------------
LONG RSeek( int iHandle, LONG lFOffset, int iMethod )
{
  LONG lReturn;

  lReturn = _llseek( iHandle, lFOffset, iMethod );

  DOSerrnum = ( lReturn == -1 ? -1 : 0 );
  return ( lReturn );  // Return error code provided
}                      // by Windows file I/O routine.


