/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:   
**	Last PVCS update: $Date:   12 Aug 1992 20:01:44  $ 
*/

/*
**	TITLE:		rawsdio.d
**
**	FACILITY:
**
**	MODULE DESCRIPTION:
**
*/

/*
**
**	Revision History:
**
**		$Log:   D:/api_lib/rawsdio.d_v  $
   
      Rev 1.0   12 Aug 1992 20:01:44   Robert Chen
   Initial revision.
   
      Rev 1.5   17 Oct 1991 10:41:34   JIM
   Global update of T.30/T.4 API source for version 1.00.
   
      Rev 1.4   12 Sep 1991 11:19:00   JIM
   Global update of T.30/T.4 API source for version 0.22B.
   
      Rev 1.3   08 Aug 1991 18:48:10   JIM
   Update to facilitate single session DLL version of API.
   
      Rev 1.0   13 May 1991 10:17:40   unknown
   Initial revision.
   
      Rev 1.0   13 May 1991 10:04:44   JIM
   Initial Revision
** 
** 
*/

#define MAXBUFLINE  ( MAXBUFLINES - 1 )
#define SCROLLINC   2
#define SB_CLEAR    ( SB_ENDSCROLL + 1 )
#define STDIO_FONT  SYSTEM_FIXED_FONT   // font used for display

#define STDIOWINEXTRA 2
#define GWW_STDIOHND 0

#define GET_STDIOHND ( ( GLOBALHANDLE ) GetWindowWord( hWnd, GWW_STDIOHND ) )
#define SET_STDIOHND( x ) ( SetWindowWord( hWnd, GWW_STDIOHND, ( WORD ) x ) )

typedef LPSTR SCRBUF;
typedef struct StdioData
{
  short  nCurrPos;
  short  nStdioCharWidth;
  short  nStdioCharHeight;
  int    iLastBufLine;
  int    iVScrLineCnt;
  int    iVScrollPos;
  int    iVScrollMax;
  GLOBALHANDLE hScrBuf;
  WORD   BUFSIZE;
  int    MAXBUFLINES;
  int    LASTBUFPAGE;

  unsigned int bStdioQuit     : 1;  // 0000000?
  unsigned int bInited        : 1;  // 000000?0
  unsigned int bScrollEnabled : 1;  // 00000?00
  
} STDIODATA;

extern HWND   hWndStdio;         // handle to standard I/O window 
extern HANDLE hStdioInst;
extern int    iLastBufLine;      // Index of last line on TTY in the array.
extern int    iVScrollPos;       // Current scrolling position in allowable range.
extern int    iVScrollMax;       // Upper limit in scrolling range.
extern int    iVScrLineCnt;      // Number of lines contained in screen buffer.
extern BOOL   bScrollEnabled;
extern BOOL   bMinMax;
extern short  nStdioCharWidth,   // width and height of Stdio font chars.
              nStdioCharHeight;

extern short  nCurrPos;
extern BOOL   bStdioQuit;
extern BOOL   bInited;

extern GLOBALHANDLE hScrBuf;
extern SCRBUF       sScrBuf;

extern WORD  BUFSIZE;      
extern int   MAXBUFLINES;
extern int   LASTBUFPAGE;

typedef STDIODATA FAR * LPSTDIODATA;

//---------------------------------------------------------------------------
// Prototypes of local functions:
//---------------------------------------------------------------------------

// rawsdio1.c:
HWND   wopen( HWND, HANDLE, BOOL );
int    StdioStart( HWND );

LONG   _fastcall AddScrLine( int );
VOID   _fastcall SetupStdioDC( HDC );
VOID   _fastcall StdioUpdate( int, BOOL );
VOID   _fastcall StdioPaint( HWND );   
VOID   _fastcall PutStdio( HDC, WORD, LPSTR );
DWORD  _fastcall StdioVScroll( WORD, LONG );
int    _fastcall StdioKeyBoard( WORD, LONG );

// rawsdio2.c:
int    StdioReAllocMem( int, WORD );

int    _fastcall SetStdioData( HWND, BOOL );
int    _fastcall GetStdioData( HWND );
LPSTR  _fastcall GetStdioLine( short );


