/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:   
**	Last PVCS update: $Date:   12 Aug 1992 20:07:06  $ 
*/

/*
**	TITLE:		rawsdio.h
**
**	FACILITY:
**    Windows Generalized Text I/O
**
**	MODULE DESCRIPTION:
**    This header file should be used to allow access to the generalized
**    text I/O functions which reside in the DLL RAWCLAS1.DLL.  Most
**    notably the function "wputs" which is used to perform rudimentary
**    text output in the Developer Functions of Reporting Class (RAWDSPLY.C).
*/

/*
**
**	Revision History:
**
**		$Log:   D:/api_lib/rawsdio.h_v  $
   
      Rev 1.0   12 Aug 1992 20:07:06   Robert Chen
   Initial revision.
** 
**    Rev 1.5   17 Oct 1991 10:42:48   JIM
** Global update of T.30/T.4 API source for version 1.00.
** 
**    Rev 1.4   12 Sep 1991 11:20:24   JIM
** Global update of T.30/T.4 API source for version 0.22B.
** 
**    Rev 1.3   08 Aug 1991 18:49:18   JIM
** Update to facilitate single session DLL version of API.
** 
**    Rev 1.0   13 May 1991 10:48:16   JIM
** Initial Revision
** 
** 
*/
// --------------------------------------------------------------------------
// Define the following constants in the event this header file is included
// in a library that does not use the windows header, i.e. using wputs in
// a helper function module.
// --------------------------------------------------------------------------
#ifndef WORD
  #define WORD unsigned int
#endif
#ifndef DWORD
  #define DWORD unsigned long
#endif
#ifndef LPSTR
  #define LPSTR char far *
#endif
#ifndef VOID
  #define VOID void
#endif
#ifndef BOOL
  #define BOOL int
#endif
#ifndef HANDLE
  #define HANDLE WORD
#endif
#ifndef HWND
  #define HWND HANDLE
#endif
#ifndef LONG
  #define LONG long
#endif
#ifndef PASCAL
  #define PASCAL pascal
#endif
#ifndef FAR
  #define FAR far
#endif
#ifndef GLOBALHANDLE
  #define GLOBALHANDLE HANDLE
#endif

#define MAXSCRLINES   25
#define MAXLINELEN    81
#define MAXSCRLINE    ( MAXSCRLINES - 1 )
#define MAXSCRAREA    MAXSCRLINES 
#define MINSCRBUF     ( MAXSCRLINES * MAXLINELEN )
#define MAXSCRBUF     65023
#define DEFSCRBUF     24576

#define STDMEM_MINIMIZE 0
#define STDMEM_CONTRACT 1
#define STDMEM_EXPAND   2
#define STDMEM_INIT     3

// rawsdio1.c:
BOOL         FAR PASCAL wputs( HWND, LPSTR );
BOOL         FAR PASCAL wputsfocus( LPSTR );
LONG         FAR PASCAL StdioWndProc( HWND, unsigned, WORD, LONG );
BOOL         FAR PASCAL StdioInit( HANDLE );
HWND         FAR PASCAL CreateStdioWindow( LPSTR, DWORD, int, int, int, int, 
                                           HWND, HANDLE, BOOL, WORD );

// rawsdio2.c:
GLOBALHANDLE FAR PASCAL GetStdioMem( HWND );
WORD         FAR PASCAL GetStdioLines( HWND );
LPSTR        FAR PASCAL GetLinePtr( HWND, int, LPSTR );
int          FAR PASCAL SetStdioMem( HWND, WORD );
BOOL         FAR PASCAL GetStdioScroll( HWND );


// ---------------------------------------------------------------------------
// Implemenation Note:
// This header file refers to functions and static variables available
// throughout all application components, DLL's and EXE's.  The functions
// are defined in the application DLL RAWCLAS1.DLL.  The function defined
// below, however, must be defined locally in the code segment which calls
// it and consequently could appear in any one of the utility code modules
// defined for the designated DLL or EXE.  If the _cdecl functions of this
// type grow in number a seperate code module will be defined.
// ---------------------------------------------------------------------------
// File: [the name of a local code module]
// File: rawautl2.c rawtutl1.c

BOOL _cdecl wprintf( LPSTR, ... );

#if !defined( MAKELONG )
  int FAR PASCAL wvsprintf(LPSTR,LPSTR,LPSTR);
  int FAR cdecl wsprintf(LPSTR,LPSTR,...);
#endif // MAKELONG


