/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:   
**	Last PVCS update: $Date:   12 Aug 1992 19:59:28  $ 
*/

/*
**	TITLE:		rawsdio2.c
**
**	FACILITY:
**
**	MODULE DESCRIPTION:
**
*/

/*
**
**	Revision History:
**
**		$Log:   D:/api_lib/rawsdio2.c_v  $
 * 
 *    Rev 1.0   12 Aug 1992 19:59:28   Robert Chen
 * Initial revision.
** 
**    Rev 1.5   17 Oct 1991 10:41:18   JIM
** Global update of T.30/T.4 API source for version 1.00.
** 
**    Rev 1.4   12 Sep 1991 11:18:44   JIM
** Global update of T.30/T.4 API source for version 0.22B.
** 
**    Rev 1.3   08 Aug 1991 18:47:54   JIM
** Update to facilitate single session DLL version of API.
** 
**    Rev 1.0   13 May 1991 09:45:50   JIM
** Initial Revision
** 
** 
*/
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <sys\timeb.h>
#include "zapi.h"
#include "rawglobl.h"
#include "rawclas1.h"
#include "rawsdio.h"
#include "rawsdio.d"
#include "rawerr.h"

#pragma optimize("egl",off)
int FAR PASCAL SetStdioMem( HWND hWnd, WORD wNewScrBufSize )
{
  int iReturn;

  GetStdioData( hWnd );

  if ( !hScrBuf )
  {
    iReturn = StdioReAllocMem( STDMEM_INIT, wNewScrBufSize );
  }
  else if ( wNewScrBufSize > BUFSIZE )
  {
    if ( !( iReturn = StdioReAllocMem( STDMEM_EXPAND, wNewScrBufSize ) ) )
      BUFSIZE = wNewScrBufSize;
  }
  else if ( wNewScrBufSize < BUFSIZE && wNewScrBufSize > MINSCRBUF )
  {
    if ( !( iReturn = StdioReAllocMem( STDMEM_CONTRACT, wNewScrBufSize ) ) )
      BUFSIZE = wNewScrBufSize;
  }
  else if ( wNewScrBufSize == BUFSIZE )
  {
    iReturn = 0;
  }
  else
    if ( !( iReturn = StdioReAllocMem( STDMEM_MINIMIZE, MINSCRBUF ) ) )
      BUFSIZE = MINSCRBUF;

  SetStdioData( hWnd, FALSE );

  return ( iReturn );
}
#pragma optimize("",on)

BOOL FAR PASCAL GetStdioScroll( HWND hWnd )
{
  GetStdioData( hWnd );

  return ( bScrollEnabled );
}

GLOBALHANDLE FAR PASCAL GetStdioMem( HWND hWnd  )
{
  GetStdioData( hWnd );

  return ( hScrBuf );
}

WORD FAR PASCAL GetStdioLines( HWND hWnd )
{
  GetStdioData( hWnd );

  return ( iVScrLineCnt );
}

#pragma optimize("egl",off )  // Temporarily deactivates global optimization.
int StdioReAllocMem( int iMemStat, WORD wBufSize )
{
  GLOBALHANDLE hNewScrBuf = 0;
  GLOBALHANDLE hOldScrBuf = hScrBuf;
  LPSTR        sNewScrBuf;
  LPSTR        sOldScrBuf;
  LPSTR        sIdx;
  RECT         rcRect;
  int          nIdxLineEnd;
  register int nIdxLine;

  GetClientRect( hWndStdio, &rcRect );

  if ( iMemStat != STDMEM_INIT )
  {
    if ( !( sOldScrBuf = GlobalLock( hOldScrBuf ) ) )
    {
      WRError( hWndStdio, "StdioReAllocMem", IS_NOLOCK );
      return ( -1 );
    }
  }
  if ( !( hNewScrBuf = GlobalAlloc( GHND, ( DWORD ) wBufSize ) ) )
  {
    WRError( hWndStdio, "StdioReAllocMem", IS_OUTOFMEM );
    return ( -1 );
  }
  if ( !( sNewScrBuf = GlobalLock( hNewScrBuf ) ) )
  {
    WRError( hWndStdio, "StdioReAllocMem", IS_NOLOCK );
    GlobalFree( hNewScrBuf );
    return ( -1 );
  }

  switch ( iMemStat )
  {
    case STDMEM_MINIMIZE:
      for ( nIdxLine = 0, sIdx = sNewScrBuf; nIdxLine < MAXSCRLINES;
                          ++nIdxLine, sIdx += MAXLINELEN )
        lstrcpy( sIdx, GetStdioLine( nIdxLine ) );
      iVScrLineCnt = MAXSCRLINE;
      bScrollEnabled = FALSE;
      break;

    case STDMEM_EXPAND:
      for ( nIdxLine = 0, sIdx = sNewScrBuf; nIdxLine < iVScrLineCnt;
            ++nIdxLine, sIdx += MAXLINELEN )
        lstrcpy( sIdx, GetLinePtr( hWndStdio, nIdxLine, sOldScrBuf ) );
      iVScrollPos = 0;      // Place scrolled display at top of buffer.
      bScrollEnabled = TRUE;
      break;

    case STDMEM_CONTRACT:
      for ( nIdxLine = 0, nIdxLineEnd = wBufSize / MAXLINELEN, sIdx = sNewScrBuf;
            nIdxLine < nIdxLineEnd; ++nIdxLine, sIdx += MAXLINELEN )
        lstrcpy( sIdx, GetLinePtr( hWndStdio, nIdxLine, sOldScrBuf ) );
      iVScrollPos = 0;       // Place scrolled display at top of buffer.
      bScrollEnabled = TRUE;
      break;

    case STDMEM_INIT:
      bScrollEnabled = ( wBufSize > MINSCRBUF );
      break;

    default:
      GlobalUnlock( hOldScrBuf );
      if ( hNewScrBuf )
        GlobalUnlock( hNewScrBuf );
      return ( -1 );
  }

  // Update scrolling parameters:
  MAXBUFLINES  = max( wBufSize / MAXLINELEN, MAXSCRLINES );
  LASTBUFPAGE  = MAXBUFLINES - MAXSCRLINES;
  iVScrLineCnt = iLastBufLine = min( MAXBUFLINES, iVScrLineCnt );

  if ( bScrollEnabled )
  {
    iVScrollMax  = max( 0, ( bMinMax ? iVScrLineCnt + 1 : iVScrLineCnt )
                        - rcRect.bottom / nStdioCharHeight );
    iVScrollPos  = min( iVScrollMax, iVScrollPos );
  }
  else
    iVScrollMax = iVScrollPos = 0;

  hScrBuf = hNewScrBuf;
  // Cleanup after normal memory reallocation:
  if ( iMemStat != STDMEM_INIT )
  {
    GlobalUnlock( hOldScrBuf );
    GlobalFree( hOldScrBuf );
    GlobalUnlock( hNewScrBuf );

    InvalidateRect( hWndStdio, NULL, TRUE );
    StdioUpdate( 0, NULL );
  }

  return ( 0 );
}
#pragma optimize("", on)  // Reactivates default optimization from CL.

//--------------------------------------------------------------------------
//
// FUNCTION: GetStdioLine( short ndx )
// PURPOSE:  Return a pointer to the specified line of the display.
//
// The forumula used in this function determines the offset value for the
// the requested line of the displayed screen buffer.  Its derivation is
// as follows:
//
// Beginning of circular buffer:    ( iLastBufLine + 1 ) +
//
// Offset to beginning of circular  ( MAXBUFLINES - iVScrLineCnt ) +
// buffer going to zero when buffer
// is full:
//
// Advances to top of last page in  ( iVScrLineCnt - MAXSCRLINES ) -
// circular buffer:
//
// Subtracts same value to return   ( iVScrollMax ) +
// back to beginning of circular
// buffer. This value is zero when 
// adding first page to circular 
// buffer:
//
// Add offset to first line of      ( iVScrollPos ) +
// displayed page.
//
// Add offset for requested line    ( iNdx )
//
// This function may be simplified to the following:
// 
// = iLastBufLine + 1 + MAXBUFLINES - MAXSCRLINES - iVScrollMax + iVScrollPos +
//   iNdx
//
// And further simplified to:
// = iLastBufLine + 1 + LASTBUFPAGE - iVScrollMax + iVScrollPos + iNdx
// 
//--------------------------------------------------------------------------
LPSTR _fastcall GetStdioLine( short iNdx )
{
  int iPos;

  // Determine screen line offset into screen buffer.
  iPos = iLastBufLine + 1 + LASTBUFPAGE - iVScrollMax + iVScrollPos + iNdx;

  if ( iPos > MAXBUFLINE )
    iPos -= MAXBUFLINES;
  else if ( iPos < 0 )
    iPos += MAXBUFLINES;

  // Return address of offset into block of memory addressed by sScrBuf.
  return( sScrBuf + iPos * MAXLINELEN );
}

LPSTR FAR PASCAL GetLinePtr( HWND hWnd, int iNdx, LPSTR sScrBufParm )
{
  int iPos;

  GetStdioData( hWnd );

  // Determine screen line offset into screen buffer.
  iPos = iLastBufLine + 1 + MAXBUFLINE - min( iVScrLineCnt, MAXBUFLINE ) + iNdx;

  if ( iPos > MAXBUFLINE )
    iPos -= MAXBUFLINES;
  else if ( iPos < 0 )
    iPos += MAXBUFLINES;

  return ( sScrBufParm + iPos * MAXLINELEN );
}

int _fastcall SetStdioData( HWND hWnd, BOOL bInitMem )
{
  GLOBALHANDLE hStdioData;
  LPSTDIODATA  pStdioData;

  if ( !hWnd )
    return ( 1 );

  if ( !( hStdioData = GET_STDIOHND ) )
  {
    if ( bInitMem )
    { 
      // ----------------------------------------------------------------------
      // Allocate global memory for Stdio instance data.
      // ----------------------------------------------------------------------
      if ( !( hStdioData = GlobalAlloc( GHND, sizeof( STDIODATA ) ) ) )
      {
        WRError( hWnd, "SetStdioData: GlobalAlloc Error", IS_OUTOFMEM );
        return ( 1 );
      }
      SET_STDIOHND( hStdioData );
    }  
    else
      return ( 1 );
  }
  if ( !( pStdioData = ( LPSTDIODATA ) GlobalLock( hStdioData ) ) )
  {
    WRError( hWnd, "SetStdioData: GlobalLock Error", IS_NOLOCK );
    return ( 1 );
  }

  pStdioData->nCurrPos         = nCurrPos;           
  pStdioData->nStdioCharWidth  = nStdioCharWidth;    
  pStdioData->nStdioCharHeight = nStdioCharHeight;   
  pStdioData->iLastBufLine     = iLastBufLine;       
  pStdioData->iVScrLineCnt     = iVScrLineCnt;       
  pStdioData->iVScrollPos      = iVScrollPos;        
  pStdioData->iVScrollMax      = iVScrollMax;        
  pStdioData->bStdioQuit       = bStdioQuit;         
  pStdioData->bInited          = bInited;            
  pStdioData->bScrollEnabled   = bScrollEnabled;     
  pStdioData->hScrBuf          = hScrBuf;            
  pStdioData->BUFSIZE          = BUFSIZE;            
  pStdioData->MAXBUFLINES      = MAXBUFLINES;
  pStdioData->LASTBUFPAGE      = LASTBUFPAGE;

  GlobalUnlock( hStdioData );
  
  return ( 0 );
}

int _fastcall GetStdioData( HWND hWnd )
{
  GLOBALHANDLE hStdioData;
  LPSTDIODATA  pStdioData;

  // ------------------------------------------------------------------------
  // Stdio session data not yet allocated.
  // ------------------------------------------------------------------------
  if ( !hWnd )
    return ( 1 );

  if ( hWnd == hWndStdio )
    return ( 0 );

  GetClassName( hWnd, szTmpStr, TMPSTRMAX );
  if ( strcmp( szTmpStr, "Stdio" ) )
    return ( 1 );

  if ( !( hStdioData = GET_STDIOHND ) )
    return ( 1 );

  if ( !( pStdioData = ( LPSTDIODATA ) GlobalLock( hStdioData ) ) )
  {
    WRError( hWndStdio, "SetStdioData: GlobalLock Error", IS_NOLOCK );
    return ( 1 );
  }

  hWndStdio        = hWnd;
  hStdioInst       = INSTANCE( hWnd );

  nCurrPos         = pStdioData->nCurrPos;        
  nStdioCharWidth  = pStdioData->nStdioCharWidth; 
  nStdioCharHeight = pStdioData->nStdioCharHeight;
  iLastBufLine     = pStdioData->iLastBufLine;    
  iVScrLineCnt     = pStdioData->iVScrLineCnt;    
  iVScrollPos      = pStdioData->iVScrollPos;     
  iVScrollMax      = pStdioData->iVScrollMax;     
  bStdioQuit       = pStdioData->bStdioQuit;      
  bInited          = pStdioData->bInited;         
  bScrollEnabled   = pStdioData->bScrollEnabled;  
  hScrBuf          = pStdioData->hScrBuf;
  BUFSIZE          = pStdioData->BUFSIZE;
  MAXBUFLINES      = pStdioData->MAXBUFLINES;
  LASTBUFPAGE      = pStdioData->LASTBUFPAGE;

  GlobalUnlock( hStdioData );
  
  return ( 0 );
}

