/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:   
**	Last PVCS update: $Date:   07 Sep 1992 15:45:54  $ 
*/

/*
**	TITLE:		rawautl1.c
**
**	FACILITY:
**
**	MODULE DESCRIPTION:
**   The functions defined in this module are defined for local use in the 
**   designated DLL or EXE module.
**
*/

/*
**
**	Revision History:
**
**		$Log:   D:/api_lib/rawtutl1.c_v  $
 * 
 *    Rev 1.2   07 Sep 1992 15:45:54   Robert Chen
 *  
 * 
 *    Rev 1.1   16 Aug 1992 22:49:14   Robert Chen
 * 
 *    Rev 1.0   12 Aug 1992 19:59:38   Robert Chen
 * Initial revision.
** 
**    Rev 1.2   17 Oct 1991 10:41:26   JIM
** Global update of T.30/T.4 API source for version 1.00.
** 
**    Rev 1.1   12 Sep 1991 11:18:50   JIM
** Global update of T.30/T.4 API source for version 0.22B.
** 
**    Rev 1.0   08 Aug 1991 18:48:00   JIM
** Update to facilitate single session DLL version of API.
** 
**    Rev 1.1   20 May 1991 09:14:36   JIM
** 
**    Rev 1.0   13 May 1991 09:46:56   JIM
** Initial Revision
** 
** 
*/

#include <windows.h>
#include <stdlib.h>  
#include <stdio.h>   
#include <string.h>  
#include <bios.h>
#include <sys\timeb.h>
#include "rawglobl.h"
#include "zapi.h"
#include "fapi.h"
#include "vapi.h"
#include "zapicls1.h"
#include "rawsdio.h"
#include "rawclas1.h"
#include "raw.h"
#include "example.h"
#include "umain.h"

// Enhancement should include reformatting of lines longer than 80 characters.
int SaveLogFile( void )
{
  int          iFile;
  LPSTR        sFileBuf;
  LPSTR        sFileBufOffset;
  int          iFileLineIdx;
  int          iFileLineEnd;
  GLOBALHANDLE hStdioMem;
  OFSTRUCT     ofStruct;

  if ( !LogEnvDlg.bDiskStat )
    return ( 0 );

  // Save log file in memory to disk.
  if ( ( iFile = RCreate( LogEnvDlg.szLogFileName, &ofStruct ) ) <= 0 )
    return ( -1 );

  hStdioMem = GetStdioMem( hWndMain );

  if ( !hStdioMem || !( sFileBuf = GlobalLock( hStdioMem ) ) )
    return ( -1 );

  for ( iFileLineIdx = 0, iFileLineEnd = GetStdioLines( hWndMain );
        iFileLineIdx < iFileLineEnd; ++iFileLineIdx )
  {
    if ( *( sFileBufOffset = GetLinePtr( hWndMain, iFileLineIdx, sFileBuf ) ) )
      lstrcpy( ( LPSTR ) szTmpStr0, sFileBufOffset );
    else
      *szTmpStr0 = NULL;
    strcat( szTmpStr0, "\r\n" );
    RWrite( iFile, szTmpStr0, strlen( szTmpStr0 ) );
  }
  LoadString( hInst, IS_ENDOFLOG, szTmpStr0, sizeof( szTmpStr0 ) );
  RWrite( iFile, szTmpStr0, strlen( szTmpStr0 ) );
  RClose( iFile );
  GlobalUnlock( GetStdioMem( hWndMain ) );      // Release memory used to store log file.

  return ( 0 );
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
LPSTR GetConfStr( char *szConfTmp )
{
  char szDialTmp[ TMPSTRMAX ];

  strcpy( szConfTmp, ATSPKR );        // Speaker AT command.
  strcat( szConfTmp, itoa( FMDlg.wSpkrStat, szDialTmp, 10 ) );

  return ( ( LPSTR ) szConfTmp );
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
LPSTR GetDialStr( char *szDialTmp )
{
  strcpy( szDialTmp, ATDIAL );     // Add actual phone number.
  strcat( szDialTmp, DialStrDlg.szDialStr );

  return ( ( LPSTR ) szDialTmp );
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int CallDialog( char *szDialog, FARPROC lpfnWndProc, HWND hWnd, LONG lParam )
{
  FARPROC lpfnWndProcInst;
  int iReturn;

  lpfnWndProcInst = MakeProcInstance( lpfnWndProc, hInst );

  if ( lParam )
    iReturn = DialogBoxParam( hInst, szDialog, hWnd, lpfnWndProcInst, lParam );
  else
    iReturn = DialogBox( hInst, szDialog, hWnd, lpfnWndProcInst );
  FreeProcInstance( lpfnWndProcInst );
  return ( iReturn );
}

#if ( WIN_TEST1 )
BOOL APIFaxPollChk( void )
{
  static BOOL bGoData;

  // Prevent GetMessage processing from CFR to DATA_FINISH state.
  switch ( APISession.T30T4CurrentState )
  {
    case T30T4_RX_TCF_RESULT:     
    case T30T4_RX_TRAIN_CONFIRM:  
      return ( TRUE );
      break;

    case T30T4_RX_GO_DATA:
      bGoData = TRUE;
      break;

    case T30T4_RX_DATA_FINISH:
      wputs( hWndMain, "DATA FINISH\n" );
      bGoData = FALSE;
      break;
  }
  return ( bGoData );
}
#endif

void TestStdio( unsigned wTestCycles )
{
  unsigned wNdx;

  for ( wNdx = 0; wNdx < wTestCycles; ++wNdx )
  {
    sprintf( szTmpStr0, "Test Output Number #%d\n", wNdx );
    wputs( hWndMain, szTmpStr0 );
  }

  for ( wNdx = 0; wNdx < 15; ++wNdx )
    SendMessage( hWndMain, WM_VSCROLL, SB_LINEUP, 0L );
  SendMessage( hWndMain, WM_VSCROLL, SB_BOTTOM, 0L );
}

//---------------------------------------------------------------------------
// Function Name: void Delay( int )
//
// Description:
// Delay processing a specific number of PC clock ticks.
//
// Calling Syntax:
//
// Args: 
//  Input:
//	Output:
//
// Modified:  
// Description: 
//---------------------------------------------------------------------------
void Delay( int ticks ) 
{
	int count;
	long int last, current;

	_bios_timeofday( _TIME_GETCLOCK, &last );
	count = ticks + 1;

	do 
  {
		_bios_timeofday( _TIME_GETCLOCK, &current );
		if ( current != last ) 
    {
			last = current;
			count--;
		}
	} while ( count != 0 );
}

int UpdateExtData( LPEXTDATA pExtData )
{
  pExtData->wRecvBuf = FMDlg.wRecvBuf; 
  pExtData->wXmitBuf = FMDlg.wXmitBuf;
  pExtData->bfXonXoff = FMDlg.bfXonXoff;
  pExtData->bfRtsCts = FMDlg.bfRtsCts; 
  pExtData->wLogOutStat = LogEnvDlg.wLogOutStat;
  pExtData->hWndMain = hWndMain;

  if ( RZSetExtData( FMDlg.wComPort, ( LONG ) pExtData ) )
    return ( 1 );

  return ( 0 );
}

BOOL IsVCON( void )
{
#ifdef DO_VOICE
  int iCurrentState; 

  if ( iCurrentState = EX1InProgress() )
    return ( iCurrentState == USR_STA_VOICE_COMMAND ||
             iCurrentState == USR_STA_AUTOANSWER_01 || 
             iCurrentState == USR_STA_AUTOANSWER_02 );

  else if ( iCurrentState = EX2InProgress() )
    return ( iCurrentState == USR_STA_VOICE_COMMAND ||
             iCurrentState == USR_STA_VOICE_SUPER_COMMAND ||
             iCurrentState == USR_STA_PASSWORD_01 || 
             iCurrentState == USR_STA_AUTOANSWER_01 || 
             iCurrentState == USR_STA_AUTOANSWER_02 );

  else if ( iCurrentState = EX4InProgress() )
    return ( iCurrentState == USR_STA_VOICE_COMMAND ||
             iCurrentState == USR_STA_VOICE_SUPER_COMMAND ||
             iCurrentState == USR_STA_PASSWORD_01 || 
             iCurrentState == USR_STA_AUTOANSWER_01 || 
             iCurrentState == USR_STA_AUTOANSWER_02 );

#ifdef DO_FAX
  else if ( iCurrentState = UCDInProgress() )
    return ( iCurrentState != AnsCD_04 );
#endif
#endif

  return ( FALSE );
}

void SetLastVState( void )
{
#if defined (DO_VOICE)
  if ( EX1InProgress() )
    USR.CurrentState = USR_STA_LAST;

  else if ( EX2InProgress() )
    USR.CurrentState = USR_STA_LAST;

  else if ( EX4InProgress() )
    USR.CurrentState = USR_STA_LAST;

#if defined (DO_FAX) 
  else if ( UCDInProgress() )
    SetUMNLast();
#endif
#endif
}

BOOL _cdecl wprintf( LPSTR lpszFmt, ... )
{
  if ( _fstrstr( lpszFmt, "%" ) )
    wvsprintf( szTmpStr, lpszFmt, ( ( LPSTR ) &lpszFmt + sizeof( lpszFmt ) ) );
  else
    lstrcpy( szTmpStr, lpszFmt );
  
  return ( wputs( hWndMain, szTmpStr ) );
}

