#**************************************************************************
#*              ROCKWELL CONFIDENTIAL AND PROPRIETARY
#*        This source is the sole property of ROCKWELL Inc.
#*    Reproduction or utilization of this source in whole or in 
#*  part is forbidden without the written consent of ROCKWELL Inc.
#**************************************************************************
#*                 (c) Copyright ROCKWELL, INC. 1991
#*                       All Rights Reserved
#**************************************************************************

#* 
#* Last update:   
#*	Last PVCS update: $Date:   07 Sep 1992 15:46:04  $ 

#*	TITLE:		raw.mak
#*
#*	FACILITY:
#*
#*	MODULE DESCRIPTION:
#*

#*
#*
#*	Revision History:
#*
#*		$Log:   D:/api_lib/rawv.mav  $
#  
#     Rev 1.4   07 Sep 1992 15:46:04   Robert Chen
#   
#  
#     Rev 1.3   19 Aug 1992 22:27:08   Robert Chen
#  
#     Rev 1.2   19 Aug 1992 13:35:32   Robert Chen
#  
#     Rev 1.1   17 Aug 1992 15:44:44   Robert Chen
#  
#     Rev 1.0   16 Aug 1992 22:58:46   Robert Chen
#  Initial revision.
#  
#     Rev 1.1   15 Aug 1992 21:53:46   Robert Chen
#  
#     Rev 1.0   12 Aug 1992 20:12:40   Robert Chen
#  Initial revision.
#  
#     Rev 1.9   17 Oct 1991 10:42:54   JIM
#  Global update of T.30/T.4 API source for version 1.00.
#  
#     Rev 1.8   12 Sep 1991 14:36:32   JIM
#  Global update of T.30/T.4 API source for version 0.22B.
#  
#     Rev 1.7   12 Sep 1991 11:20:30   JIM
#  Global update of T.30/T.4 API source for version 0.22B.
#  
#     Rev 1.6   09 Aug 1991 15:34:16   JIM
#  Update to facilitate single session DLL version of API.
#  
#     Rev 1.5   08 Aug 1991 18:49:24   JIM
#  Update to facilitate single session DLL version of API.
#  
#     Rev 1.2   29 May 1991 11:17:28   JIM
#  Changes were made to support environmental differences between the LIBRARY and
#  my DEVELOPMENT system. JYW
#  
#     Rev 1.0   13 May 1991 10:05:52   JIM
#  Initial Revision
#* 
#* 
# What does "ALL:" do?  Answer:
# This line allows NMAKE to work as well.  By default if the command line
# is empty, NMAKE will use the first description block it encounters to
# determine which targets must be created from the pseudotarget and its
# dependencies.  "all:" is the pseudotarget which is never created, thus
# the term pseudotarget, but defines the targets which must generated when
# no command line target is specified.  JYW

#---------------------------------------------------------------------------
# Application Notes:
#
# _MAX_PATH produces warning message, temporarily #undef ined in FAXFILE.H
#---------------------------------------------------------------------------

#---------------------------------------------------------------------------
# Path of API source.  APIPATH is adjusted based on the location of makefile
# on the library or on a development system.
#---------------------------------------------------------------------------
!if "$(SYSTEM)"=="DEVELOPMENT"
APIPATH1=..\\
APIPATH2=.\\win
!else
APIPATH1=.\\
APIPATH2=.\\
!endif
OB=.\\winobjs\\

# Inference Rules:
.rc.res:
  rc -rv $*.rc

#Link command line flags, debug capable:
#LFLAGS   =/NOD /NOE /M /CO /FARCALLTRANSLATION /PACKCODE /align:16
LFLAGS    =/NOD /NOE /F /PACKCODE:63488 /align:16 

DESTFILE = wvapimn
LINKFILE = $(DESTFILE).lnk
APPLIB   = srfraww
#VAPILIB  = srfvcaw

#----------------------------------------------------------------------------
# FF_DLL   - Faxfile compiler directive for DLL compiled functions.
# MSC600   - Identifies the version of the compiler in use.
# FASTCALL - Defines the compiler directive for MSC specific "fastcall"
#            conventions.
# VF_SWIN  - Identifies the operating system targeted for the executable code.
#----------------------------------------------------------------------------
#WINFLAGS = -DFF_DLL -DVF_SWIN
WINFLAGS = -DVF_SWIN -DDO_VOICE
  
#----------------------------------------------------------------------------
# RECOMPILATION REQUIRES MSC 6.00a
#
# Symbol Definition:
# SMALL MODEL:
#
# Compile flags for Windows App API code with DEBUG option (-Zi).
#----------------------------------------------------------------------------
# Compile command line flags, debug capable:
C51 = -W2 -c -AS -Gsw -Zpei -Fo$(OB) -I$(APIPATH1) -I.\ -Od -DMSC510 -DFASTCALL=
C60 = -W3 -c -AS -Gsw -Zpei -Fo$(OB) -I$(APIPATH1) -I.\ -Od  -DFASTCALL=_fastcall 

#C51 = -W2 -c -AS -Gsw -Zpe -I$(APIPATH1) -I.\ -Ox -DMSC510 -DFASTCALL=
#C60 = -W3 -c -AS -Gsw -Zpe -I$(APIPATH1) -I.\ -Owxz -DMSC600 -DFASTCALL=_fastcall 

CFLAGS = $(C60) $(WINFLAGS)
APIFLAGS = -DFAR=_far -DPASCAL=_pascal -DFASTCALL=_fastcall -DVF_SWIN

#LINKLIBS = $(APPLIB).lib rvrifdll.lib rfrawdll.lib 
#SYSLIBS1 = faxfile.lib select.lib view.lib 
#SYSLIBS2 = rfapidll.lib rvapidll.lib rzapidll.lib print.lib libw slibcew 

LINKLIBS = $(APPLIB).lib rvrifdll.lib rfrawdll.lib 
SYSLIBS1 = select.lib 
SYSLIBS2 = rvapidll.lib rzapidll.lib libw slibcew 

#----------------------------------------------------------------------------
# Application object modules:
#----------------------------------------------------------------------------
OBJSW1 = $(OB)rawmain.obj $(OB)rawtutl1.obj 
OBJSW2 = $(OB)rawdlg1.obj $(OB)rawdlg2.obj $(OB)rawdlg3.obj $(OB)rawdlg4.obj 
OBJSW3 = $(OB)rawcnfio.obj $(OB)rawdtapp.obj $(OB)rawio.obj $(OB)rawerr.obj 
OBJSV1 = $(OB)example1.obj $(OB)example2.obj  $(OB)example4.obj   
OBJSV2 = $(OB)vcallbke.obj

#OBJSW2 = $(OB)rawdlg1.obj $(OB)rawdlg2.obj $(OB)rawdlg3.obj $(OB)rawdlg4.obj 
#OBJSW1 = rawmain.obj rawappmn.obj rawvoimn.obj rawtutl1.obj 
#OBJSV2 = $(OB)vcallbk.obj $(OB)vcallbke.obj
#OBJSV1 = $(OB)example1.obj $(OB)example4.obj   $(OB)umain.obj

all: $(OBJSW1) $(OBJSW2) $(OBJSW3) $(OBJSV1) $(OBJSV2) $(LINKLIBS) rawv.res \
     $(DESTFILE).exe  

#---------------------------------------------------------------------------
# Windows DVT (test harness) object modules:
#---------------------------------------------------------------------------
$(OB)rawmain.obj : rawmain.c $(APIPATH1)zapi.h $(APIPATH1)fapi.h $(APIPATH1)vapi.h \
              rawglobl.h raw.h rawsdio.h view.h print.h $(APIPATH1)example.h
  cl $(CFLAGS)   rawmain.c
$(OB)rawappmn.obj: rawappmn.c $(APIPATH1)zapi.h $(APIPATH1)fapi.h rawglobl.h \
              raw.h rawsdio.h rawclas1.h rawerr.h view.h print.h
  cl $(CFLAGS)   rawappmn.c

$(OB)rawvoimn.obj: rawvoimn.c rawvoice.h $(APIPATH1)vapi.h
  cl $(CFLAGS)   rawvoimn.c

$(OB)rawtutl1.obj: rawtutl1.c $(APIPATH1)zapi.h $(APIPATH1)fapi.h rawglobl.h \
              raw.h rawsdio.h rawclas1.h 
  cl $(CFLAGS) rawtutl1.c

$(OB)rawdlg1.obj : rawdlg1.c $(APIPATH1)zapi.h $(APIPATH1)fapi.h rawglobl.h \
              raw.h rawsdio.h rawclas1.h rawerr.h
  cl $(CFLAGS) rawdlg1.c

$(OB)rawdlg2.obj : rawdlg2.c $(APIPATH1)zapi.h $(APIPATH1)fapi.h rawglobl.h \
              raw.h rawclas1.h rawerr.h
  cl $(CFLAGS) rawdlg2.c

$(OB)rawdlg3.obj : rawdlg3.c $(APIPATH1)zapi.h $(APIPATH1)fapi.h rawglobl.h \
              raw.h rawsdio.h rawclas1.h rawerr.h
  cl $(CFLAGS) rawdlg3.c

$(OB)rawdlg4.obj : rawdlg4.c $(APIPATH1)zapi.h $(APIPATH1)fapi.h rawglobl.h raw.h \
              rawclas1.h
  cl $(CFLAGS) rawdlg4.c

$(OB)rawcnfio.obj: rawcnfio.c $(APIPATH1)zapi.h $(APIPATH1)fapi.h rawglobl.h raw.h
  cl $(CFLAGS) rawcnfio.c

$(OB)rawio.obj   : rawio.c $(APIPATH1)zapi.h $(APIPATH1)fapi.h rawglobl.h raw.h \
              rawerr.h
  cl $(CFLAGS) rawio.c

$(OB)rawdtapp.obj: rawdtapp.c $(APIPATH1)zapi.h $(APIPATH1)zapi.h rawglobl.h raw.h
  cl $(CFLAGS) rawdtapp.c

$(OB)rawerr.obj  : rawerr.c $(APIPATH1)zapi.h rawglobl.h rawerr.h
  cl $(CFLAGS) rawerr.c

$(OB)vcallbk.obj: $(APIPATH1)vcallbk.c $(APIPATH1)umain.h $(APIPATH1)vcallbk.h \
             $(APIPATH1)zapi.h $(APIPATH1)vapi.h 
  cl $(CFLAGS)   $(APIPATH1)vcallbk.c

$(OB)vcallbke.obj: $(APIPATH1)vcallbke.c $(APIPATH1)umain.h $(APIPATH1)vcallbk.h \
              $(APIPATH1)zapi.h $(APIPATH1)vapi.h \
              rawglobl.h rawsdio.h rawvoice.h
  cl $(CFLAGS)   $(APIPATH1)vcallbke.c

$(OB)umain.obj: $(APIPATH1)umain.c $(APIPATH1)vapi.h $(APIPATH1)vcallbk.h \
           $(APIPATH1)fapi.h $(APIPATH1)zapi.h \
           $(APIPATH1)umain.h
  cl $(CFLAGS)   $(APIPATH1)umain.c

$(OB)example1.obj: $(APIPATH1)example1.c $(APIPATH1)zapi.h $(APIPATH1)vapi.h \
              $(APIPATH1)vcallbk.h $(APIPATH1)example.h \
              $(APIPATH1)fapi.h rawglobl.h \
              raw.h rawvoice.h rawsdio.h rawerr.h rawclas1.h
# set cl=$(CFLAGS) 
  cl $(CFLAGS) $(APIPATH1)example1.c
  set cl=

$(OB)example2.obj: $(APIPATH1)example2.c $(APIPATH1)zapi.h $(APIPATH1)vapi.h \
              $(APIPATH1)vcallbk.h $(APIPATH1)example.h \
              $(APIPATH1)fapi.h  rawglobl.h \
              raw.h rawvoice.h rawsdio.h rawerr.h rawclas1.h
# set cl=$(CFLAGS) 
  cl $(CFLAGS)  $(APIPATH1)example2.c
  set cl=

$(OB)example4.obj: $(APIPATH1)example4.c $(APIPATH1)zapi.h $(APIPATH1)vapi.h \
              $(APIPATH1)vcallbk.h $(APIPATH1)example.h \
              $(APIPATH1)fapi.h  rawglobl.h \
              raw.h rawvoice.h rawsdio.h rawerr.h rawclas1.h
# set cl=$(CFLAGS) 
  cl $(CFLAGS)  $(APIPATH1)example4.c
  set cl=

# ---------------------------------------------------------------------------
# Compilation of Windows resource file:
# ---------------------------------------------------------------------------
rawv.res: rawv.rc raw.h rawerr.rc rawerr.h logenv.dlg xmitlist.dlg cancel.dlg \
         receive.dlg faxmodem.dlg asciform.dlg openfile.dlg savefile.dlg

# ---------------------------------------------------------------------------
# Application (Windows test harness) object module library:
# ---------------------------------------------------------------------------
$(APPLIB).lib: $(OBJSW1) $(OBJSW2) $(OBJSW3) $(OBJSV1) $(OBJSV2)
  @if exist $(APPLIB).lib del $(APPLIB).lib
  lib $(APPLIB).lib;

  @echo $(APPLIB).lib                                              > $(APPLIB).LNK
  @echo +$(OB)rawtutl1 +$(OB)rawdlg1 &                             >> $(APPLIB).LNK
  @echo +$(OB)rawdlg2 +$(OB)rawdlg3 +$(OB)rawdlg4 +$(OB)rawcnfio & >> $(APPLIB).LNK
  @echo +$(OB)rawio +$(OB)rawdtapp +$(OB)rawerr +$(OB)example1 &   >> $(APPLIB).LNK
  @echo +$(OB)example2 +$(OB)example4 +$(OB)vcallbke               >> $(APPLIB).LNK
  @echo $(APPLIB).lst;                                             >> $(APPLIB).LNK

  lib @$(APPLIB).lnk
#  @echo +rawappmn +rawvoimn +rawtutl1 +rawdlg1 &         >> $(APPLIB).LNK
#  @echo +rawdlg2 +rawdlg3 +rawdlg4 +rawcnfio   &         >> $(APPLIB).LNK
#  @echo +example4 +umain +vcallbk +vcallbke              >> $(APPLIB).LNK

# ===========================================================================
# Top Level Target:
# ===========================================================================
$(DESTFILE).exe: $(OB)rawmain.obj $(LINKLIBS) rawv.res rawv.def
  @echo $(LFLAGS) +                                      >  $(LINKFILE)
  @echo $(OB)rawmain.obj,                                >> $(LINKFILE)
  @echo $(DESTFILE).exe, $(DESTFILE).map                 >> $(LINKFILE)
  @echo $(LINKLIBS) +                                    >> $(LINKFILE)
  @echo $(SYSLIBS1) +                                    >> $(LINKFILE)
  @echo $(SYSLIBS2), rawv.def                             >> $(LINKFILE)

  @echo . 
  link @$(LINKFILE)
  rc rawv.res $(DESTFILE).exe



