// --------------------------------------------------------------------------
// This header file resolves the DOS and Windows compatibility of the 
// manifest constants used by the functions demonstrating VAPI 
// functionality.
// --------------------------------------------------------------------------
#if defined( VF_DOS )
  typedef int	          BOOL;
  typedef unsigned char	BYTE;
  typedef unsigned int	WORD;
  typedef unsigned long	DWORD;
  typedef char near	    *PSTR;
  typedef char near	    *NPSTR;
  typedef char far	    *LPSTR;
  typedef BYTE near	    *PBYTE;
  typedef BYTE far	    *LPBYTE;
  typedef int near	    *PINT;
  typedef int far 	    *LPINT;
  typedef WORD near	    *PWORD;
  typedef WORD far	    *LPWORD;
  typedef long near	    *PLONG;
  typedef long far	    *LPLONG;
  typedef DWORD near	  *PDWORD;
  typedef DWORD far	    *LPDWORD;
  typedef void far	    *LPVOID;
  typedef void near     *PVOID;

  #define PASCAL pascal
  #define FAR		 far
  #define NEAR   near
  #define LONG   long
  #define VOID   void

  #define LOWORD(l) ((WORD)(l))
  #define HIWORD(l) ((WORD)(((DWORD)(l)>>16)&0xFFFF))
  #define LOBYTE(w) ((BYTE)(w))
  #define HIBYTE(w) ((BYTE)(((WORD)(w)>>8)&0xFF))

  #include "apisess.h"
  #include "apidos.h"
#endif // ( VF_DOS )

#define GOTOVCON   0
#define GOTOONHOOK 1

typedef enum VoiceStatesTag
{
  VOICE_REST,
  VOICE_TRANSACTION,
  VOICE_POLL,
  VOICE_DONE,
  VOICE_ERROR
} VOICESTATES;

// --------------------------------------------------------------------------
// Function prototypes:
// --------------------------------------------------------------------------
DWORD       VoiceInProgress( void );
VOICESTATES VoicePoll( void );
int         VoiceInit( WORD, WORD, WORD );

extern void USetLast(void);
extern int  UStateIsVCON(void);

// --------------------------------------------------------------------------
// Callback function instance thunks:
// --------------------------------------------------------------------------
typedef void (FAR PASCAL *VOIDFARBACK)();
typedef int (FAR PASCAL *INTFARBACK)();
extern RVCALLBACK lpfnGenCallBack;
