/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/*
**      Last PVCS update: $ $
*/

/*
**      TITLE:   VAPI.H     
**
**      FACILITY:       
**
**      MODULE DESCRIPTION:
**
**      
**
*/

/*
**
**      Revision History:
**
**              $Log:   C:/api_lib/vapi.h_v  $
   
      Rev 1.1   30 Sep 1992 10:43:20   Robert Chen
   
      Rev 1.0   12 Aug 1992 20:07:30   Robert Chen
   Initial revision.
   
***************************************************************************/

//
// Voice Definition
//
enum CALL_BACK_ID
   {
      RV_CB_TONE_IDLE,
      RV_CB_TONE_TX,
      RV_CB_TONE_RX,
      RV_CB_TONE_CD,
      RV_CB_VPS,
      RV_CB_VTD,
      RV_CB_CMID,
      RV_CB_VCI,
      RV_CB_VLA,
      RV_CB_BDR,
      RV_CB_VCF,
      RV_CB_LOCK_MEM,
      RV_CB_UNLOCK_MEM
   };

struct VPS
	{
		int	BPS;
		long 	SampleRate;
		int	SilenceSensitivity;
		int	SilenceDeletion;
		int	SilenceDetectPeriod;
		int	VoiceLine;
	};

struct VTD
	{
		int	TxTD;
		int	RxTD;
		int	IdleTD;
	};

struct VCI
	{
	unsigned int	BPS;	
	unsigned long 	SampleRateLow;
	unsigned long 	SampleRateHigh;
	unsigned int	SilenceSensitivityLow;
	unsigned int	SilenceSensitivityHigh;
	struct VTD 		ToneDetectionCaps;
	};

struct VFC
   {
      int ValidFileFlag;
      int BPS;
      long SampleRate;
      int SilenceDeletion;
      int VoiceFileNameIndex;
      char far *CMIdString;
      int CMIdIndex;
   };


typedef void ( FAR PASCAL *RVCALLBACK )( int id, long Parm);

/*
** Voice WatchDog Timer Limits
*/
enum rvwdde
	{
	RV_WD_INIT,
	RV_WD_AT_RESPONSE,
   RV_WD_EOS_VCON_WAIT,
   RV_WD_VCON_GUARD_TIME,
   RV_WD_DUMMY
	};

#define RV_WD_NUM (RV_WD_DUMMY+1)

/*
** Line Error Control structure
*/
/*
** =======================================================================
**
** Function Prototypes for Interfacing between VAPI and Developer's
** Application
**
** =======================================================================
*/

extern void FAR PASCAL
	RVOpen(unsigned char far *InitString, 
         RVCALLBACK lpfnRVCallBack);

extern void FAR PASCAL
	RVClose(void);

extern int FAR PASCAL 
	RVSetVMBaudRate(	int Mode, 
							int Baudrate);

extern int FAR PASCAL 
	RVGetCurrentSetting(void);

extern int FAR PASCAL 
	RVGetBPSRange(void);

extern int FAR PASCAL 
	RVGetCMIdRange(void);

extern int FAR PASCAL 
	RVGetVLRange(void);

extern int FAR PASCAL 
	RVSetCurrentSetting( struct VPS far *VoiceParmSetting,	
								struct VTD far *ToneDetectionMask,
								int BaudRate);
	
extern int FAR PASCAL 
	RVSetCurrentMode(	unsigned int Mode,
							struct VCI far *VoiceCapsInfo,
							unsigned int VCINumber);
							
	
extern int FAR PASCAL 
	RVDial( unsigned char far *DialString);

extern int FAR PASCAL 
	RVPlayTone( unsigned char far *ToneString);

extern int FAR PASCAL 
	RVAnswer(	unsigned int WaitLimit,
					int DCEMode,
					int BaudRate);

extern int FAR PASCAL 
	RVCheckVoiceFiles( unsigned char far *VoiceFiles[],
							 unsigned char far *CMIdStrings[],	
							 unsigned int CMIdSize,	
							 struct VCI far *VoiceCapsInfo,	
							 unsigned int VCINumber);	
								

extern int FAR PASCAL 
   RVAnswerCD(unsigned int WaitLimit,
                struct VTD far *ToneDetectionMask,
                int DCEMode,
                int BaudRate,
                int MaxMsg,
                struct    VPS far *VoiceParmSetting,
                unsigned char far *CMIdString,
                unsigned char far *VoiceFileName,
                unsigned char far *InitialOGM,
                unsigned char far *ReservedPtr1,
                unsigned char far *ReservedPtr2
                );

extern int FAR PASCAL 
	RVPlayFile(	struct VTD far *ToneDetectionMask,
					unsigned char far *VoiceFileName);
					

extern int FAR PASCAL 
	RVPlayBuffer(	struct VPS far *VoiceParmSetting,
						struct VTD far *ToneDetectionMask,
						long Handle,
						unsigned long BufferLength);

extern int FAR PASCAL 
	RVRecordFile(	struct VPS far *VoiceParmSetting,
						struct VTD far *ToneDetectionMask,
						unsigned char far *CMIdString,
						unsigned char far *VoiceFileName);

extern int FAR PASCAL 
	RVRecordBuffer(	struct VPS far *VoiceParmSetting,
							struct VTD far *ToneDetectionMask,
							long Handle,
							unsigned long BufferLength);

extern void FAR PASCAL 
	RVPoll(void);

extern enum VAPIErrCodes FAR PASCAL 
	RVStatus(void);

extern int FAR PASCAL 
	RVStopVoiceIO(int);

extern int FAR PASCAL 
   RVDataFax(void);

extern void FAR PASCAL
  RVSetProc( RVCALLBACK );

extern void FAR PASCAL 
   RVWDControl(int set, unsigned int far *wd);

extern void FAR PASCAL RVUpdateTimers
   (unsigned int duration);

extern int FAR PASCAL 
   RVinProgress(void);

extern void FAR PASCAL 
   RVSysAbortReq(void);

extern void FAR PASCAL 
   RVDataAnswer( void);

extern void FAR PASCAL 
	RVSendAtCmd( char far *AtCmdLine);



/*
** Voice Session routines
*/
extern int  FAR PASCAL RVCloseSess(void);
extern void FAR PASCAL RVPollSysTimerInit(void);
extern void FAR PASCAL RVPollSysTimer(void);
extern  int FAR PASCAL RVOpenSess(unsigned int id, long param);
extern  int FAR PASCAL RVCloseSess(void);


/*
** Voice Session display routines
*/
extern void FAR PASCAL RVShowTxAT(unsigned char far *s);
extern void FAR PASCAL RVShowRxAT(unsigned char far *s);
extern void FAR PASCAL RVEndTransReport(int code,
                                        int line, 
                                        unsigned char far *fn,
                                        int userabort);

extern void FAR PASCAL RVWarnReport(int code, 
                                    int line, 
                                    unsigned char far *fn);

extern int FAR PASCAL RVSendDLE( unsigned char DLECode );

extern int FAR PASCAL RVSetExtData( unsigned int  wComPort, 
                                             long lpExtData );

extern long FAR PASCAL RVGetExtData( void );

/*
** VAPI Error Codes
*/
enum VAPIErrCodes
	{
	RV_STATUS_NONE=0,					    /* No status */
	RV_STATUS_DONE,			
	RV_STATUS_DONE_CD_PLAY,			
	RV_STATUS_DONE_CD_RECORD,			
	RV_STATUS_DATA,
	RV_STATUS_FAX,
	RV_STATUS_TIMEOUT,

	/*
	** Others
	*/
   RV_ERR_GEN_MARKER=-32767,
	RV_ERR_GEN_WRONG_TOKEN,           /* Unexpected modem token */
	RV_ERR_GEN_NO_RESPONSE,			    /* No reponse from the modem */
	RV_ERR_GEN_NO_SUCH_FILE,
	RV_ERR_GEN_NOT_A_RIFF_FILE,
	RV_ERR_GEN_NOCARR,				    /* No carrier detect */
	RV_ERR_GEN_SYS_ABORT,			    /* User abort before data transfer */
	RV_ERR_GEN_INTERNAL,
	RV_ERR_INV_BPS,
	RV_ERR_INV_SAMPLE_RATE,
	RV_ERR_INV_SILENCE_SENSITIVITY,
	RV_ERR_INV_SILENCE_DETECT_PER,
	RV_ERR_INV_SILENCE_DELETION,
	RV_ERR_INV_VOICE_LINE,
	RV_ERR_INV_TONE_DETECTION,
	RV_ERR_INV_BAUDRATE,
	RV_ERR_INV_PARAM,
	RV_ERR_INV_CLASS,		  
   RV_ERR_RX_SYS_ABORT,

	/*
	** Developer's Error Codes
	*/
   RV_ERR_DEV_MARKER=-28671,
	RV_ERR_DEV_INV_IRQ_BUF,	         /*	Developer's use - Irq buffer */
	RV_ERR_DEV_INV_COM_ID,				/* Invalid COM id, 0..(MAX_COM_ID-1) */

	/*
	** Add on errors
	*/
   RV_SPARE_MARKER=-24575,
	RV_SPARE      				         /* Start of spare errors */
	};


