/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:  11-14-91
**	Last PVCS update: $Date:   29 Sep 1992 19:58:34  $
*/

/*
**	TITLE:		VAPIDSPLY.C
**
**	
**
**	MODULE DESCRIPTION:
**
** DOS test harness for the API.
**
*/

/*
**
**	Revision History:
**
**		$Log:   C:/api_lib/vapidspl.c_v  $
 * 
 *    Rev 1.1   29 Sep 1992 19:58:34   Robert Chen
 * 
 *    Rev 1.0   12 Aug 1992 20:00:32   Robert Chen
 * Initial revision.
 * 
 *    Rev 1.0   15 Jun 1992 10:56:58   Robert Chen
 *  
 * 
*/

/*
** =======================================================================
**
** Libraries
**
** =======================================================================
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys\types.h>
#include <sys\timeb.h>

/*
** General API defines
*/

#include "zapidos.h"



/*
** T30/T4 API defines
*/
#include "vapi.h"

/*
** Session defines
*/

/*
** =======================================================================
**
** Defines
**
** =======================================================================
*/

/*
** =======================================================================
**
** Variables
**
** =======================================================================
*/

char  *RV_ERR_CODE_STRING[] = 
{
	"RV_STATUS_NONE",					    
	"RV_STATUS_DONE",			
	"RV_STATUS_DATA",
	"RV_STATUS_FAX",
	"RV_STATUS_TIMEOUT",
   "RV_ERR_GEN_MARKER",
	"RV_ERR_GEN_WRONG_TOKEN",           
	"RV_ERR_GEN_NO_RESPONSE",			    
	"RV_ERR_GEN_NO_SUCH_FILE",
	"RV_ERR_GEN_NOT_A_RIFF_FILE",
	"RV_ERR_GEN_NOCARR",				    
	"RV_ERR_GEN_SYS_ABORT",			    
	"RV_ERR_GEN_INTERNAL",
	"RV_ERR_INV_BPS",
	"RV_ERR_INV_SAMPLE_RATE",
	"RV_ERR_INV_SILENCE_SENSITIVITY",
	"RV_ERR_INV_SILENCE_DETECT_PER",
	"RV_ERR_INV_SILENCE_DELETION",
	"RV_ERR_INV_VOICE_LINE",
	"RV_ERR_INV_TONE_DETECTION",
	"RV_ERR_INV_BAUDRATE",
	"RV_ERR_INV_PARAM",
	"RV_ERR_INV_CLASS",		  
   "RV_ERR_RX_SYS_ABORT",
   "RV_ERR_DEV_MARKER",
	"RV_ERR_DEV_INV_IRQ_BUF",	         
	"RV_ERR_DEV_INV_COM_ID",				
   "RV_SPARE_MARKER",
	"RV_SPARE",
   ""   				         
};

/*
** =======================================================================
**
** RVShowTxAT() -
** 	Print out AT commends send to modem
**
** =======================================================================
*/
void FAR PASCAL RVShowTxAT(unsigned char far *s)
{
		printf("Tx: %s\n",s);
}

/*
** =======================================================================
**
** RVShowRxAT() -
** 	Print out AT commends received by the modem
**
** =======================================================================
*/
void FAR PASCAL RVShowRxAT(unsigned char far *s)

{
		printf("Rx: %s\n",s);
}

/*
** =======================================================================
**
** RVEndTransReport() -
** 	Report transaction end, callback from API.
**
** =======================================================================
*/
void FAR PASCAL RVEndTransReport(int code,
                                 int line, 
                                 unsigned char far *fn,
                                 int userabort)
{
   static int SearchIndexDone = 0;
   static int ErrGenMarker;
   static int ErrDevMarker;
   static int SpareMarker;
   static int ErrIndex;

   if (!SearchIndexDone)
   {
      for (ErrIndex=0; RV_ERR_CODE_STRING[ErrIndex][0] != 0; ErrIndex++)
         {
            if (strcmp("RV_ERR_GEN_MARKER", RV_ERR_CODE_STRING[ErrIndex]) == 0)
               ErrGenMarker = ErrIndex;
            if (strcmp("RV_ERR_DEV_MARKER", RV_ERR_CODE_STRING[ErrIndex]) == 0)
               ErrDevMarker = ErrIndex;
            if (strcmp("RV_SAPRE_MARKER", RV_ERR_CODE_STRING[ErrIndex]) == 0)
               SpareMarker = ErrIndex;
         }
         SearchIndexDone = 1;
   }

   if (code>=0)
      ErrIndex = code;
   else if (code >= RV_SPARE_MARKER)
      ErrIndex = code - RV_SPARE_MARKER + SpareMarker;
   else if (code >= RV_ERR_DEV_MARKER)
      ErrIndex = code - RV_ERR_DEV_MARKER + ErrDevMarker;
   else if (code >= RV_ERR_GEN_MARKER)
      ErrIndex = code - RV_ERR_GEN_MARKER + ErrGenMarker;

 	printf("\nEnd Transaction: %s at line %u, file %s",
		RV_ERR_CODE_STRING[ErrIndex],line,fn);
	if (userabort)
		printf(" (User abort)");
	printf("\n");
}

/*
** =======================================================================
**
** RVWarnReport() -
** 	Report Warning messages only, callback from API.
**
** =======================================================================
*/
void FAR PASCAL RVWarnReport(int code, int line, unsigned char far *fn)
{

   static int SearchIndexDone = 0;
   static int ErrGenMarker;
   static int ErrDevMarker;
   static int SpareMarker;
   static int ErrIndex;

   if (!SearchIndexDone)
   {
      for (ErrIndex=0; RV_ERR_CODE_STRING[ErrIndex][0] != 0; ErrIndex++)
         {
            if (strcmp("RV_ERR_GEN_MARKER", RV_ERR_CODE_STRING[ErrIndex]) == 0)
               ErrGenMarker = ErrIndex;
            if (strcmp("RV_ERR_DEV_MARKER", RV_ERR_CODE_STRING[ErrIndex]) == 0)
               ErrDevMarker = ErrIndex;
            if (strcmp("RV_SAPRE_MARKER", RV_ERR_CODE_STRING[ErrIndex]) == 0)
               SpareMarker = ErrIndex;
         }
         SearchIndexDone = 1;
   }

   if (code>=0)
      ErrIndex = code;
   else if (code >= RV_SPARE_MARKER)
      ErrIndex = code - RV_SPARE_MARKER + SpareMarker;
   else if (code >= RV_ERR_DEV_MARKER)
      ErrIndex = code - RV_ERR_DEV_MARKER + ErrDevMarker;
   else if (code >= RV_ERR_GEN_MARKER)
      ErrIndex = code - RV_ERR_GEN_MARKER + ErrGenMarker;
  
	printf("Warning: %s at line %u, file %s\n",
		RV_ERR_CODE_STRING[ErrIndex],line,fn);

}

