/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/*
** Last update:  11-14-91
**      Last PVCS update: $Date:   12 Aug 1992 20:00:38  $
*/

/*
**      TITLE:          APISESS.C
**
**      FACILITY:       T30/T4 API
**
**      MODULE DESCRIPTION:
**
** DOS test harness for the API.
**
*/

/*
**
**      Revision History:
**
**              $Log:   D:/api_lib/vapisess.c_v  $
 * 
 *    Rev 1.0   12 Aug 1992 20:00:38   Robert Chen
 * Initial revision.
 * 
 *    Rev 1.0   15 Jun 1992 11:20:06   Robert Chen
 *  
 * 
 *    Rev 1.0   26 May 1992 11:18:54   Robert Chen
 * Initial revision.
 *
 *    Rev 1.1   02 Mar 1992 17:45:18   Robert Chen
 *
 *
 *
 *    Rev 1.1   24 Jan 1992 17:12:14   Robert Chen
 * Working Version on Fri 24 Jan 92.
 * Detects DTMF on while recording message and pad <DEL>s
 *
 *
 *    Rev 1.0   07 Jan 1992 10:04:38   unknown
 * Initial revision.
**
**    Rev 1.5   17 Oct 1991 10:37:04   JIM
** Global update of T.30/T.4 API source for version 1.00.
**
**    Rev 1.4   12 Sep 1991 11:14:16   JIM
** Global update of T.30/T.4 API source for version 0.22B.
**
**    Rev 1.3   13 Aug 1991 17:24:28   JIM
** Correction of API source check in to include new fax file source.
**
**    Rev 1.2   08 Aug 1991 18:43:14   JIM
** Update to facilitate single session DLL version of API.
**
**
*/

/*
** =======================================================================
**
** Libraries
**
** =======================================================================
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys\types.h>
#include <sys\timeb.h>

/*
** General API defines
*/



#include "zapidos.h"


#include "vapi.h"
#include "zapi.h"

/*
** Session defines
*/
// #include "vapisess.h"

/*
** =======================================================================
**
** Defines
**
** =======================================================================
*/

/*
** Irq Buffer Size
*/
#define IRQ_BUF_SIZE 4096

/*
** =======================================================================
**
** Variables
**
** =======================================================================
*/
/*
** System Timer Notes.
*/
static struct timeb TimeStart,TimeEnd;

/*
** Interrrupt buffer size
*/
static unsigned char RZIrqBuffer[IRQ_BUF_SIZE];

/*
** =======================================================================
**
** RVPollSysTimerInit() -
**      Init API Timers from the System time
**
** =======================================================================
*/
void FAR PASCAL RVPollSysTimerInit()
{
     ftime(&TimeStart);
}

/*
** =======================================================================
**
** RVPollSysTimer() -
**      Update API Timers from the System time
**
** =======================================================================
*/
void FAR PASCAL RVPollSysTimer()
{
     static strobe= 0;
     long delta;

     /*
      ** Calling DOS is time consuming.  Tolerate a little
      ** inaccuracy in the timers for better performance.
      */
     if (++strobe & 0x7)
          return;

     ftime(&TimeEnd);
     delta=
     1000*(TimeEnd.time-TimeStart.time) +
     TimeEnd.millitm-TimeStart.millitm;
     RVUpdateTimers((unsigned short)delta);
     TimeStart=TimeEnd;
}

/*
** =======================================================================
**
** RVOpenSess() -
**      Initailize API Context.
**
** =======================================================================
*/
int FAR PASCAL RVOpenSess(id,param)
unsigned int id;
long param;
{
     static unsigned int wd[RV_WD_NUM];

     RZAssignIrq(id,RZIrqBuffer,IRQ_BUF_SIZE);

     /*
      ** Initialize Developer's XON/XOFF flag
      */
     RZDisXonXoff();

     /*
      ** Initialize Developer's CTS flow control flag
      */
     RZDisCTS();

     RVWDControl(0,wd);                    // Get the default values           
     wd[RV_WD_AT_RESPONSE]=1000;           // Wait 1.5 sec for AT response     
     wd[RV_WD_INIT]=2000;                  
     RVWDControl(1,wd);                    // Set new values                   

     return RV_STATUS_NONE;
}

/*
** =======================================================================
**
** RVCloseSess() -
**      Shutdown API Session
**
** =======================================================================
*/
int FAR PASCAL RVCloseSess()
{
     return RV_STATUS_NONE;
}


