/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/*
** Last update:
**      Last PVCS update: $Date:   29 Sep 1992 19:59:14  $
*/

/*
**      TITLE:          VCALLBKE.C
**
**      FACILITY:
**
**      MODULE DESCRIPTION:
**      Example code of the Call Back function and
**      developer functions called the VAPI
**
**
*/

/*
**
**      Revision History:
**
**
*/
#if defined( VF_SWIN ) || defined( VF_MWIN )
  #include <windows.h>
#else
  #define LPSTR char far *
#endif

#define DEBUG

#include <string.h>
#include <graph.h>
#include <stdio.h>



#include "vapi.h"
#include "zapi.h"
#include "example.h"

#if defined( VF_SWIN ) || defined( VF_MWIN )
  #include "rawglobl.h"
  #include "rawsdio.h"
  #include "rawvoice.h"
  #ifdef DEBUG
     #define VCBprintf wprintf
  #else
     #define VCBprintf //
  #endif
#else
  #ifdef DEBUG
     #define VCBprintf printf
  #else
     #define VCBprintf //
  #endif
#endif

int FAR PASCAL RVCallBack( int ID, long Parm)
{
   switch (ID)
   {
      case RV_CB_TONE_IDLE:
           VCBprintf("Enter RV_CB_TONE_IDLE CallBack\n");
           VCBprintf("   Tone %c\n", Parm);
           USR.ToneDetected = (char) Parm;
         return(0);

      case RV_CB_TONE_TX:
           VCBprintf("Enter RV_CB_TONE_TX CallBack\n");
           VCBprintf("   Tone %c\n", (LPSTR)Parm);
           USR.ToneDetected = (char) Parm;
         return(0);

      case RV_CB_TONE_RX:
           VCBprintf("Enter RV_CB_TONE_RX CallBack\n");
           VCBprintf("   Tone %c\n", (LPSTR)Parm);
           USR.ToneDetected = (char) Parm;
         return(0);

      case RV_CB_TONE_CD:
           VCBprintf("Enter RV_CB_TONE_CD CallBack\n");
           VCBprintf("   Tone %c\n", (LPSTR)Parm);
           USR.ToneDetected = (char) Parm;
         return(0);

      case RV_CB_VPS:
         VCBprintf("Enter RV_CB_VPS CallBack\n");
         VCBprintf("   BPS                 %d\n", ((struct VPS far *) Parm)->BPS);
         VCBprintf("   SampleRate          %d\n", ((struct VPS far *) Parm)->SampleRate);          
         VCBprintf("   SilenceSensitivity  %d\n", ((struct VPS far *) Parm)->SilenceSensitivity);
         VCBprintf("   SilenceDeletion     %d\n", ((struct VPS far *) Parm)->SilenceDeletion);
         VCBprintf("   SilenceDetectPeriod %d\n", ((struct VPS far *) Parm)->SilenceDetectPeriod);
         VCBprintf("   VoiceLine           %d\n", ((struct VPS far *) Parm)->VoiceLine);

        if (Parm)
            // _fmemcpy(&USR.VoiceParmInfo, (struct VPS *) Parm, sizeof(struct VPS));
            _fmemcpy(&USR.VoiceParmInfo, (void far *) Parm, sizeof(struct VPS));
         return(0);

      case RV_CB_VTD:
         VCBprintf("Enter RV_CB_VTD CallBack\n");
         VCBprintf("   TxTD          %x\n", ((struct VTD far *) Parm)->TxTD  );
         VCBprintf("   RxTD          %x\n", ((struct VTD far *) Parm)->RxTD  );
         VCBprintf("   IdleTD        %x\n", ((struct VTD far *) Parm)->IdleTD);

        if (Parm)
            // _fmemcpy(&USR.ToneDetectionInfo, (struct VTD *) Parm, sizeof(struct VTD));
            _fmemcpy(&USR.ToneDetectionInfo, (void far *) Parm, sizeof(struct VTD));

         return(0);

      case RV_CB_CMID:
         VCBprintf("Enter CMID CallBack\n");
         VCBprintf("CMID string %s\n", (char far *)  Parm);
         if (Parm)
            _fstrcpy(USR.CMIdString, (char far *) Parm); 
         return(0);

      case RV_CB_VCI:
         VCBprintf("Enter RV_CB_VCI CallBack\n");
         VCBprintf("   BPS                     %d\n", ((struct VCI far *) Parm)->BPS);
         VCBprintf("   SampleRateLow           %d\n", ((struct VCI far *) Parm)->SampleRateLow);          
         VCBprintf("   SampleRateHigh          %d\n", ((struct VCI far *) Parm)->SampleRateHigh);          
         VCBprintf("   SilenceSensitivityLow   %d\n", ((struct VCI far *) Parm)->SilenceSensitivityLow);
         VCBprintf("   SilenceSensitivityHigh  %d\n", ((struct VCI far *) Parm)->SilenceSensitivityHigh);
         VCBprintf("   TxTD        %x\n", ((struct VCI far *) Parm)->ToneDetectionCaps.TxTD);
         VCBprintf("   RxTD        %x\n", ((struct VCI far *) Parm)->ToneDetectionCaps.RxTD);
         VCBprintf("   IdleTD     %x\n", ((struct VCI far *) Parm)->ToneDetectionCaps.IdleTD);
         return(0);

      case RV_CB_VLA:
         VCBprintf("Enter RV_CB_VLA CallBack\n");
         VCBprintf("   Voice Line Attribute %d\n", Parm);
         return(0);

      case RV_CB_BDR:
         VCBprintf("Enter RV_CB_BDR CallBack\n");
         VCBprintf("   Baud Rate %d\n", Parm);
         return(0);

      case RV_CB_VCF:
         VCBprintf("Enter RV_CB_VCF CallBack\n");
         VCBprintf("   Valid File Flag    %x\n", ((struct VFC far *) Parm)->ValidFileFlag);
         VCBprintf("   BPS                %d\n", ((struct VFC far *) Parm)->BPS);
         VCBprintf("   Sample Rate        %d\n", ((struct VFC far *) Parm)->SampleRate);
         VCBprintf("   SilencdDeletion    %d\n", ((struct VFC far *) Parm)->SilenceDeletion);
         VCBprintf("   VoiceFileNameIndex %d\n", ((struct VFC far *) Parm)->VoiceFileNameIndex);
         VCBprintf("   CMIdString         %s\n", ((struct VFC far *) Parm)->CMIdString);
         VCBprintf("   CMIdIndex          %d\n", ((struct VFC far *) Parm)->CMIdIndex);
         return(0);

      case RV_CB_LOCK_MEM:
         VCBprintf("Enter RV_CB_LOCK_MEM CallBack\n");
         return(0);

      case RV_CB_UNLOCK_MEM:
         VCBprintf("Enter RV_CB_UNLOCK_MEM CallBack\n");
         return(0);

      default:
         return(0);

   }
   return(0);
}

