/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:  
**	Last PVCS update: $Date:   12 Sep 1992 14:50:02  $
*/

/*
**	TITLE:		ZAPI.H
**
**	FACILITY:	
**
**	MODULE DESCRIPTION:
**
** Public portion of the general system wide defines.
**
*/

/*
**
**	Revision History:
**
**		$Log:   D:/api_lib/zapi.h_v  $
   
      Rev 1.1   12 Sep 1992 14:50:02   Robert Chen
   
      Rev 1.0   12 Aug 1992 20:07:54   Robert Chen
   Initial revision.
   
      Rev 1.0   26 May 1992 11:20:00   Robert Chen
   Initial revision.
** 
*/

/*
** =======================================================================
**
** Defines and Types
**
** =======================================================================
*/
#define TRUE	1
#define FALSE 	0
/*
** =======================================================================
**
** Function Prototypes for Interfacing between API and Developer's
** Application
**
** =======================================================================
*/
extern void FAR PASCAL
	RZFlushRxComm(void);
extern void FAR PASCAL
	RZFlushTxComm(void);


/*
** =======================================================================
**
** Function Prototypes provided by the Application Developer
**
** =======================================================================
*/
extern int FAR PASCAL
	RZBaud38400(void);
extern int FAR PASCAL
	RZBaud19200(void);
extern int FAR PASCAL
	RZBaud2400(void);
extern int FAR PASCAL
	RZOpenCom(void);
extern int FAR PASCAL
	RZCloseCom(void);
extern int FAR PASCAL
	RZComRxDataAvail(void);
extern int FAR PASCAL
	RZComTxBufEmpty(void);
extern int FAR PASCAL
	RZComTxBufRoom(void);
extern void FAR PASCAL
	RZDisXonXoff(void);
extern void FAR PASCAL
	RZDisCTS(void);
extern void FAR PASCAL
	RZEnaCTS(void);
extern void FAR PASCAL
	RZEnaXonXoff(int datamode);
extern void FAR PASCAL
	RZEndHighSpeed(void);
extern void FAR PASCAL
	RZFifoPresent(void);
extern unsigned char far * FAR PASCAL
	RZLockMemTxBuffer(unsigned int handle);
extern void FAR PASCAL
	RZReleaseMemTxBuffer(unsigned int handle);
extern int FAR PASCAL
	RZReadCom(unsigned char far *buffer,int size);
extern void FAR PASCAL
	RZStartRxHighSpeed(void);
extern void FAR PASCAL
	RZStartTxHighSpeed(void);
extern int FAR PASCAL
	RZWriteCom(unsigned char far *buffer,int size);
extern void FAR PASCAL
	RZAssignIrq(unsigned int id,unsigned char *p,unsigned int size);
extern unsigned int PASCAL
	RZRetIrqId(void);
extern int FAR PASCAL
	RZOpenCom(void);
extern int FAR PASCAL
	RZCloseCom(void);
extern int FAR PASCAL 
  RZSetExtData( unsigned int  wComPort, long lpExtData );
extern long FAR PASCAL 
  RZGetExtData( void );

/*
** Maximum Telephone Number accepted
*/
#define TELE_BUF_SIZE 60

/*
** Maximum Tx File Path
*/
#define FILE_PATH_SIZE 100

/*
** This API assumes the AT command size buffer on the modem is no
** greater than AT_BUF_SIZE
*/
#define AT_BUF_SIZE 30

/*
** Additional User Init String; do precede with AT
*/
#define USERINIT_BUF_SIZE 50

/*
** Tx files come from which media (slower Tx speed for floppies)
*/
#define USE_MEDIA_HD 0
#define USE_MEDIA_FLOPPY 1

#define USE_MEDIA_NUM (USE_MEDIA_FLOPPY + 1)



