/*
***************************************************************************
**              ROCKWELL CONFIDENTIAL AND PROPRIETARY
**        This source is the sole property of ROCKWELL Inc.
**    Reproduction or utilization of this source in whole or in 
**  part is forbidden without the written consent of ROCKWELL Inc.
***************************************************************************
**                 (c) Copyright ROCKWELL, INC. 1991
**                       All Rights Reserved
***************************************************************************
*/

/* 
** Last update:   7-17-91
**	Last PVCS update: $Date:   15 Aug 1992 21:57:12  $ 
*/

/*
**	TITLE:		ZAPIDOS.H
**
**	FACILITY:	T30/T4 API
**
**	MODULE DESCRIPTION:
**
** Public defines for disk usage.
**
*/

/*
**
**	Revision History:
**
**		$Log:   D:/api_lib/zapidos.h_v  $
   
      Rev 1.1   15 Aug 1992 21:57:12   Robert Chen
   
      Rev 1.0   12 Aug 1992 20:08:04   Robert Chen
   Initial revision.
** 
**    Rev 1.12   29 Apr 1992 16:30:24   JIM
** Global update of T.30/T.4 API (FAPI) source for version 1.03.
** 
**    Rev 1.9   17 Oct 1991 10:39:18   JIM
** Global update of T.30/T.4 API source for version 1.00.
** 
**    Rev 1.8   12 Sep 1991 11:16:30   JIM
** Global update of T.30/T.4 API source for version 0.22B.
** 
**    Rev 1.7   13 Aug 1991 17:26:32   JIM
** Correction of API source check in to include new fax file source.
** 
**    Rev 1.6   09 Aug 1991 13:04:32   JIM
** Update to facilitate single session DLL version of API.
** 
**    Rev 1.0   11 Apr 1991 15:05:18   STAN
** Initial revision.
** 
*/

/*
** =======================================================================
**
** Defines and Types
**
** =======================================================================
*/

/*
** RZDOSOpen() options
*/
#define ORF_RDONLY 0
#define ORF_WRONLY 1
#define ORF_RDWR 2

/*
** RZDOSSeek() options
*/
#define SEEKRF_SET 0
#define SEEKRF_CUR 1
#define SEEKRF_END 2

extern int RZerrnum;		/* File error code */
/*
** =======================================================================
**
** Function Prototypes provided by the Application
**
** =======================================================================
*/
#if defined( VF_SWIN ) || defined( VF_MWIN )

extern int FAR PASCAL RZDOSOpen(unsigned char far *path,int method);
extern int FAR PASCAL RZDOSCreate(unsigned char far *path);
extern int FAR PASCAL RZDOSDelete(unsigned char far *path);
extern int FAR PASCAL RZDOSClose(int handle);
extern int FAR PASCAL RZDOSRead(int handle,unsigned char far *buffer,
	                             unsigned int count);
extern int FAR PASCAL RZDOSWrite(int handle,unsigned char far *buffer,
	                               unsigned int count);
extern long FAR PASCAL RZDOSSeek(int handle,long foffset,int method);
#else
extern int RZDOSOpen(unsigned char far *path,int method);
extern int RZDOSCreate(unsigned char far *path);
extern int RZDOSDelete(unsigned char far *path);
extern int RZDOSClose(int handle);
extern int RZDOSRead(int handle,unsigned char far *buffer,
         	unsigned int count);
extern int RZDOSWrite(int handle,unsigned char far *buffer,
	         unsigned int count);
extern long RZDOSSeek(int handle,long foffset,int method);
#endif
